/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*116 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 23|128,7/*919*/, TARGET_VAL(ISD::STORE),// ->2982
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 16|128,5/*656*/, /*->2981*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 10 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 44, /*->2980*/
/*  2936*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/*  2939*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2940*/    OPC_Scope, 18, /*->2960*/ // 2 children in Scope
/*  2942*/     OPC_CheckChild2TypeI32,
/*  2943*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2944*/     OPC_CheckPredicate5,  // Predicate_store
/*  2945*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2946*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2948*/     OPC_EmitMergeInputChains1_0,
/*  2949*/     OPC_EmitInteger32, 0, 
/*  2951*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2960*/    /*Scope*/ 18, /*->2979*/
/*  2961*/     OPC_CheckChild2TypeI64,
/*  2962*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2963*/     OPC_CheckPredicate5,  // Predicate_store
/*  2964*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2965*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2967*/     OPC_EmitMergeInputChains1_0,
/*  2968*/     OPC_EmitInteger32, 0, 
/*  2970*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2979*/    0, /*End of Scope*/
/*  2980*/   0, /*End of Scope*/
/*  2981*/  0, /*End of Scope*/
/*  2982*/ /*SwitchOpcode*/ 22|128,2/*278*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3264
/*  2986*/  OPC_Scope, 40, /*->3028*/ // 3 children in Scope
/*  2988*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  2989*/   OPC_CheckChild1Integer, 114|128,67|128,1/*25074*/, 
/*  2993*/   OPC_MoveChild2,
/*  2994*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  2997*/   OPC_RecordChild0, // #1 = $table1
/*  2998*/   OPC_MoveChild0,
/*  2999*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3002*/   OPC_MoveParent,
/*  3003*/   OPC_MoveSibling3,
/*  3004*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3007*/   OPC_RecordChild0, // #2 = $table2
/*  3008*/   OPC_MoveChild0,
/*  3009*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3012*/   OPC_MoveParent,
/*  3013*/   OPC_MoveParent,
/*  3014*/   OPC_RecordChild4, // #3 = $d
/*  3015*/   OPC_RecordChild5, // #4 = $s
/*  3016*/   OPC_RecordChild6, // #5 = $n
/*  3017*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3018*/   OPC_EmitMergeInputChains1_0,
/*  3019*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12537:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3028*/  /*Scope*/ 44, /*->3073*/
/*  3029*/   OPC_RecordMemRef,
/*  3030*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3031*/   OPC_CheckChild1Integer, 106|128,67|128,1/*25066*/, 
/*  3035*/   OPC_RecordChild2, // #1 = $val
/*  3036*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3037*/   OPC_Scope, 16, /*->3055*/ // 2 children in Scope
/*  3039*/    OPC_CheckChild3TypeI32,
/*  3040*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3041*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3043*/    OPC_EmitMergeInputChains1_0,
/*  3044*/    OPC_EmitInteger32, 0, 
/*  3046*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12533:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3055*/   /*Scope*/ 16, /*->3072*/
/*  3056*/    OPC_CheckChild3TypeI64,
/*  3057*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3058*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3060*/    OPC_EmitMergeInputChains1_0,
/*  3061*/    OPC_EmitInteger32, 0, 
/*  3063*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12533:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3072*/   0, /*End of Scope*/
/*  3073*/  /*Scope*/ 60|128,1/*188*/, /*->3263*/
/*  3075*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3076*/   OPC_Scope, 26, /*->3104*/ // 7 children in Scope
/*  3078*/    OPC_CheckChild1Integer, 10|128,68|128,1/*25098*/, 
/*  3082*/    OPC_MoveChild2,
/*  3083*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3086*/    OPC_RecordChild0, // #1 = $table
/*  3087*/    OPC_MoveChild0,
/*  3088*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3091*/    OPC_MoveParent,
/*  3092*/    OPC_MoveParent,
/*  3093*/    OPC_RecordChild3, // #2 = $i
/*  3094*/    OPC_RecordChild4, // #3 = $val
/*  3095*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3096*/    OPC_EmitMergeInputChains1_0,
/*  3097*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12549:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3104*/   /*Scope*/ 28, /*->3133*/
/*  3105*/    OPC_CheckChild1Integer, 120|128,67|128,1/*25080*/, 
/*  3109*/    OPC_MoveChild2,
/*  3110*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3113*/    OPC_RecordChild0, // #1 = $table
/*  3114*/    OPC_MoveChild0,
/*  3115*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3118*/    OPC_MoveParent,
/*  3119*/    OPC_MoveParent,
/*  3120*/    OPC_RecordChild3, // #2 = $i
/*  3121*/    OPC_RecordChild4, // #3 = $val
/*  3122*/    OPC_RecordChild5, // #4 = $n
/*  3123*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3124*/    OPC_EmitMergeInputChains1_0,
/*  3125*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12540:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3133*/   /*Scope*/ 26, /*->3160*/
/*  3134*/    OPC_CheckChild1Integer, 8|128,68|128,1/*25096*/, 
/*  3138*/    OPC_MoveChild2,
/*  3139*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3142*/    OPC_RecordChild0, // #1 = $table
/*  3143*/    OPC_MoveChild0,
/*  3144*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3147*/    OPC_MoveParent,
/*  3148*/    OPC_MoveParent,
/*  3149*/    OPC_RecordChild3, // #2 = $i
/*  3150*/    OPC_RecordChild4, // #3 = $val
/*  3151*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3152*/    OPC_EmitMergeInputChains1_0,
/*  3153*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12548:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3160*/   /*Scope*/ 28, /*->3189*/
/*  3161*/    OPC_CheckChild1Integer, 118|128,67|128,1/*25078*/, 
/*  3165*/    OPC_MoveChild2,
/*  3166*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3169*/    OPC_RecordChild0, // #1 = $table
/*  3170*/    OPC_MoveChild0,
/*  3171*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3174*/    OPC_MoveParent,
/*  3175*/    OPC_MoveParent,
/*  3176*/    OPC_RecordChild3, // #2 = $i
/*  3177*/    OPC_RecordChild4, // #3 = $val
/*  3178*/    OPC_RecordChild5, // #4 = $n
/*  3179*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3180*/    OPC_EmitMergeInputChains1_0,
/*  3181*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12539:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3189*/   /*Scope*/ 27, /*->3217*/
/*  3190*/    OPC_CheckChild1Integer, 6|128,68|128,1/*25094*/, 
/*  3194*/    OPC_MoveChild2,
/*  3195*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3198*/    OPC_RecordChild0, // #1 = $table
/*  3199*/    OPC_MoveChild0,
/*  3200*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3203*/    OPC_MoveParent,
/*  3204*/    OPC_MoveParent,
/*  3205*/    OPC_RecordChild3, // #2 = $i
/*  3206*/    OPC_RecordChild4, // #3 = $val
/*  3207*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3209*/    OPC_EmitMergeInputChains1_0,
/*  3210*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12547:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3217*/   /*Scope*/ 29, /*->3247*/
/*  3218*/    OPC_CheckChild1Integer, 116|128,67|128,1/*25076*/, 
/*  3222*/    OPC_MoveChild2,
/*  3223*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3226*/    OPC_RecordChild0, // #1 = $table
/*  3227*/    OPC_MoveChild0,
/*  3228*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3231*/    OPC_MoveParent,
/*  3232*/    OPC_MoveParent,
/*  3233*/    OPC_RecordChild3, // #2 = $i
/*  3234*/    OPC_RecordChild4, // #3 = $val
/*  3235*/    OPC_RecordChild5, // #4 = $n
/*  3236*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3238*/    OPC_EmitMergeInputChains1_0,
/*  3239*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12538:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3247*/   /*Scope*/ 14, /*->3262*/
/*  3248*/    OPC_CheckChild1Integer, 100|128,67|128,1/*25060*/, 
/*  3252*/    OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/*  3254*/    OPC_EmitMergeInputChains1_0,
/*  3255*/    OPC_EmitInteger32, 0, 
/*  3257*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                  1/*#Ops*/, 1, 
              // Src: (intrinsic_void 12530:{ *:[iPTR] }) - Complexity = 8
              // Dst: (RETHROW 0:{ *:[i32] })
/*  3262*/   0, /*End of Scope*/
/*  3263*/  0, /*End of Scope*/
/*  3264*/ /*SwitchOpcode*/ 81|128,3/*465*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3733
/*  3268*/  OPC_Scope, 22|128,1/*150*/, /*->3421*/ // 3 children in Scope
/*  3271*/   OPC_RecordMemRef,
/*  3272*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3273*/   OPC_Scope, 45, /*->3320*/ // 3 children in Scope
/*  3275*/    OPC_CheckChild1Integer, 38|128,67|128,1/*24998*/, 
/*  3279*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3280*/    OPC_Scope, 18, /*->3300*/ // 2 children in Scope
/*  3282*/     OPC_CheckChild2TypeI32,
/*  3283*/     OPC_RecordChild3, // #2 = $count
/*  3284*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3285*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3287*/     OPC_EmitMergeInputChains1_0,
/*  3288*/     OPC_EmitInteger32, 0, 
/*  3290*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12499:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3300*/    /*Scope*/ 18, /*->3319*/
/*  3301*/     OPC_CheckChild2TypeI64,
/*  3302*/     OPC_RecordChild3, // #2 = $count
/*  3303*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3304*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3306*/     OPC_EmitMergeInputChains1_0,
/*  3307*/     OPC_EmitInteger32, 0, 
/*  3309*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12499:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3319*/    0, /*End of Scope*/
/*  3320*/   /*Scope*/ 49, /*->3370*/
/*  3321*/    OPC_CheckChild1Integer, 40|128,67|128,1/*25000*/, 
/*  3325*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3326*/    OPC_Scope, 20, /*->3348*/ // 2 children in Scope
/*  3328*/     OPC_CheckChild2TypeI32,
/*  3329*/     OPC_RecordChild3, // #2 = $exp
/*  3330*/     OPC_RecordChild4, // #3 = $timeout
/*  3331*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3332*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3334*/     OPC_EmitMergeInputChains1_0,
/*  3335*/     OPC_EmitInteger32, 0, 
/*  3337*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12500:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3348*/    /*Scope*/ 20, /*->3369*/
/*  3349*/     OPC_CheckChild2TypeI64,
/*  3350*/     OPC_RecordChild3, // #2 = $exp
/*  3351*/     OPC_RecordChild4, // #3 = $timeout
/*  3352*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3353*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3355*/     OPC_EmitMergeInputChains1_0,
/*  3356*/     OPC_EmitInteger32, 0, 
/*  3358*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12500:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3369*/    0, /*End of Scope*/
/*  3370*/   /*Scope*/ 49, /*->3420*/
/*  3371*/    OPC_CheckChild1Integer, 42|128,67|128,1/*25002*/, 
/*  3375*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3376*/    OPC_Scope, 20, /*->3398*/ // 2 children in Scope
/*  3378*/     OPC_CheckChild2TypeI32,
/*  3379*/     OPC_RecordChild3, // #2 = $exp
/*  3380*/     OPC_RecordChild4, // #3 = $timeout
/*  3381*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3382*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3384*/     OPC_EmitMergeInputChains1_0,
/*  3385*/     OPC_EmitInteger32, 0, 
/*  3387*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12501:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3398*/    /*Scope*/ 20, /*->3419*/
/*  3399*/     OPC_CheckChild2TypeI64,
/*  3400*/     OPC_RecordChild3, // #2 = $exp
/*  3401*/     OPC_RecordChild4, // #3 = $timeout
/*  3402*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3403*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3405*/     OPC_EmitMergeInputChains1_0,
/*  3406*/     OPC_EmitInteger32, 0, 
/*  3408*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12501:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3419*/    0, /*End of Scope*/
/*  3420*/   0, /*End of Scope*/
/*  3421*/  /*Scope*/ 9|128,2/*265*/, /*->3688*/
/*  3423*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3424*/   OPC_Scope, 26, /*->3452*/ // 9 children in Scope
/*  3426*/    OPC_CheckChild1Integer, 126|128,67|128,1/*25086*/, 
/*  3430*/    OPC_MoveChild2,
/*  3431*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3434*/    OPC_RecordChild0, // #1 = $table
/*  3435*/    OPC_MoveChild0,
/*  3436*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3439*/    OPC_MoveParent,
/*  3440*/    OPC_MoveParent,
/*  3441*/    OPC_RecordChild3, // #2 = $i
/*  3442*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3443*/    OPC_EmitMergeInputChains1_0,
/*  3444*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  /*MVT::funcref*/98|128,1/*226*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12543:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3452*/   /*Scope*/ 27, /*->3480*/
/*  3453*/    OPC_CheckChild1Integer, 4|128,68|128,1/*25092*/, 
/*  3457*/    OPC_MoveChild2,
/*  3458*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3461*/    OPC_RecordChild0, // #1 = $table
/*  3462*/    OPC_MoveChild0,
/*  3463*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3466*/    OPC_MoveParent,
/*  3467*/    OPC_MoveParent,
/*  3468*/    OPC_RecordChild3, // #2 = $val
/*  3469*/    OPC_RecordChild4, // #3 = $n
/*  3470*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3471*/    OPC_EmitMergeInputChains1_0,
/*  3472*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12546:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3480*/   /*Scope*/ 26, /*->3507*/
/*  3481*/    OPC_CheckChild1Integer, 124|128,67|128,1/*25084*/, 
/*  3485*/    OPC_MoveChild2,
/*  3486*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3489*/    OPC_RecordChild0, // #1 = $table
/*  3490*/    OPC_MoveChild0,
/*  3491*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3494*/    OPC_MoveParent,
/*  3495*/    OPC_MoveParent,
/*  3496*/    OPC_RecordChild3, // #2 = $i
/*  3497*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3498*/    OPC_EmitMergeInputChains1_0,
/*  3499*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  /*MVT::externref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12542:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3507*/   /*Scope*/ 27, /*->3535*/
/*  3508*/    OPC_CheckChild1Integer, 2|128,68|128,1/*25090*/, 
/*  3512*/    OPC_MoveChild2,
/*  3513*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3516*/    OPC_RecordChild0, // #1 = $table
/*  3517*/    OPC_MoveChild0,
/*  3518*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3521*/    OPC_MoveParent,
/*  3522*/    OPC_MoveParent,
/*  3523*/    OPC_RecordChild3, // #2 = $val
/*  3524*/    OPC_RecordChild4, // #3 = $n
/*  3525*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3526*/    OPC_EmitMergeInputChains1_0,
/*  3527*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12545:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3535*/   /*Scope*/ 27, /*->3563*/
/*  3536*/    OPC_CheckChild1Integer, 122|128,67|128,1/*25082*/, 
/*  3540*/    OPC_MoveChild2,
/*  3541*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3544*/    OPC_RecordChild0, // #1 = $table
/*  3545*/    OPC_MoveChild0,
/*  3546*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3549*/    OPC_MoveParent,
/*  3550*/    OPC_MoveParent,
/*  3551*/    OPC_RecordChild3, // #2 = $i
/*  3552*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3554*/    OPC_EmitMergeInputChains1_0,
/*  3555*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  /*MVT::exnref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 12541:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3563*/   /*Scope*/ 28, /*->3592*/
/*  3564*/    OPC_CheckChild1Integer, 0|128,68|128,1/*25088*/, 
/*  3568*/    OPC_MoveChild2,
/*  3569*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3572*/    OPC_RecordChild0, // #1 = $table
/*  3573*/    OPC_MoveChild0,
/*  3574*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3577*/    OPC_MoveParent,
/*  3578*/    OPC_MoveParent,
/*  3579*/    OPC_RecordChild3, // #2 = $val
/*  3580*/    OPC_RecordChild4, // #3 = $n
/*  3581*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3583*/    OPC_EmitMergeInputChains1_0,
/*  3584*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12544:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3592*/   /*Scope*/ 23, /*->3616*/
/*  3593*/    OPC_CheckChild1Integer, 12|128,68|128,1/*25100*/, 
/*  3597*/    OPC_MoveChild2,
/*  3598*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3601*/    OPC_RecordChild0, // #1 = $table
/*  3602*/    OPC_MoveChild0,
/*  3603*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3606*/    OPC_MoveParent,
/*  3607*/    OPC_MoveParent,
/*  3608*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3609*/    OPC_EmitMergeInputChains1_0,
/*  3610*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  /*MVT::i32*/7, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12550:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3616*/   /*Scope*/ 32, /*->3649*/
/*  3617*/    OPC_CheckChild1Integer, 46|128,67|128,1/*25006*/, 
/*  3621*/    OPC_RecordChild2, // #1 = $flags
/*  3622*/    OPC_MoveChild2,
/*  3623*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3626*/    OPC_MoveParent,
/*  3627*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->3638
/*  3630*/     OPC_EmitMergeInputChains1_0,
/*  3631*/     OPC_EmitConvertToTarget1,
/*  3632*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8206MEMORY_SIZE_A32),
                   /*MVT::i32*/7, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12503:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8206MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3638*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->3648
/*  3640*/     OPC_EmitMergeInputChains1_0,
/*  3641*/     OPC_EmitConvertToTarget1,
/*  3642*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8207MEMORY_SIZE_A64),
                   /*MVT::i64*/8, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12503:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8207MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3648*/    0, // EndSwitchType
/*  3649*/   /*Scope*/ 37, /*->3687*/
/*  3650*/    OPC_CheckChild1Integer, 44|128,67|128,1/*25004*/, 
/*  3654*/    OPC_RecordChild2, // #1 = $flags
/*  3655*/    OPC_MoveChild2,
/*  3656*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3659*/    OPC_MoveParent,
/*  3660*/    OPC_RecordChild3, // #2 = $delta
/*  3661*/    OPC_SwitchType /*2 cases */, 10, /*MVT::i32*/7, // ->3674
/*  3664*/     OPC_CheckChild3TypeI32,
/*  3665*/     OPC_EmitMergeInputChains1_0,
/*  3666*/     OPC_EmitConvertToTarget1,
/*  3667*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8206MEMORY_GROW_A32),
                   /*MVT::i32*/7, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12502:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_8206MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3674*/    /*SwitchType*/ 10, /*MVT::i64*/8, // ->3686
/*  3676*/     OPC_CheckChild3TypeI64,
/*  3677*/     OPC_EmitMergeInputChains1_0,
/*  3678*/     OPC_EmitConvertToTarget1,
/*  3679*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8207MEMORY_GROW_A64),
                   /*MVT::i64*/8, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12502:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_8207MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3686*/    0, // EndSwitchType
/*  3687*/   0, /*End of Scope*/
/*  3688*/  /*Scope*/ 43, /*->3732*/
/*  3689*/   OPC_RecordMemRef,
/*  3690*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3691*/   OPC_CheckChild1Integer, 34|128,67|128,1/*24994*/, 
/*  3695*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3696*/   OPC_Scope, 16, /*->3714*/ // 2 children in Scope
/*  3698*/    OPC_CheckChild2TypeI32,
/*  3699*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3700*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3702*/    OPC_EmitMergeInputChains1_0,
/*  3703*/    OPC_EmitInteger32, 0, 
/*  3705*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12497:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3714*/   /*Scope*/ 16, /*->3731*/
/*  3715*/    OPC_CheckChild2TypeI64,
/*  3716*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3717*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3719*/    OPC_EmitMergeInputChains1_0,
/*  3720*/    OPC_EmitInteger32, 0, 
/*  3722*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12497:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3731*/   0, /*End of Scope*/
/*  3732*/  0, /*End of Scope*/
/*  3733*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4022
/*  3737*/  OPC_RecordMemRef,
/*  3738*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3739*/  OPC_Scope, 119, /*->3860*/ // 2 children in Scope
/*  3741*/   OPC_MoveChild1,
/*  3742*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3745*/   OPC_RecordChild0, // #1 = $val
/*  3746*/   OPC_MoveParent,
/*  3747*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3748*/   OPC_Scope, 54, /*->3804*/ // 2 children in Scope
/*  3750*/    OPC_CheckChild2TypeI32,
/*  3751*/    OPC_Scope, 16, /*->3769*/ // 3 children in Scope
/*  3753*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3754*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3755*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3757*/     OPC_EmitMergeInputChains1_0,
/*  3758*/     OPC_EmitInteger32, 0, 
/*  3760*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3769*/    /*Scope*/ 16, /*->3786*/
/*  3770*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3771*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3772*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3774*/     OPC_EmitMergeInputChains1_0,
/*  3775*/     OPC_EmitInteger32, 0, 
/*  3777*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3786*/    /*Scope*/ 16, /*->3803*/
/*  3787*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3788*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3789*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3791*/     OPC_EmitMergeInputChains1_0,
/*  3792*/     OPC_EmitInteger32, 0, 
/*  3794*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3803*/    0, /*End of Scope*/
/*  3804*/   /*Scope*/ 54, /*->3859*/
/*  3805*/    OPC_CheckChild2TypeI64,
/*  3806*/    OPC_Scope, 16, /*->3824*/ // 3 children in Scope
/*  3808*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3809*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3810*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3812*/     OPC_EmitMergeInputChains1_0,
/*  3813*/     OPC_EmitInteger32, 0, 
/*  3815*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3824*/    /*Scope*/ 16, /*->3841*/
/*  3825*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3826*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3827*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3829*/     OPC_EmitMergeInputChains1_0,
/*  3830*/     OPC_EmitInteger32, 0, 
/*  3832*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3841*/    /*Scope*/ 16, /*->3858*/
/*  3842*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3843*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3844*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3846*/     OPC_EmitMergeInputChains1_0,
/*  3847*/     OPC_EmitInteger32, 0, 
/*  3849*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3858*/    0, /*End of Scope*/
/*  3859*/   0, /*End of Scope*/
/*  3860*/  /*Scope*/ 31|128,1/*159*/, /*->4021*/
/*  3862*/   OPC_RecordChild1, // #1 = $val
/*  3863*/   OPC_Scope, 114, /*->3979*/ // 2 children in Scope
/*  3865*/    OPC_CheckChild1TypeI32,
/*  3866*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3867*/    OPC_Scope, 54, /*->3923*/ // 2 children in Scope
/*  3869*/     OPC_CheckChild2TypeI32,
/*  3870*/     OPC_Scope, 16, /*->3888*/ // 3 children in Scope
/*  3872*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3873*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3874*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3876*/      OPC_EmitMergeInputChains1_0,
/*  3877*/      OPC_EmitInteger32, 0, 
/*  3879*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3888*/     /*Scope*/ 16, /*->3905*/
/*  3889*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3890*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3891*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3893*/      OPC_EmitMergeInputChains1_0,
/*  3894*/      OPC_EmitInteger32, 0, 
/*  3896*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3905*/     /*Scope*/ 16, /*->3922*/
/*  3906*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3907*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3908*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3910*/      OPC_EmitMergeInputChains1_0,
/*  3911*/      OPC_EmitInteger32, 0, 
/*  3913*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3922*/     0, /*End of Scope*/
/*  3923*/    /*Scope*/ 54, /*->3978*/
/*  3924*/     OPC_CheckChild2TypeI64,
/*  3925*/     OPC_Scope, 16, /*->3943*/ // 3 children in Scope
/*  3927*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3928*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3929*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3931*/      OPC_EmitMergeInputChains1_0,
/*  3932*/      OPC_EmitInteger32, 0, 
/*  3934*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3943*/     /*Scope*/ 16, /*->3960*/
/*  3944*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3945*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3946*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3948*/      OPC_EmitMergeInputChains1_0,
/*  3949*/      OPC_EmitInteger32, 0, 
/*  3951*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3960*/     /*Scope*/ 16, /*->3977*/
/*  3961*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3962*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3963*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3965*/      OPC_EmitMergeInputChains1_0,
/*  3966*/      OPC_EmitInteger32, 0, 
/*  3968*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3977*/     0, /*End of Scope*/
/*  3978*/    0, /*End of Scope*/
/*  3979*/   /*Scope*/ 40, /*->4020*/
/*  3980*/    OPC_CheckChild1TypeI64,
/*  3981*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3982*/    OPC_Scope, 17, /*->4001*/ // 2 children in Scope
/*  3984*/     OPC_CheckChild2TypeI32,
/*  3985*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  3986*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3987*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3989*/     OPC_EmitMergeInputChains1_0,
/*  3990*/     OPC_EmitInteger32, 0, 
/*  3992*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4001*/    /*Scope*/ 17, /*->4019*/
/*  4002*/     OPC_CheckChild2TypeI64,
/*  4003*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4004*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4005*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4007*/     OPC_EmitMergeInputChains1_0,
/*  4008*/     OPC_EmitInteger32, 0, 
/*  4010*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4019*/    0, /*End of Scope*/
/*  4020*/   0, /*End of Scope*/
/*  4021*/  0, /*End of Scope*/
/*  4022*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4372
/*  4026*/  OPC_Scope, 118, /*->4146*/ // 6 children in Scope
/*  4028*/   OPC_MoveChild0,
/*  4029*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4032*/   OPC_Scope, 55, /*->4089*/ // 2 children in Scope
/*  4034*/    OPC_CheckChild0Integer, 10|128,67|128,1/*24970*/, 
/*  4038*/    OPC_RecordChild1, // #0 = $x
/*  4039*/    OPC_Scope, 11, /*->4052*/ // 4 children in Scope
/*  4041*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4043*/     OPC_MoveParent,
/*  4044*/     OPC_CheckChild1Integer, 2, 
/*  4046*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4052*/    /*Scope*/ 11, /*->4064*/
/*  4053*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4055*/     OPC_MoveParent,
/*  4056*/     OPC_CheckChild1Integer, 2, 
/*  4058*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4064*/    /*Scope*/ 11, /*->4076*/
/*  4065*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4067*/     OPC_MoveParent,
/*  4068*/     OPC_CheckChild1Integer, 2, 
/*  4070*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4076*/    /*Scope*/ 11, /*->4088*/
/*  4077*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4079*/     OPC_MoveParent,
/*  4080*/     OPC_CheckChild1Integer, 2, 
/*  4082*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4088*/    0, /*End of Scope*/
/*  4089*/   /*Scope*/ 55, /*->4145*/
/*  4090*/    OPC_CheckChild0Integer, 8|128,67|128,1/*24968*/, 
/*  4094*/    OPC_RecordChild1, // #0 = $x
/*  4095*/    OPC_Scope, 11, /*->4108*/ // 4 children in Scope
/*  4097*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4099*/     OPC_MoveParent,
/*  4100*/     OPC_CheckChild1Integer, 2, 
/*  4102*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4108*/    /*Scope*/ 11, /*->4120*/
/*  4109*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4111*/     OPC_MoveParent,
/*  4112*/     OPC_CheckChild1Integer, 2, 
/*  4114*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4120*/    /*Scope*/ 11, /*->4132*/
/*  4121*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4123*/     OPC_MoveParent,
/*  4124*/     OPC_CheckChild1Integer, 2, 
/*  4126*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4132*/    /*Scope*/ 11, /*->4144*/
/*  4133*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4135*/     OPC_MoveParent,
/*  4136*/     OPC_CheckChild1Integer, 2, 
/*  4138*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4144*/    0, /*End of Scope*/
/*  4145*/   0, /*End of Scope*/
/*  4146*/  /*Scope*/ 29, /*->4176*/
/*  4147*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4150*/   OPC_MoveChild0,
/*  4151*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4154*/   OPC_RecordChild0, // #0 = $vec
/*  4155*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  4157*/   OPC_RecordChild1, // #1 = $idx
/*  4158*/   OPC_MoveChild1,
/*  4159*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4162*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/*  4164*/   OPC_CheckTypeI32,
/*  4165*/   OPC_MoveParent,
/*  4166*/   OPC_MoveParent,
/*  4167*/   OPC_CheckTypeI32,
/*  4168*/   OPC_EmitConvertToTarget1,
/*  4169*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4176*/  /*Scope*/ 30, /*->4207*/
/*  4177*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4181*/   OPC_MoveChild0,
/*  4182*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4185*/   OPC_RecordChild0, // #0 = $vec
/*  4186*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  4188*/   OPC_RecordChild1, // #1 = $idx
/*  4189*/   OPC_MoveChild1,
/*  4190*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4193*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/*  4195*/   OPC_CheckTypeI32,
/*  4196*/   OPC_MoveParent,
/*  4197*/   OPC_MoveParent,
/*  4198*/   OPC_CheckTypeI32,
/*  4199*/   OPC_EmitConvertToTarget1,
/*  4200*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4207*/  /*Scope*/ 73, /*->4281*/
/*  4208*/   OPC_RecordChild0, // #0 = $lhs
/*  4209*/   OPC_Scope, 21, /*->4232*/ // 2 children in Scope
/*  4211*/    OPC_RecordChild1, // #1 = $rhs
/*  4212*/    OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->4222
/*  4215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4222*/    /*SwitchType*/ 7, /*MVT::i64*/8, // ->4231
/*  4224*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4231*/    0, // EndSwitchType
/*  4232*/   /*Scope*/ 47, /*->4280*/
/*  4233*/    OPC_MoveChild1,
/*  4234*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4237*/    OPC_RecordChild0, // #1 = $rhs
/*  4238*/    OPC_MoveChild1,
/*  4239*/    OPC_CheckImmAllOnesV,
/*  4240*/    OPC_MoveParent,
/*  4241*/    OPC_MoveParent,
/*  4242*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4252
/*  4245*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4252*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4261
/*  4254*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4261*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4270
/*  4263*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4270*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4279
/*  4272*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4279*/    0, // EndSwitchType
/*  4280*/   0, /*End of Scope*/
/*  4281*/  /*Scope*/ 48, /*->4330*/
/*  4282*/   OPC_MoveChild0,
/*  4283*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4286*/   OPC_RecordChild0, // #0 = $rhs
/*  4287*/   OPC_MoveChild1,
/*  4288*/   OPC_CheckImmAllOnesV,
/*  4289*/   OPC_MoveParent,
/*  4290*/   OPC_MoveParent,
/*  4291*/   OPC_RecordChild1, // #1 = $lhs
/*  4292*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4302
/*  4295*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4302*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4311
/*  4304*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4311*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4320
/*  4313*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4320*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4329
/*  4322*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4329*/   0, // EndSwitchType
/*  4330*/  /*Scope*/ 40, /*->4371*/
/*  4331*/   OPC_RecordChild0, // #0 = $lhs
/*  4332*/   OPC_RecordChild1, // #1 = $rhs
/*  4333*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4343
/*  4336*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4343*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4352
/*  4345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4352*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4361
/*  4354*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4361*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4370
/*  4363*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4370*/   0, // EndSwitchType
/*  4371*/  0, /*End of Scope*/
/*  4372*/ /*SwitchOpcode*/ 125|128,11/*1533*/, TARGET_VAL(ISD::SETCC),// ->5909
/*  4376*/  OPC_Scope, 126|128,1/*254*/, /*->4633*/ // 2 children in Scope
/*  4379*/   OPC_MoveChild0,
/*  4380*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4383*/   OPC_Scope, 123, /*->4508*/ // 2 children in Scope
/*  4385*/    OPC_CheckChild0Integer, 10|128,67|128,1/*24970*/, 
/*  4389*/    OPC_RecordChild1, // #0 = $x
/*  4390*/    OPC_Scope, 28, /*->4420*/ // 4 children in Scope
/*  4392*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4394*/     OPC_MoveParent,
/*  4395*/     OPC_CheckTypeI32,
/*  4396*/     OPC_Scope, 10, /*->4408*/ // 2 children in Scope
/*  4398*/      OPC_CheckChild1Integer, 0, 
/*  4400*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4402*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4408*/     /*Scope*/ 10, /*->4419*/
/*  4409*/      OPC_CheckChild1Integer, 2, 
/*  4411*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4413*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4419*/     0, /*End of Scope*/
/*  4420*/    /*Scope*/ 28, /*->4449*/
/*  4421*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4423*/     OPC_MoveParent,
/*  4424*/     OPC_CheckTypeI32,
/*  4425*/     OPC_Scope, 10, /*->4437*/ // 2 children in Scope
/*  4427*/      OPC_CheckChild1Integer, 0, 
/*  4429*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4431*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4437*/     /*Scope*/ 10, /*->4448*/
/*  4438*/      OPC_CheckChild1Integer, 2, 
/*  4440*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4442*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4448*/     0, /*End of Scope*/
/*  4449*/    /*Scope*/ 28, /*->4478*/
/*  4450*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4452*/     OPC_MoveParent,
/*  4453*/     OPC_CheckTypeI32,
/*  4454*/     OPC_Scope, 10, /*->4466*/ // 2 children in Scope
/*  4456*/      OPC_CheckChild1Integer, 0, 
/*  4458*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4460*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4466*/     /*Scope*/ 10, /*->4477*/
/*  4467*/      OPC_CheckChild1Integer, 2, 
/*  4469*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4471*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4477*/     0, /*End of Scope*/
/*  4478*/    /*Scope*/ 28, /*->4507*/
/*  4479*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4481*/     OPC_MoveParent,
/*  4482*/     OPC_CheckTypeI32,
/*  4483*/     OPC_Scope, 10, /*->4495*/ // 2 children in Scope
/*  4485*/      OPC_CheckChild1Integer, 0, 
/*  4487*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4489*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4495*/     /*Scope*/ 10, /*->4506*/
/*  4496*/      OPC_CheckChild1Integer, 2, 
/*  4498*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4500*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4506*/     0, /*End of Scope*/
/*  4507*/    0, /*End of Scope*/
/*  4508*/   /*Scope*/ 123, /*->4632*/
/*  4509*/    OPC_CheckChild0Integer, 8|128,67|128,1/*24968*/, 
/*  4513*/    OPC_RecordChild1, // #0 = $x
/*  4514*/    OPC_Scope, 28, /*->4544*/ // 4 children in Scope
/*  4516*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4518*/     OPC_MoveParent,
/*  4519*/     OPC_CheckTypeI32,
/*  4520*/     OPC_Scope, 10, /*->4532*/ // 2 children in Scope
/*  4522*/      OPC_CheckChild1Integer, 0, 
/*  4524*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4526*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4532*/     /*Scope*/ 10, /*->4543*/
/*  4533*/      OPC_CheckChild1Integer, 2, 
/*  4535*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4537*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4543*/     0, /*End of Scope*/
/*  4544*/    /*Scope*/ 28, /*->4573*/
/*  4545*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4547*/     OPC_MoveParent,
/*  4548*/     OPC_CheckTypeI32,
/*  4549*/     OPC_Scope, 10, /*->4561*/ // 2 children in Scope
/*  4551*/      OPC_CheckChild1Integer, 0, 
/*  4553*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4555*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4561*/     /*Scope*/ 10, /*->4572*/
/*  4562*/      OPC_CheckChild1Integer, 2, 
/*  4564*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4566*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4572*/     0, /*End of Scope*/
/*  4573*/    /*Scope*/ 28, /*->4602*/
/*  4574*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4576*/     OPC_MoveParent,
/*  4577*/     OPC_CheckTypeI32,
/*  4578*/     OPC_Scope, 10, /*->4590*/ // 2 children in Scope
/*  4580*/      OPC_CheckChild1Integer, 0, 
/*  4582*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4584*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4590*/     /*Scope*/ 10, /*->4601*/
/*  4591*/      OPC_CheckChild1Integer, 2, 
/*  4593*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4595*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4601*/     0, /*End of Scope*/
/*  4602*/    /*Scope*/ 28, /*->4631*/
/*  4603*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4605*/     OPC_MoveParent,
/*  4606*/     OPC_CheckTypeI32,
/*  4607*/     OPC_Scope, 10, /*->4619*/ // 2 children in Scope
/*  4609*/      OPC_CheckChild1Integer, 0, 
/*  4611*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4613*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4619*/     /*Scope*/ 10, /*->4630*/
/*  4620*/      OPC_CheckChild1Integer, 2, 
/*  4622*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4624*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4630*/     0, /*End of Scope*/
/*  4631*/    0, /*End of Scope*/
/*  4632*/   0, /*End of Scope*/
/*  4633*/  /*Scope*/ 121|128,9/*1273*/, /*->5908*/
/*  4635*/   OPC_RecordChild0, // #0 = $src
/*  4636*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, /*MVT::i32*/7, // ->5132
/*  4640*/    OPC_Scope, 118, /*->4760*/ // 4 children in Scope
/*  4642*/     OPC_CheckChild0TypeI32,
/*  4643*/     OPC_Scope, 10, /*->4655*/ // 2 children in Scope
/*  4645*/      OPC_CheckChild1Integer, 0, 
/*  4647*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4649*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4655*/     /*Scope*/ 103, /*->4759*/
/*  4656*/      OPC_RecordChild1, // #1 = $rhs
/*  4657*/      OPC_Scope, 9, /*->4668*/ // 10 children in Scope
/*  4659*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4661*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4668*/      /*Scope*/ 9, /*->4678*/
/*  4669*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4671*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4678*/      /*Scope*/ 9, /*->4688*/
/*  4679*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4681*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4688*/      /*Scope*/ 9, /*->4698*/
/*  4689*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4691*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4698*/      /*Scope*/ 9, /*->4708*/
/*  4699*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4701*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4708*/      /*Scope*/ 9, /*->4718*/
/*  4709*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4711*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4718*/      /*Scope*/ 9, /*->4728*/
/*  4719*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4721*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4728*/      /*Scope*/ 9, /*->4738*/
/*  4729*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4731*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4738*/      /*Scope*/ 9, /*->4748*/
/*  4739*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4741*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4748*/      /*Scope*/ 9, /*->4758*/
/*  4749*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4751*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4758*/      0, /*End of Scope*/
/*  4759*/     0, /*End of Scope*/
/*  4760*/    /*Scope*/ 118, /*->4879*/
/*  4761*/     OPC_CheckChild0TypeI64,
/*  4762*/     OPC_Scope, 10, /*->4774*/ // 2 children in Scope
/*  4764*/      OPC_CheckChild1Integer, 0, 
/*  4766*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4768*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4774*/     /*Scope*/ 103, /*->4878*/
/*  4775*/      OPC_RecordChild1, // #1 = $rhs
/*  4776*/      OPC_Scope, 9, /*->4787*/ // 10 children in Scope
/*  4778*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4780*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4787*/      /*Scope*/ 9, /*->4797*/
/*  4788*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4790*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4797*/      /*Scope*/ 9, /*->4807*/
/*  4798*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4800*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4807*/      /*Scope*/ 9, /*->4817*/
/*  4808*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4810*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4817*/      /*Scope*/ 9, /*->4827*/
/*  4818*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4820*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4827*/      /*Scope*/ 9, /*->4837*/
/*  4828*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4830*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4837*/      /*Scope*/ 9, /*->4847*/
/*  4838*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4840*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4847*/      /*Scope*/ 9, /*->4857*/
/*  4848*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4850*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4857*/      /*Scope*/ 9, /*->4867*/
/*  4858*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4860*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4867*/      /*Scope*/ 9, /*->4877*/
/*  4868*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4870*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4877*/      0, /*End of Scope*/
/*  4878*/     0, /*End of Scope*/
/*  4879*/    /*Scope*/ 125, /*->5005*/
/*  4880*/     OPC_CheckChild0Type, /*MVT::f32*/12, 
/*  4882*/     OPC_RecordChild1, // #1 = $rhs
/*  4883*/     OPC_Scope, 9, /*->4894*/ // 12 children in Scope
/*  4885*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4887*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4894*/     /*Scope*/ 9, /*->4904*/
/*  4895*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4897*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4904*/     /*Scope*/ 9, /*->4914*/
/*  4905*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4907*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4914*/     /*Scope*/ 9, /*->4924*/
/*  4915*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4917*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4924*/     /*Scope*/ 9, /*->4934*/
/*  4925*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4927*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4934*/     /*Scope*/ 9, /*->4944*/
/*  4935*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4937*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4944*/     /*Scope*/ 9, /*->4954*/
/*  4945*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4947*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4954*/     /*Scope*/ 9, /*->4964*/
/*  4955*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4957*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4964*/     /*Scope*/ 9, /*->4974*/
/*  4965*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  4967*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4974*/     /*Scope*/ 9, /*->4984*/
/*  4975*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  4977*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4984*/     /*Scope*/ 9, /*->4994*/
/*  4985*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  4987*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4994*/     /*Scope*/ 9, /*->5004*/
/*  4995*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  4997*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5004*/     0, /*End of Scope*/
/*  5005*/    /*Scope*/ 125, /*->5131*/
/*  5006*/     OPC_CheckChild0Type, /*MVT::f64*/13, 
/*  5008*/     OPC_RecordChild1, // #1 = $rhs
/*  5009*/     OPC_Scope, 9, /*->5020*/ // 12 children in Scope
/*  5011*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5013*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5020*/     /*Scope*/ 9, /*->5030*/
/*  5021*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5023*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5030*/     /*Scope*/ 9, /*->5040*/
/*  5031*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5033*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5040*/     /*Scope*/ 9, /*->5050*/
/*  5041*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5043*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5050*/     /*Scope*/ 9, /*->5060*/
/*  5051*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5053*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5060*/     /*Scope*/ 9, /*->5070*/
/*  5061*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5063*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5070*/     /*Scope*/ 9, /*->5080*/
/*  5071*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5073*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5080*/     /*Scope*/ 9, /*->5090*/
/*  5081*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5083*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5090*/     /*Scope*/ 9, /*->5100*/
/*  5091*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5093*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5100*/     /*Scope*/ 9, /*->5110*/
/*  5101*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5103*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5110*/     /*Scope*/ 9, /*->5120*/
/*  5111*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5113*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5120*/     /*Scope*/ 9, /*->5130*/
/*  5121*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5123*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5130*/     0, /*End of Scope*/
/*  5131*/    0, /*End of Scope*/
/*  5132*/   /*SwitchType*/ 115, /*MVT::v16i8*/39, // ->5249
/*  5134*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  5136*/    OPC_RecordChild1, // #1 = $rhs
/*  5137*/    OPC_Scope, 10, /*->5149*/ // 10 children in Scope
/*  5139*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5141*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5142*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5149*/    /*Scope*/ 10, /*->5160*/
/*  5150*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5152*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5153*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5160*/    /*Scope*/ 10, /*->5171*/
/*  5161*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5163*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5164*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5171*/    /*Scope*/ 10, /*->5182*/
/*  5172*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5174*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5175*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5182*/    /*Scope*/ 10, /*->5193*/
/*  5183*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5185*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5186*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5193*/    /*Scope*/ 10, /*->5204*/
/*  5194*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5196*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5197*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5204*/    /*Scope*/ 10, /*->5215*/
/*  5205*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5207*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5208*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5215*/    /*Scope*/ 10, /*->5226*/
/*  5216*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5218*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5219*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5226*/    /*Scope*/ 10, /*->5237*/
/*  5227*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5229*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5237*/    /*Scope*/ 10, /*->5248*/
/*  5238*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5240*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5248*/    0, /*End of Scope*/
/*  5249*/   /*SwitchType*/ 62|128,1/*190*/, /*MVT::v8i16*/50, // ->5442
/*  5252*/    OPC_Scope, 115, /*->5369*/ // 2 children in Scope
/*  5254*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  5256*/     OPC_RecordChild1, // #1 = $rhs
/*  5257*/     OPC_Scope, 10, /*->5269*/ // 10 children in Scope
/*  5259*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5261*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5262*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5269*/     /*Scope*/ 10, /*->5280*/
/*  5270*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5272*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5273*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5280*/     /*Scope*/ 10, /*->5291*/
/*  5281*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5283*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5284*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5291*/     /*Scope*/ 10, /*->5302*/
/*  5292*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5294*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5295*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5302*/     /*Scope*/ 10, /*->5313*/
/*  5303*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5305*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5306*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5313*/     /*Scope*/ 10, /*->5324*/
/*  5314*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5316*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5317*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5324*/     /*Scope*/ 10, /*->5335*/
/*  5325*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5327*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5328*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5335*/     /*Scope*/ 10, /*->5346*/
/*  5336*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5338*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5339*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5346*/     /*Scope*/ 10, /*->5357*/
/*  5347*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5349*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5350*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5357*/     /*Scope*/ 10, /*->5368*/
/*  5358*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5360*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5361*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5368*/     0, /*End of Scope*/
/*  5369*/    /*Scope*/ 71, /*->5441*/
/*  5370*/     OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/*  5372*/     OPC_RecordChild1, // #1 = $rhs
/*  5373*/     OPC_Scope, 10, /*->5385*/ // 6 children in Scope
/*  5375*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5377*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5378*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5385*/     /*Scope*/ 10, /*->5396*/
/*  5386*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5388*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5389*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5396*/     /*Scope*/ 10, /*->5407*/
/*  5397*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5399*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5400*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5407*/     /*Scope*/ 10, /*->5418*/
/*  5408*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5410*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5411*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5418*/     /*Scope*/ 10, /*->5429*/
/*  5419*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5421*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5422*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5429*/     /*Scope*/ 10, /*->5440*/
/*  5430*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5432*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5433*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5440*/     0, /*End of Scope*/
/*  5441*/    0, /*End of Scope*/
/*  5442*/   /*SwitchType*/ 123|128,1/*251*/, /*MVT::v4i32*/60, // ->5696
/*  5445*/    OPC_Scope, 115, /*->5562*/ // 2 children in Scope
/*  5447*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  5449*/     OPC_RecordChild1, // #1 = $rhs
/*  5450*/     OPC_Scope, 10, /*->5462*/ // 10 children in Scope
/*  5452*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5454*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5455*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5462*/     /*Scope*/ 10, /*->5473*/
/*  5463*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5465*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5466*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5473*/     /*Scope*/ 10, /*->5484*/
/*  5474*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5476*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5477*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5484*/     /*Scope*/ 10, /*->5495*/
/*  5485*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5487*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5488*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5495*/     /*Scope*/ 10, /*->5506*/
/*  5496*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5498*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5499*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5506*/     /*Scope*/ 10, /*->5517*/
/*  5507*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5509*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5510*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5517*/     /*Scope*/ 10, /*->5528*/
/*  5518*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5520*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5521*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5528*/     /*Scope*/ 10, /*->5539*/
/*  5529*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5531*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5532*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5539*/     /*Scope*/ 10, /*->5550*/
/*  5540*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5542*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5543*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5550*/     /*Scope*/ 10, /*->5561*/
/*  5551*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5553*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5554*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5561*/     0, /*End of Scope*/
/*  5562*/    /*Scope*/ 3|128,1/*131*/, /*->5695*/
/*  5564*/     OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/*  5566*/     OPC_RecordChild1, // #1 = $rhs
/*  5567*/     OPC_Scope, 10, /*->5579*/ // 12 children in Scope
/*  5569*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5571*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5572*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5579*/     /*Scope*/ 10, /*->5590*/
/*  5580*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5582*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5583*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5590*/     /*Scope*/ 10, /*->5601*/
/*  5591*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5593*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5594*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5601*/     /*Scope*/ 10, /*->5612*/
/*  5602*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5604*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5605*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5612*/     /*Scope*/ 10, /*->5623*/
/*  5613*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5615*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5616*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5623*/     /*Scope*/ 10, /*->5634*/
/*  5624*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5626*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5627*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5634*/     /*Scope*/ 9, /*->5644*/
/*  5635*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5637*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5644*/     /*Scope*/ 9, /*->5654*/
/*  5645*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5647*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5654*/     /*Scope*/ 9, /*->5664*/
/*  5655*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5657*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5664*/     /*Scope*/ 9, /*->5674*/
/*  5665*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5667*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5674*/     /*Scope*/ 9, /*->5684*/
/*  5675*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5677*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5684*/     /*Scope*/ 9, /*->5694*/
/*  5685*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5687*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5694*/     0, /*End of Scope*/
/*  5695*/    0, /*End of Scope*/
/*  5696*/   /*SwitchType*/ 80|128,1/*208*/, /*MVT::v2i64*/78, // ->5907
/*  5699*/    OPC_Scope, 71, /*->5772*/ // 2 children in Scope
/*  5701*/     OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  5703*/     OPC_RecordChild1, // #1 = $rhs
/*  5704*/     OPC_Scope, 10, /*->5716*/ // 6 children in Scope
/*  5706*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5708*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5709*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5716*/     /*Scope*/ 10, /*->5727*/
/*  5717*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5719*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5720*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5727*/     /*Scope*/ 10, /*->5738*/
/*  5728*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5730*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5731*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5738*/     /*Scope*/ 10, /*->5749*/
/*  5739*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5741*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5742*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5749*/     /*Scope*/ 10, /*->5760*/
/*  5750*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5752*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5753*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5760*/     /*Scope*/ 10, /*->5771*/
/*  5761*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5763*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5771*/     0, /*End of Scope*/
/*  5772*/    /*Scope*/ 4|128,1/*132*/, /*->5906*/
/*  5774*/     OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/*  5777*/     OPC_RecordChild1, // #1 = $rhs
/*  5778*/     OPC_Scope, 10, /*->5790*/ // 12 children in Scope
/*  5780*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5782*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5783*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5790*/     /*Scope*/ 10, /*->5801*/
/*  5791*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5793*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5794*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5801*/     /*Scope*/ 10, /*->5812*/
/*  5802*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5804*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5805*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5812*/     /*Scope*/ 10, /*->5823*/
/*  5813*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5815*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5816*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5823*/     /*Scope*/ 10, /*->5834*/
/*  5824*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5826*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5827*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5834*/     /*Scope*/ 10, /*->5845*/
/*  5835*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5837*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5838*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5845*/     /*Scope*/ 9, /*->5855*/
/*  5846*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5848*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5855*/     /*Scope*/ 9, /*->5865*/
/*  5856*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5858*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5865*/     /*Scope*/ 9, /*->5875*/
/*  5866*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5868*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5875*/     /*Scope*/ 9, /*->5885*/
/*  5876*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5885*/     /*Scope*/ 9, /*->5895*/
/*  5886*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5888*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5895*/     /*Scope*/ 9, /*->5905*/
/*  5896*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5898*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5905*/     0, /*End of Scope*/
/*  5906*/    0, /*End of Scope*/
/*  5907*/   0, // EndSwitchType
/*  5908*/  0, /*End of Scope*/
/*  5909*/ /*SwitchOpcode*/ 25|128,11/*1433*/, TARGET_VAL(ISD::LOAD),// ->7346
/*  5913*/  OPC_RecordMemRef,
/*  5914*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5915*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5916*/  OPC_Scope, 72|128,5/*712*/, /*->6631*/ // 2 children in Scope
/*  5919*/   OPC_CheckChild1TypeI32,
/*  5920*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  5922*/   OPC_Scope, 37, /*->5961*/ // 16 children in Scope
/*  5924*/    OPC_CheckPredicate6,  // Predicate_load
/*  5925*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->5943
/*  5928*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5929*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5931*/     OPC_EmitMergeInputChains1_0,
/*  5932*/     OPC_EmitInteger32, 0, 
/*  5934*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5943*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->5960
/*  5945*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5946*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5948*/     OPC_EmitMergeInputChains1_0,
/*  5949*/     OPC_EmitInteger32, 0, 
/*  5951*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5960*/    0, // EndSwitchType
/*  5961*/   /*Scope*/ 97, /*->6059*/
/*  5962*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  5964*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6003
/*  5967*/     OPC_Scope, 16, /*->5985*/ // 2 children in Scope
/*  5969*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  5970*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5971*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5973*/      OPC_EmitMergeInputChains1_0,
/*  5974*/      OPC_EmitInteger32, 0, 
/*  5976*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5985*/     /*Scope*/ 16, /*->6002*/
/*  5986*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  5987*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5988*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5990*/      OPC_EmitMergeInputChains1_0,
/*  5991*/      OPC_EmitInteger32, 0, 
/*  5993*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6002*/     0, /*End of Scope*/
/*  6003*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6058
/*  6005*/     OPC_Scope, 16, /*->6023*/ // 3 children in Scope
/*  6007*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6008*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6009*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6011*/      OPC_EmitMergeInputChains1_0,
/*  6012*/      OPC_EmitInteger32, 0, 
/*  6014*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6023*/     /*Scope*/ 16, /*->6040*/
/*  6024*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6025*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6026*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6028*/      OPC_EmitMergeInputChains1_0,
/*  6029*/      OPC_EmitInteger32, 0, 
/*  6031*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6040*/     /*Scope*/ 16, /*->6057*/
/*  6041*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6042*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6043*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6045*/      OPC_EmitMergeInputChains1_0,
/*  6046*/      OPC_EmitInteger32, 0, 
/*  6048*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6057*/     0, /*End of Scope*/
/*  6058*/    0, // EndSwitchType
/*  6059*/   /*Scope*/ 97, /*->6157*/
/*  6060*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6062*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6101
/*  6065*/     OPC_Scope, 16, /*->6083*/ // 2 children in Scope
/*  6067*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6068*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6069*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6071*/      OPC_EmitMergeInputChains1_0,
/*  6072*/      OPC_EmitInteger32, 0, 
/*  6074*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6083*/     /*Scope*/ 16, /*->6100*/
/*  6084*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6085*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6086*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6088*/      OPC_EmitMergeInputChains1_0,
/*  6089*/      OPC_EmitInteger32, 0, 
/*  6091*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6100*/     0, /*End of Scope*/
/*  6101*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6156
/*  6103*/     OPC_Scope, 16, /*->6121*/ // 3 children in Scope
/*  6105*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6106*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6107*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6109*/      OPC_EmitMergeInputChains1_0,
/*  6110*/      OPC_EmitInteger32, 0, 
/*  6112*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6121*/     /*Scope*/ 16, /*->6138*/
/*  6122*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6123*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6124*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6126*/      OPC_EmitMergeInputChains1_0,
/*  6127*/      OPC_EmitInteger32, 0, 
/*  6129*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6138*/     /*Scope*/ 16, /*->6155*/
/*  6139*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6140*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6141*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6143*/      OPC_EmitMergeInputChains1_0,
/*  6144*/      OPC_EmitInteger32, 0, 
/*  6146*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6155*/     0, /*End of Scope*/
/*  6156*/    0, // EndSwitchType
/*  6157*/   /*Scope*/ 97, /*->6255*/
/*  6158*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6160*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6199
/*  6163*/     OPC_Scope, 16, /*->6181*/ // 2 children in Scope
/*  6165*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6166*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6167*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6169*/      OPC_EmitMergeInputChains1_0,
/*  6170*/      OPC_EmitInteger32, 0, 
/*  6172*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6181*/     /*Scope*/ 16, /*->6198*/
/*  6182*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6183*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6184*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6186*/      OPC_EmitMergeInputChains1_0,
/*  6187*/      OPC_EmitInteger32, 0, 
/*  6189*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6198*/     0, /*End of Scope*/
/*  6199*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6254
/*  6201*/     OPC_Scope, 16, /*->6219*/ // 3 children in Scope
/*  6203*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6204*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6205*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6207*/      OPC_EmitMergeInputChains1_0,
/*  6208*/      OPC_EmitInteger32, 0, 
/*  6210*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6219*/     /*Scope*/ 16, /*->6236*/
/*  6220*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6221*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6222*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6224*/      OPC_EmitMergeInputChains1_0,
/*  6225*/      OPC_EmitInteger32, 0, 
/*  6227*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6236*/     /*Scope*/ 16, /*->6253*/
/*  6237*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6238*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6239*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6241*/      OPC_EmitMergeInputChains1_0,
/*  6242*/      OPC_EmitInteger32, 0, 
/*  6244*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6253*/     0, /*End of Scope*/
/*  6254*/    0, // EndSwitchType
/*  6255*/   /*Scope*/ 105, /*->6361*/
/*  6256*/    OPC_CheckPredicate6,  // Predicate_load
/*  6257*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->6275
/*  6260*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6261*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6263*/     OPC_EmitMergeInputChains1_0,
/*  6264*/     OPC_EmitInteger32, 0, 
/*  6266*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6275*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->6292
/*  6277*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6278*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6280*/     OPC_EmitMergeInputChains1_0,
/*  6281*/     OPC_EmitInteger32, 0, 
/*  6283*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6292*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->6309
/*  6294*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6295*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6297*/     OPC_EmitMergeInputChains1_0,
/*  6298*/     OPC_EmitInteger32, 0, 
/*  6300*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6309*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->6326
/*  6311*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6312*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6314*/     OPC_EmitMergeInputChains1_0,
/*  6315*/     OPC_EmitInteger32, 0, 
/*  6317*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6326*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->6343
/*  6328*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6329*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6331*/     OPC_EmitMergeInputChains1_0,
/*  6332*/     OPC_EmitInteger32, 0, 
/*  6334*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6343*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->6360
/*  6345*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6346*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6348*/     OPC_EmitMergeInputChains1_0,
/*  6349*/     OPC_EmitInteger32, 0, 
/*  6351*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6360*/    0, // EndSwitchType
/*  6361*/   /*Scope*/ 21, /*->6383*/
/*  6362*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6364*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6366*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6368*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6369*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6371*/    OPC_EmitMergeInputChains1_0,
/*  6372*/    OPC_EmitInteger32, 0, 
/*  6374*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6383*/   /*Scope*/ 21, /*->6405*/
/*  6384*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6386*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6388*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6390*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6391*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6393*/    OPC_EmitMergeInputChains1_0,
/*  6394*/    OPC_EmitInteger32, 0, 
/*  6396*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6405*/   /*Scope*/ 21, /*->6427*/
/*  6406*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6408*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6410*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6412*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6413*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6415*/    OPC_EmitMergeInputChains1_0,
/*  6416*/    OPC_EmitInteger32, 0, 
/*  6418*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6427*/   /*Scope*/ 21, /*->6449*/
/*  6428*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6430*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6432*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6434*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6435*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6437*/    OPC_EmitMergeInputChains1_0,
/*  6438*/    OPC_EmitInteger32, 0, 
/*  6440*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6449*/   /*Scope*/ 21, /*->6471*/
/*  6450*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6452*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6454*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6456*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6457*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6459*/    OPC_EmitMergeInputChains1_0,
/*  6460*/    OPC_EmitInteger32, 0, 
/*  6462*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6471*/   /*Scope*/ 21, /*->6493*/
/*  6472*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6474*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6476*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6478*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6479*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6481*/    OPC_EmitMergeInputChains1_0,
/*  6482*/    OPC_EmitInteger32, 0, 
/*  6484*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6493*/   /*Scope*/ 21, /*->6515*/
/*  6494*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6496*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6498*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6500*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6501*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6503*/    OPC_EmitMergeInputChains1_0,
/*  6504*/    OPC_EmitInteger32, 0, 
/*  6506*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6515*/   /*Scope*/ 21, /*->6537*/
/*  6516*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6518*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6520*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6522*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6523*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6525*/    OPC_EmitMergeInputChains1_0,
/*  6526*/    OPC_EmitInteger32, 0, 
/*  6528*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6537*/   /*Scope*/ 21, /*->6559*/
/*  6538*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6540*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6542*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6544*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6545*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6547*/    OPC_EmitMergeInputChains1_0,
/*  6548*/    OPC_EmitInteger32, 0, 
/*  6550*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6559*/   /*Scope*/ 39, /*->6599*/
/*  6560*/    OPC_CheckPredicate6,  // Predicate_load
/*  6561*/    OPC_SwitchType /*2 cases */, 15, /*MVT::v4f32*/110, // ->6579
/*  6564*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6565*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6567*/     OPC_EmitMergeInputChains1_0,
/*  6568*/     OPC_EmitInteger32, 0, 
/*  6570*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6579*/    /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->6598
/*  6582*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6583*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6585*/     OPC_EmitMergeInputChains1_0,
/*  6586*/     OPC_EmitInteger32, 0, 
/*  6588*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6598*/    0, // EndSwitchType
/*  6599*/   /*Scope*/ 30, /*->6630*/
/*  6600*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6602*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/*  6605*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6606*/    OPC_EmitMergeInputChains1_0,
/*  6607*/    OPC_EmitInteger32, 0, 
/*  6609*/    OPC_EmitInteger32, 0, 
/*  6611*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6620*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 4,  // Results = #5
/*  6627*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6630*/   0, /*End of Scope*/
/*  6631*/  /*Scope*/ 72|128,5/*712*/, /*->7345*/
/*  6633*/   OPC_CheckChild1TypeI64,
/*  6634*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  6636*/   OPC_Scope, 37, /*->6675*/ // 16 children in Scope
/*  6638*/    OPC_CheckPredicate6,  // Predicate_load
/*  6639*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->6657
/*  6642*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6643*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6645*/     OPC_EmitMergeInputChains1_0,
/*  6646*/     OPC_EmitInteger32, 0, 
/*  6648*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6657*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6674
/*  6659*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6660*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6662*/     OPC_EmitMergeInputChains1_0,
/*  6663*/     OPC_EmitInteger32, 0, 
/*  6665*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6674*/    0, // EndSwitchType
/*  6675*/   /*Scope*/ 97, /*->6773*/
/*  6676*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6678*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6717
/*  6681*/     OPC_Scope, 16, /*->6699*/ // 2 children in Scope
/*  6683*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6684*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6685*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6687*/      OPC_EmitMergeInputChains1_0,
/*  6688*/      OPC_EmitInteger32, 0, 
/*  6690*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6699*/     /*Scope*/ 16, /*->6716*/
/*  6700*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6701*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6702*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6704*/      OPC_EmitMergeInputChains1_0,
/*  6705*/      OPC_EmitInteger32, 0, 
/*  6707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6716*/     0, /*End of Scope*/
/*  6717*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6772
/*  6719*/     OPC_Scope, 16, /*->6737*/ // 3 children in Scope
/*  6721*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6722*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6723*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6725*/      OPC_EmitMergeInputChains1_0,
/*  6726*/      OPC_EmitInteger32, 0, 
/*  6728*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6737*/     /*Scope*/ 16, /*->6754*/
/*  6738*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6739*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6740*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6742*/      OPC_EmitMergeInputChains1_0,
/*  6743*/      OPC_EmitInteger32, 0, 
/*  6745*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6754*/     /*Scope*/ 16, /*->6771*/
/*  6755*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6756*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6757*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6759*/      OPC_EmitMergeInputChains1_0,
/*  6760*/      OPC_EmitInteger32, 0, 
/*  6762*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6771*/     0, /*End of Scope*/
/*  6772*/    0, // EndSwitchType
/*  6773*/   /*Scope*/ 97, /*->6871*/
/*  6774*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6776*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6815
/*  6779*/     OPC_Scope, 16, /*->6797*/ // 2 children in Scope
/*  6781*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6782*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6783*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6785*/      OPC_EmitMergeInputChains1_0,
/*  6786*/      OPC_EmitInteger32, 0, 
/*  6788*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6797*/     /*Scope*/ 16, /*->6814*/
/*  6798*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6799*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6800*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6802*/      OPC_EmitMergeInputChains1_0,
/*  6803*/      OPC_EmitInteger32, 0, 
/*  6805*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6814*/     0, /*End of Scope*/
/*  6815*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6870
/*  6817*/     OPC_Scope, 16, /*->6835*/ // 3 children in Scope
/*  6819*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6820*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6823*/      OPC_EmitMergeInputChains1_0,
/*  6824*/      OPC_EmitInteger32, 0, 
/*  6826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6835*/     /*Scope*/ 16, /*->6852*/
/*  6836*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6837*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6838*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6840*/      OPC_EmitMergeInputChains1_0,
/*  6841*/      OPC_EmitInteger32, 0, 
/*  6843*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6852*/     /*Scope*/ 16, /*->6869*/
/*  6853*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6854*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6855*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6857*/      OPC_EmitMergeInputChains1_0,
/*  6858*/      OPC_EmitInteger32, 0, 
/*  6860*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6869*/     0, /*End of Scope*/
/*  6870*/    0, // EndSwitchType
/*  6871*/   /*Scope*/ 97, /*->6969*/
/*  6872*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6874*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6913
/*  6877*/     OPC_Scope, 16, /*->6895*/ // 2 children in Scope
/*  6879*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6880*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6881*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6883*/      OPC_EmitMergeInputChains1_0,
/*  6884*/      OPC_EmitInteger32, 0, 
/*  6886*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6895*/     /*Scope*/ 16, /*->6912*/
/*  6896*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6897*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6898*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6900*/      OPC_EmitMergeInputChains1_0,
/*  6901*/      OPC_EmitInteger32, 0, 
/*  6903*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6912*/     0, /*End of Scope*/
/*  6913*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6968
/*  6915*/     OPC_Scope, 16, /*->6933*/ // 3 children in Scope
/*  6917*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6918*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6919*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6921*/      OPC_EmitMergeInputChains1_0,
/*  6922*/      OPC_EmitInteger32, 0, 
/*  6924*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6933*/     /*Scope*/ 16, /*->6950*/
/*  6934*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6935*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6936*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6938*/      OPC_EmitMergeInputChains1_0,
/*  6939*/      OPC_EmitInteger32, 0, 
/*  6941*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6950*/     /*Scope*/ 16, /*->6967*/
/*  6951*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6952*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6953*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6955*/      OPC_EmitMergeInputChains1_0,
/*  6956*/      OPC_EmitInteger32, 0, 
/*  6958*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6967*/     0, /*End of Scope*/
/*  6968*/    0, // EndSwitchType
/*  6969*/   /*Scope*/ 105, /*->7075*/
/*  6970*/    OPC_CheckPredicate6,  // Predicate_load
/*  6971*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->6989
/*  6974*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6975*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6977*/     OPC_EmitMergeInputChains1_0,
/*  6978*/     OPC_EmitInteger32, 0, 
/*  6980*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6989*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->7006
/*  6991*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6992*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6994*/     OPC_EmitMergeInputChains1_0,
/*  6995*/     OPC_EmitInteger32, 0, 
/*  6997*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7006*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->7023
/*  7008*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7009*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7011*/     OPC_EmitMergeInputChains1_0,
/*  7012*/     OPC_EmitInteger32, 0, 
/*  7014*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7023*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->7040
/*  7025*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7026*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7028*/     OPC_EmitMergeInputChains1_0,
/*  7029*/     OPC_EmitInteger32, 0, 
/*  7031*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7040*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->7057
/*  7042*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7043*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7045*/     OPC_EmitMergeInputChains1_0,
/*  7046*/     OPC_EmitInteger32, 0, 
/*  7048*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7057*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->7074
/*  7059*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7060*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7062*/     OPC_EmitMergeInputChains1_0,
/*  7063*/     OPC_EmitInteger32, 0, 
/*  7065*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7074*/    0, // EndSwitchType
/*  7075*/   /*Scope*/ 21, /*->7097*/
/*  7076*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7078*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7080*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7082*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7083*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7085*/    OPC_EmitMergeInputChains1_0,
/*  7086*/    OPC_EmitInteger32, 0, 
/*  7088*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7097*/   /*Scope*/ 21, /*->7119*/
/*  7098*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7100*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7102*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7104*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7105*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7107*/    OPC_EmitMergeInputChains1_0,
/*  7108*/    OPC_EmitInteger32, 0, 
/*  7110*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7119*/   /*Scope*/ 21, /*->7141*/
/*  7120*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7122*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7124*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7126*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7127*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7129*/    OPC_EmitMergeInputChains1_0,
/*  7130*/    OPC_EmitInteger32, 0, 
/*  7132*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7141*/   /*Scope*/ 21, /*->7163*/
/*  7142*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7144*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7146*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7148*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7149*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7151*/    OPC_EmitMergeInputChains1_0,
/*  7152*/    OPC_EmitInteger32, 0, 
/*  7154*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7163*/   /*Scope*/ 21, /*->7185*/
/*  7164*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7166*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7168*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7170*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7171*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7173*/    OPC_EmitMergeInputChains1_0,
/*  7174*/    OPC_EmitInteger32, 0, 
/*  7176*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7185*/   /*Scope*/ 21, /*->7207*/
/*  7186*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7188*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7190*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7192*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7193*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7195*/    OPC_EmitMergeInputChains1_0,
/*  7196*/    OPC_EmitInteger32, 0, 
/*  7198*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7207*/   /*Scope*/ 21, /*->7229*/
/*  7208*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7210*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7212*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7214*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7215*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7217*/    OPC_EmitMergeInputChains1_0,
/*  7218*/    OPC_EmitInteger32, 0, 
/*  7220*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7229*/   /*Scope*/ 21, /*->7251*/
/*  7230*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7232*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7234*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7236*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7237*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7239*/    OPC_EmitMergeInputChains1_0,
/*  7240*/    OPC_EmitInteger32, 0, 
/*  7242*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7251*/   /*Scope*/ 21, /*->7273*/
/*  7252*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7254*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7256*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7258*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7259*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7261*/    OPC_EmitMergeInputChains1_0,
/*  7262*/    OPC_EmitInteger32, 0, 
/*  7264*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7273*/   /*Scope*/ 39, /*->7313*/
/*  7274*/    OPC_CheckPredicate6,  // Predicate_load
/*  7275*/    OPC_SwitchType /*2 cases */, 15, /*MVT::v4f32*/110, // ->7293
/*  7278*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7279*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7281*/     OPC_EmitMergeInputChains1_0,
/*  7282*/     OPC_EmitInteger32, 0, 
/*  7284*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7293*/    /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->7312
/*  7296*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7297*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7299*/     OPC_EmitMergeInputChains1_0,
/*  7300*/     OPC_EmitInteger32, 0, 
/*  7302*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7312*/    0, // EndSwitchType
/*  7313*/   /*Scope*/ 30, /*->7344*/
/*  7314*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7316*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/*  7319*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7320*/    OPC_EmitMergeInputChains1_0,
/*  7321*/    OPC_EmitInteger32, 0, 
/*  7323*/    OPC_EmitInteger64, 0, 
/*  7325*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7334*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 4,  // Results = #5
/*  7341*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7344*/   0, /*End of Scope*/
/*  7345*/  0, /*End of Scope*/
/*  7346*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7509
/*  7350*/  OPC_RecordMemRef,
/*  7351*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7352*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7353*/  OPC_Scope, 76, /*->7431*/ // 2 children in Scope
/*  7355*/   OPC_CheckChild1TypeI32,
/*  7356*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7412
/*  7359*/    OPC_Scope, 16, /*->7377*/ // 3 children in Scope
/*  7361*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7362*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7363*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7365*/     OPC_EmitMergeInputChains1_0,
/*  7366*/     OPC_EmitInteger32, 0, 
/*  7368*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7377*/    /*Scope*/ 16, /*->7394*/
/*  7378*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7379*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7380*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7382*/     OPC_EmitMergeInputChains1_0,
/*  7383*/     OPC_EmitInteger32, 0, 
/*  7385*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7394*/    /*Scope*/ 16, /*->7411*/
/*  7395*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7396*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7397*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7399*/     OPC_EmitMergeInputChains1_0,
/*  7400*/     OPC_EmitInteger32, 0, 
/*  7402*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7411*/    0, /*End of Scope*/
/*  7412*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7430
/*  7414*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7415*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7416*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7418*/    OPC_EmitMergeInputChains1_0,
/*  7419*/    OPC_EmitInteger32, 0, 
/*  7421*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7430*/   0, // EndSwitchType
/*  7431*/  /*Scope*/ 76, /*->7508*/
/*  7432*/   OPC_CheckChild1TypeI64,
/*  7433*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7489
/*  7436*/    OPC_Scope, 16, /*->7454*/ // 3 children in Scope
/*  7438*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7439*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7440*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7442*/     OPC_EmitMergeInputChains1_0,
/*  7443*/     OPC_EmitInteger32, 0, 
/*  7445*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7454*/    /*Scope*/ 16, /*->7471*/
/*  7455*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7456*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7457*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7459*/     OPC_EmitMergeInputChains1_0,
/*  7460*/     OPC_EmitInteger32, 0, 
/*  7462*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7471*/    /*Scope*/ 16, /*->7488*/
/*  7472*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7473*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7474*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7476*/     OPC_EmitMergeInputChains1_0,
/*  7477*/     OPC_EmitInteger32, 0, 
/*  7479*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7488*/    0, /*End of Scope*/
/*  7489*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7507
/*  7491*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7492*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7493*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7495*/    OPC_EmitMergeInputChains1_0,
/*  7496*/    OPC_EmitInteger32, 0, 
/*  7498*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7507*/   0, // EndSwitchType
/*  7508*/  0, /*End of Scope*/
/*  7509*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7754
/*  7513*/  OPC_RecordMemRef,
/*  7514*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7515*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7516*/  OPC_Scope, 117, /*->7635*/ // 2 children in Scope
/*  7518*/   OPC_CheckChild1TypeI32,
/*  7519*/   OPC_RecordChild2, // #2 = $val
/*  7520*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7615
/*  7523*/    OPC_Scope, 17, /*->7542*/ // 5 children in Scope
/*  7525*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7526*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7527*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7529*/     OPC_EmitMergeInputChains1_0,
/*  7530*/     OPC_EmitInteger32, 0, 
/*  7532*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7542*/    /*Scope*/ 17, /*->7560*/
/*  7543*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7544*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7545*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7547*/     OPC_EmitMergeInputChains1_0,
/*  7548*/     OPC_EmitInteger32, 0, 
/*  7550*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7560*/    /*Scope*/ 17, /*->7578*/
/*  7561*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7562*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7563*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7565*/     OPC_EmitMergeInputChains1_0,
/*  7566*/     OPC_EmitInteger32, 0, 
/*  7568*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7578*/    /*Scope*/ 17, /*->7596*/
/*  7579*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7580*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7581*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7583*/     OPC_EmitMergeInputChains1_0,
/*  7584*/     OPC_EmitInteger32, 0, 
/*  7586*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7596*/    /*Scope*/ 17, /*->7614*/
/*  7597*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7598*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7599*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7601*/     OPC_EmitMergeInputChains1_0,
/*  7602*/     OPC_EmitInteger32, 0, 
/*  7604*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7614*/    0, /*End of Scope*/
/*  7615*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7634
/*  7617*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7618*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7619*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7621*/    OPC_EmitMergeInputChains1_0,
/*  7622*/    OPC_EmitInteger32, 0, 
/*  7624*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7634*/   0, // EndSwitchType
/*  7635*/  /*Scope*/ 117, /*->7753*/
/*  7636*/   OPC_CheckChild1TypeI64,
/*  7637*/   OPC_RecordChild2, // #2 = $val
/*  7638*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7733
/*  7641*/    OPC_Scope, 17, /*->7660*/ // 5 children in Scope
/*  7643*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7644*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7645*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7647*/     OPC_EmitMergeInputChains1_0,
/*  7648*/     OPC_EmitInteger32, 0, 
/*  7650*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7660*/    /*Scope*/ 17, /*->7678*/
/*  7661*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7662*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7663*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7665*/     OPC_EmitMergeInputChains1_0,
/*  7666*/     OPC_EmitInteger32, 0, 
/*  7668*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7678*/    /*Scope*/ 17, /*->7696*/
/*  7679*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7680*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7681*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7683*/     OPC_EmitMergeInputChains1_0,
/*  7684*/     OPC_EmitInteger32, 0, 
/*  7686*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7696*/    /*Scope*/ 17, /*->7714*/
/*  7697*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7698*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7699*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7701*/     OPC_EmitMergeInputChains1_0,
/*  7702*/     OPC_EmitInteger32, 0, 
/*  7704*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7714*/    /*Scope*/ 17, /*->7732*/
/*  7715*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7716*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7717*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7719*/     OPC_EmitMergeInputChains1_0,
/*  7720*/     OPC_EmitInteger32, 0, 
/*  7722*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7732*/    0, /*End of Scope*/
/*  7733*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7752
/*  7735*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7736*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7737*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7739*/    OPC_EmitMergeInputChains1_0,
/*  7740*/    OPC_EmitInteger32, 0, 
/*  7742*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7752*/   0, // EndSwitchType
/*  7753*/  0, /*End of Scope*/
/*  7754*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->7999
/*  7758*/  OPC_RecordMemRef,
/*  7759*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7760*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7761*/  OPC_Scope, 117, /*->7880*/ // 2 children in Scope
/*  7763*/   OPC_CheckChild1TypeI32,
/*  7764*/   OPC_RecordChild2, // #2 = $val
/*  7765*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7860
/*  7768*/    OPC_Scope, 17, /*->7787*/ // 5 children in Scope
/*  7770*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7771*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7772*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7774*/     OPC_EmitMergeInputChains1_0,
/*  7775*/     OPC_EmitInteger32, 0, 
/*  7777*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7787*/    /*Scope*/ 17, /*->7805*/
/*  7788*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7789*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7790*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7792*/     OPC_EmitMergeInputChains1_0,
/*  7793*/     OPC_EmitInteger32, 0, 
/*  7795*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7805*/    /*Scope*/ 17, /*->7823*/
/*  7806*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7807*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7808*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7810*/     OPC_EmitMergeInputChains1_0,
/*  7811*/     OPC_EmitInteger32, 0, 
/*  7813*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7823*/    /*Scope*/ 17, /*->7841*/
/*  7824*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7825*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7826*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7828*/     OPC_EmitMergeInputChains1_0,
/*  7829*/     OPC_EmitInteger32, 0, 
/*  7831*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7841*/    /*Scope*/ 17, /*->7859*/
/*  7842*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7843*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7844*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7846*/     OPC_EmitMergeInputChains1_0,
/*  7847*/     OPC_EmitInteger32, 0, 
/*  7849*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7859*/    0, /*End of Scope*/
/*  7860*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7879
/*  7862*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  7863*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7864*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7866*/    OPC_EmitMergeInputChains1_0,
/*  7867*/    OPC_EmitInteger32, 0, 
/*  7869*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7879*/   0, // EndSwitchType
/*  7880*/  /*Scope*/ 117, /*->7998*/
/*  7881*/   OPC_CheckChild1TypeI64,
/*  7882*/   OPC_RecordChild2, // #2 = $val
/*  7883*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7978
/*  7886*/    OPC_Scope, 17, /*->7905*/ // 5 children in Scope
/*  7888*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7889*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7890*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7892*/     OPC_EmitMergeInputChains1_0,
/*  7893*/     OPC_EmitInteger32, 0, 
/*  7895*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7905*/    /*Scope*/ 17, /*->7923*/
/*  7906*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7907*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7908*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7910*/     OPC_EmitMergeInputChains1_0,
/*  7911*/     OPC_EmitInteger32, 0, 
/*  7913*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7923*/    /*Scope*/ 17, /*->7941*/
/*  7924*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7925*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7926*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7928*/     OPC_EmitMergeInputChains1_0,
/*  7929*/     OPC_EmitInteger32, 0, 
/*  7931*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7941*/    /*Scope*/ 17, /*->7959*/
/*  7942*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7943*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7944*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7946*/     OPC_EmitMergeInputChains1_0,
/*  7947*/     OPC_EmitInteger32, 0, 
/*  7949*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7959*/    /*Scope*/ 17, /*->7977*/
/*  7960*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7961*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7962*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7964*/     OPC_EmitMergeInputChains1_0,
/*  7965*/     OPC_EmitInteger32, 0, 
/*  7967*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7977*/    0, /*End of Scope*/
/*  7978*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7997
/*  7980*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  7981*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7982*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7984*/    OPC_EmitMergeInputChains1_0,
/*  7985*/    OPC_EmitInteger32, 0, 
/*  7987*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7997*/   0, // EndSwitchType
/*  7998*/  0, /*End of Scope*/
/*  7999*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8244
/*  8003*/  OPC_RecordMemRef,
/*  8004*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8005*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8006*/  OPC_Scope, 117, /*->8125*/ // 2 children in Scope
/*  8008*/   OPC_CheckChild1TypeI32,
/*  8009*/   OPC_RecordChild2, // #2 = $val
/*  8010*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8105
/*  8013*/    OPC_Scope, 17, /*->8032*/ // 5 children in Scope
/*  8015*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8016*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8017*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8019*/     OPC_EmitMergeInputChains1_0,
/*  8020*/     OPC_EmitInteger32, 0, 
/*  8022*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8032*/    /*Scope*/ 17, /*->8050*/
/*  8033*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8034*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8035*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8037*/     OPC_EmitMergeInputChains1_0,
/*  8038*/     OPC_EmitInteger32, 0, 
/*  8040*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8050*/    /*Scope*/ 17, /*->8068*/
/*  8051*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8052*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8053*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8055*/     OPC_EmitMergeInputChains1_0,
/*  8056*/     OPC_EmitInteger32, 0, 
/*  8058*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8068*/    /*Scope*/ 17, /*->8086*/
/*  8069*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8070*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8071*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8073*/     OPC_EmitMergeInputChains1_0,
/*  8074*/     OPC_EmitInteger32, 0, 
/*  8076*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8086*/    /*Scope*/ 17, /*->8104*/
/*  8087*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8088*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8089*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8091*/     OPC_EmitMergeInputChains1_0,
/*  8092*/     OPC_EmitInteger32, 0, 
/*  8094*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8104*/    0, /*End of Scope*/
/*  8105*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8124
/*  8107*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8108*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8109*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8111*/    OPC_EmitMergeInputChains1_0,
/*  8112*/    OPC_EmitInteger32, 0, 
/*  8114*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8124*/   0, // EndSwitchType
/*  8125*/  /*Scope*/ 117, /*->8243*/
/*  8126*/   OPC_CheckChild1TypeI64,
/*  8127*/   OPC_RecordChild2, // #2 = $val
/*  8128*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8223
/*  8131*/    OPC_Scope, 17, /*->8150*/ // 5 children in Scope
/*  8133*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8134*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8135*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8137*/     OPC_EmitMergeInputChains1_0,
/*  8138*/     OPC_EmitInteger32, 0, 
/*  8140*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8150*/    /*Scope*/ 17, /*->8168*/
/*  8151*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8152*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8153*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8155*/     OPC_EmitMergeInputChains1_0,
/*  8156*/     OPC_EmitInteger32, 0, 
/*  8158*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8168*/    /*Scope*/ 17, /*->8186*/
/*  8169*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8170*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8171*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8173*/     OPC_EmitMergeInputChains1_0,
/*  8174*/     OPC_EmitInteger32, 0, 
/*  8176*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8186*/    /*Scope*/ 17, /*->8204*/
/*  8187*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8188*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8189*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8191*/     OPC_EmitMergeInputChains1_0,
/*  8192*/     OPC_EmitInteger32, 0, 
/*  8194*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8204*/    /*Scope*/ 17, /*->8222*/
/*  8205*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8206*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8207*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8209*/     OPC_EmitMergeInputChains1_0,
/*  8210*/     OPC_EmitInteger32, 0, 
/*  8212*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8222*/    0, /*End of Scope*/
/*  8223*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8242
/*  8225*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8226*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8227*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8229*/    OPC_EmitMergeInputChains1_0,
/*  8230*/    OPC_EmitInteger32, 0, 
/*  8232*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8242*/   0, // EndSwitchType
/*  8243*/  0, /*End of Scope*/
/*  8244*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8489
/*  8248*/  OPC_RecordMemRef,
/*  8249*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8250*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8251*/  OPC_Scope, 117, /*->8370*/ // 2 children in Scope
/*  8253*/   OPC_CheckChild1TypeI32,
/*  8254*/   OPC_RecordChild2, // #2 = $val
/*  8255*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8350
/*  8258*/    OPC_Scope, 17, /*->8277*/ // 5 children in Scope
/*  8260*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8261*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8262*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8264*/     OPC_EmitMergeInputChains1_0,
/*  8265*/     OPC_EmitInteger32, 0, 
/*  8267*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8277*/    /*Scope*/ 17, /*->8295*/
/*  8278*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8279*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8280*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8282*/     OPC_EmitMergeInputChains1_0,
/*  8283*/     OPC_EmitInteger32, 0, 
/*  8285*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8295*/    /*Scope*/ 17, /*->8313*/
/*  8296*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8297*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8298*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8300*/     OPC_EmitMergeInputChains1_0,
/*  8301*/     OPC_EmitInteger32, 0, 
/*  8303*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8313*/    /*Scope*/ 17, /*->8331*/
/*  8314*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8315*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8316*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8318*/     OPC_EmitMergeInputChains1_0,
/*  8319*/     OPC_EmitInteger32, 0, 
/*  8321*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8331*/    /*Scope*/ 17, /*->8349*/
/*  8332*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8333*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8334*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8336*/     OPC_EmitMergeInputChains1_0,
/*  8337*/     OPC_EmitInteger32, 0, 
/*  8339*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8349*/    0, /*End of Scope*/
/*  8350*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8369
/*  8352*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8353*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8354*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8356*/    OPC_EmitMergeInputChains1_0,
/*  8357*/    OPC_EmitInteger32, 0, 
/*  8359*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8369*/   0, // EndSwitchType
/*  8370*/  /*Scope*/ 117, /*->8488*/
/*  8371*/   OPC_CheckChild1TypeI64,
/*  8372*/   OPC_RecordChild2, // #2 = $val
/*  8373*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8468
/*  8376*/    OPC_Scope, 17, /*->8395*/ // 5 children in Scope
/*  8378*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8379*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8380*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8382*/     OPC_EmitMergeInputChains1_0,
/*  8383*/     OPC_EmitInteger32, 0, 
/*  8385*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8395*/    /*Scope*/ 17, /*->8413*/
/*  8396*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8397*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8398*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8400*/     OPC_EmitMergeInputChains1_0,
/*  8401*/     OPC_EmitInteger32, 0, 
/*  8403*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8413*/    /*Scope*/ 17, /*->8431*/
/*  8414*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8415*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8416*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8418*/     OPC_EmitMergeInputChains1_0,
/*  8419*/     OPC_EmitInteger32, 0, 
/*  8421*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8431*/    /*Scope*/ 17, /*->8449*/
/*  8432*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8433*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8434*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8436*/     OPC_EmitMergeInputChains1_0,
/*  8437*/     OPC_EmitInteger32, 0, 
/*  8439*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8449*/    /*Scope*/ 17, /*->8467*/
/*  8450*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8451*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8452*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8454*/     OPC_EmitMergeInputChains1_0,
/*  8455*/     OPC_EmitInteger32, 0, 
/*  8457*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8467*/    0, /*End of Scope*/
/*  8468*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8487
/*  8470*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8471*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8472*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8474*/    OPC_EmitMergeInputChains1_0,
/*  8475*/    OPC_EmitInteger32, 0, 
/*  8477*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8487*/   0, // EndSwitchType
/*  8488*/  0, /*End of Scope*/
/*  8489*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8734
/*  8493*/  OPC_RecordMemRef,
/*  8494*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8495*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8496*/  OPC_Scope, 117, /*->8615*/ // 2 children in Scope
/*  8498*/   OPC_CheckChild1TypeI32,
/*  8499*/   OPC_RecordChild2, // #2 = $val
/*  8500*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8595
/*  8503*/    OPC_Scope, 17, /*->8522*/ // 5 children in Scope
/*  8505*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8506*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8507*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8509*/     OPC_EmitMergeInputChains1_0,
/*  8510*/     OPC_EmitInteger32, 0, 
/*  8512*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8522*/    /*Scope*/ 17, /*->8540*/
/*  8523*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8524*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8525*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8527*/     OPC_EmitMergeInputChains1_0,
/*  8528*/     OPC_EmitInteger32, 0, 
/*  8530*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8540*/    /*Scope*/ 17, /*->8558*/
/*  8541*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8542*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8543*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8545*/     OPC_EmitMergeInputChains1_0,
/*  8546*/     OPC_EmitInteger32, 0, 
/*  8548*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8558*/    /*Scope*/ 17, /*->8576*/
/*  8559*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8560*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8561*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8563*/     OPC_EmitMergeInputChains1_0,
/*  8564*/     OPC_EmitInteger32, 0, 
/*  8566*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8576*/    /*Scope*/ 17, /*->8594*/
/*  8577*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8578*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8579*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8581*/     OPC_EmitMergeInputChains1_0,
/*  8582*/     OPC_EmitInteger32, 0, 
/*  8584*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8594*/    0, /*End of Scope*/
/*  8595*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8614
/*  8597*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8598*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8599*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8601*/    OPC_EmitMergeInputChains1_0,
/*  8602*/    OPC_EmitInteger32, 0, 
/*  8604*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8614*/   0, // EndSwitchType
/*  8615*/  /*Scope*/ 117, /*->8733*/
/*  8616*/   OPC_CheckChild1TypeI64,
/*  8617*/   OPC_RecordChild2, // #2 = $val
/*  8618*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8713
/*  8621*/    OPC_Scope, 17, /*->8640*/ // 5 children in Scope
/*  8623*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8624*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8625*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8627*/     OPC_EmitMergeInputChains1_0,
/*  8628*/     OPC_EmitInteger32, 0, 
/*  8630*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8640*/    /*Scope*/ 17, /*->8658*/
/*  8641*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8642*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8643*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8645*/     OPC_EmitMergeInputChains1_0,
/*  8646*/     OPC_EmitInteger32, 0, 
/*  8648*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8658*/    /*Scope*/ 17, /*->8676*/
/*  8659*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8660*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8661*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8663*/     OPC_EmitMergeInputChains1_0,
/*  8664*/     OPC_EmitInteger32, 0, 
/*  8666*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8676*/    /*Scope*/ 17, /*->8694*/
/*  8677*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8678*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8679*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8681*/     OPC_EmitMergeInputChains1_0,
/*  8682*/     OPC_EmitInteger32, 0, 
/*  8684*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8694*/    /*Scope*/ 17, /*->8712*/
/*  8695*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8696*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8697*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8699*/     OPC_EmitMergeInputChains1_0,
/*  8700*/     OPC_EmitInteger32, 0, 
/*  8702*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8712*/    0, /*End of Scope*/
/*  8713*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8732
/*  8715*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8716*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8717*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8719*/    OPC_EmitMergeInputChains1_0,
/*  8720*/    OPC_EmitInteger32, 0, 
/*  8722*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8732*/   0, // EndSwitchType
/*  8733*/  0, /*End of Scope*/
/*  8734*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->8979
/*  8738*/  OPC_RecordMemRef,
/*  8739*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8740*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8741*/  OPC_Scope, 117, /*->8860*/ // 2 children in Scope
/*  8743*/   OPC_CheckChild1TypeI32,
/*  8744*/   OPC_RecordChild2, // #2 = $val
/*  8745*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8840
/*  8748*/    OPC_Scope, 17, /*->8767*/ // 5 children in Scope
/*  8750*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8751*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8752*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8754*/     OPC_EmitMergeInputChains1_0,
/*  8755*/     OPC_EmitInteger32, 0, 
/*  8757*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8767*/    /*Scope*/ 17, /*->8785*/
/*  8768*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8769*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8770*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8772*/     OPC_EmitMergeInputChains1_0,
/*  8773*/     OPC_EmitInteger32, 0, 
/*  8775*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8785*/    /*Scope*/ 17, /*->8803*/
/*  8786*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8787*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8788*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8790*/     OPC_EmitMergeInputChains1_0,
/*  8791*/     OPC_EmitInteger32, 0, 
/*  8793*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8803*/    /*Scope*/ 17, /*->8821*/
/*  8804*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8805*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8806*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8808*/     OPC_EmitMergeInputChains1_0,
/*  8809*/     OPC_EmitInteger32, 0, 
/*  8811*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8821*/    /*Scope*/ 17, /*->8839*/
/*  8822*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8823*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8824*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8826*/     OPC_EmitMergeInputChains1_0,
/*  8827*/     OPC_EmitInteger32, 0, 
/*  8829*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8839*/    0, /*End of Scope*/
/*  8840*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8859
/*  8842*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  8843*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8844*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8846*/    OPC_EmitMergeInputChains1_0,
/*  8847*/    OPC_EmitInteger32, 0, 
/*  8849*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8859*/   0, // EndSwitchType
/*  8860*/  /*Scope*/ 117, /*->8978*/
/*  8861*/   OPC_CheckChild1TypeI64,
/*  8862*/   OPC_RecordChild2, // #2 = $val
/*  8863*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8958
/*  8866*/    OPC_Scope, 17, /*->8885*/ // 5 children in Scope
/*  8868*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8869*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8870*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8872*/     OPC_EmitMergeInputChains1_0,
/*  8873*/     OPC_EmitInteger32, 0, 
/*  8875*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8885*/    /*Scope*/ 17, /*->8903*/
/*  8886*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8887*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8888*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8890*/     OPC_EmitMergeInputChains1_0,
/*  8891*/     OPC_EmitInteger32, 0, 
/*  8893*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8903*/    /*Scope*/ 17, /*->8921*/
/*  8904*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8905*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8906*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8908*/     OPC_EmitMergeInputChains1_0,
/*  8909*/     OPC_EmitInteger32, 0, 
/*  8911*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8921*/    /*Scope*/ 17, /*->8939*/
/*  8922*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8923*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8924*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8926*/     OPC_EmitMergeInputChains1_0,
/*  8927*/     OPC_EmitInteger32, 0, 
/*  8929*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8939*/    /*Scope*/ 17, /*->8957*/
/*  8940*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8941*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8942*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8944*/     OPC_EmitMergeInputChains1_0,
/*  8945*/     OPC_EmitInteger32, 0, 
/*  8947*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8957*/    0, /*End of Scope*/
/*  8958*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8977
/*  8960*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  8961*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8962*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8964*/    OPC_EmitMergeInputChains1_0,
/*  8965*/    OPC_EmitInteger32, 0, 
/*  8967*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8977*/   0, // EndSwitchType
/*  8978*/  0, /*End of Scope*/
/*  8979*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9238
/*  8983*/  OPC_RecordMemRef,
/*  8984*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  8985*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8986*/  OPC_Scope, 124, /*->9112*/ // 2 children in Scope
/*  8988*/   OPC_CheckChild1TypeI32,
/*  8989*/   OPC_RecordChild2, // #2 = $exp
/*  8990*/   OPC_RecordChild3, // #3 = $new
/*  8991*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9091
/*  8994*/    OPC_Scope, 18, /*->9014*/ // 5 children in Scope
/*  8996*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  8997*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8998*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9000*/     OPC_EmitMergeInputChains1_0,
/*  9001*/     OPC_EmitInteger32, 0, 
/*  9003*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9014*/    /*Scope*/ 18, /*->9033*/
/*  9015*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9016*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9017*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9019*/     OPC_EmitMergeInputChains1_0,
/*  9020*/     OPC_EmitInteger32, 0, 
/*  9022*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9033*/    /*Scope*/ 18, /*->9052*/
/*  9034*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9035*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9036*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9038*/     OPC_EmitMergeInputChains1_0,
/*  9039*/     OPC_EmitInteger32, 0, 
/*  9041*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9052*/    /*Scope*/ 18, /*->9071*/
/*  9053*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9054*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9055*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9057*/     OPC_EmitMergeInputChains1_0,
/*  9058*/     OPC_EmitInteger32, 0, 
/*  9060*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9071*/    /*Scope*/ 18, /*->9090*/
/*  9072*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9073*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9074*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9076*/     OPC_EmitMergeInputChains1_0,
/*  9077*/     OPC_EmitInteger32, 0, 
/*  9079*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9090*/    0, /*End of Scope*/
/*  9091*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9111
/*  9093*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9094*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9095*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9097*/    OPC_EmitMergeInputChains1_0,
/*  9098*/    OPC_EmitInteger32, 0, 
/*  9100*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9111*/   0, // EndSwitchType
/*  9112*/  /*Scope*/ 124, /*->9237*/
/*  9113*/   OPC_CheckChild1TypeI64,
/*  9114*/   OPC_RecordChild2, // #2 = $exp
/*  9115*/   OPC_RecordChild3, // #3 = $new
/*  9116*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9216
/*  9119*/    OPC_Scope, 18, /*->9139*/ // 5 children in Scope
/*  9121*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9122*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9123*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9125*/     OPC_EmitMergeInputChains1_0,
/*  9126*/     OPC_EmitInteger32, 0, 
/*  9128*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9139*/    /*Scope*/ 18, /*->9158*/
/*  9140*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9141*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9142*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9144*/     OPC_EmitMergeInputChains1_0,
/*  9145*/     OPC_EmitInteger32, 0, 
/*  9147*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9158*/    /*Scope*/ 18, /*->9177*/
/*  9159*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9160*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9161*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9163*/     OPC_EmitMergeInputChains1_0,
/*  9164*/     OPC_EmitInteger32, 0, 
/*  9166*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9177*/    /*Scope*/ 18, /*->9196*/
/*  9178*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9179*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9180*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9182*/     OPC_EmitMergeInputChains1_0,
/*  9183*/     OPC_EmitInteger32, 0, 
/*  9185*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9196*/    /*Scope*/ 18, /*->9215*/
/*  9197*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9198*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9199*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9201*/     OPC_EmitMergeInputChains1_0,
/*  9202*/     OPC_EmitInteger32, 0, 
/*  9204*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9215*/    0, /*End of Scope*/
/*  9216*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9236
/*  9218*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9219*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9220*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9222*/    OPC_EmitMergeInputChains1_0,
/*  9223*/    OPC_EmitInteger32, 0, 
/*  9225*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9236*/   0, // EndSwitchType
/*  9237*/  0, /*End of Scope*/
/*  9238*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9330
/*  9241*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9242*/  OPC_Scope, 69, /*->9313*/ // 2 children in Scope
/*  9244*/   OPC_MoveChild1,
/*  9245*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9270
/*  9249*/    OPC_RecordChild0, // #1 = $cond
/*  9250*/    OPC_MoveChild0,
/*  9251*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9253*/    OPC_MoveParent,
/*  9254*/    OPC_CheckChild1Integer, 2, 
/*  9256*/    OPC_CheckTypeI32,
/*  9257*/    OPC_MoveSibling2,
/*  9258*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9261*/    OPC_RecordNode, // #2 = $dst
/*  9262*/    OPC_MoveParent,
/*  9263*/    OPC_EmitMergeInputChains1_0,
/*  9264*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9270*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9312
/*  9273*/    OPC_RecordChild0, // #1 = $cond
/*  9274*/    OPC_CheckChild0TypeI32,
/*  9275*/    OPC_CheckChild1Integer, 0, 
/*  9277*/    OPC_CheckTypeI32,
/*  9278*/    OPC_Scope, 15, /*->9295*/ // 2 children in Scope
/*  9280*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9282*/     OPC_MoveSibling2,
/*  9283*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9286*/     OPC_RecordNode, // #2 = $dst
/*  9287*/     OPC_MoveParent,
/*  9288*/     OPC_EmitMergeInputChains1_0,
/*  9289*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9295*/    /*Scope*/ 15, /*->9311*/
/*  9296*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9298*/     OPC_MoveSibling2,
/*  9299*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9302*/     OPC_RecordNode, // #2 = $dst
/*  9303*/     OPC_MoveParent,
/*  9304*/     OPC_EmitMergeInputChains1_0,
/*  9305*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9311*/    0, /*End of Scope*/
/*  9312*/   0, // EndSwitchOpcode
/*  9313*/  /*Scope*/ 15, /*->9329*/
/*  9314*/   OPC_RecordChild1, // #1 = $cond
/*  9315*/   OPC_CheckChild1TypeI32,
/*  9316*/   OPC_RecordChild2, // #2 = $dst
/*  9317*/   OPC_MoveChild2,
/*  9318*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9321*/   OPC_MoveParent,
/*  9322*/   OPC_EmitMergeInputChains1_0,
/*  9323*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9329*/  0, /*End of Scope*/
/*  9330*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9392
/*  9333*/  OPC_RecordChild0, // #0 = $lhs
/*  9334*/  OPC_Scope, 31, /*->9367*/ // 2 children in Scope
/*  9336*/   OPC_MoveChild1,
/*  9337*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9352
/*  9340*/    OPC_CheckAndImm, 31, 
/*  9342*/    OPC_RecordChild0, // #1 = $rhs
/*  9343*/    OPC_MoveParent,
/*  9344*/    OPC_CheckTypeI32,
/*  9345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9352*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9366
/*  9354*/    OPC_CheckAndImm, 63, 
/*  9356*/    OPC_RecordChild0, // #1 = $rhs
/*  9357*/    OPC_MoveParent,
/*  9358*/    OPC_CheckTypeI64,
/*  9359*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9366*/   0, // EndSwitchType
/*  9367*/  /*Scope*/ 23, /*->9391*/
/*  9368*/   OPC_RecordChild1, // #1 = $rhs
/*  9369*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9380
/*  9372*/    OPC_CheckChild1TypeI32,
/*  9373*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9380*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9390
/*  9382*/    OPC_CheckChild1TypeI64,
/*  9383*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9390*/   0, // EndSwitchType
/*  9391*/  0, /*End of Scope*/
/*  9392*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9454
/*  9395*/  OPC_RecordChild0, // #0 = $lhs
/*  9396*/  OPC_Scope, 31, /*->9429*/ // 2 children in Scope
/*  9398*/   OPC_MoveChild1,
/*  9399*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9414
/*  9402*/    OPC_CheckAndImm, 31, 
/*  9404*/    OPC_RecordChild0, // #1 = $rhs
/*  9405*/    OPC_MoveParent,
/*  9406*/    OPC_CheckTypeI32,
/*  9407*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9414*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9428
/*  9416*/    OPC_CheckAndImm, 63, 
/*  9418*/    OPC_RecordChild0, // #1 = $rhs
/*  9419*/    OPC_MoveParent,
/*  9420*/    OPC_CheckTypeI64,
/*  9421*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9428*/   0, // EndSwitchType
/*  9429*/  /*Scope*/ 23, /*->9453*/
/*  9430*/   OPC_RecordChild1, // #1 = $rhs
/*  9431*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9442
/*  9434*/    OPC_CheckChild1TypeI32,
/*  9435*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9442*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9452
/*  9444*/    OPC_CheckChild1TypeI64,
/*  9445*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9452*/   0, // EndSwitchType
/*  9453*/  0, /*End of Scope*/
/*  9454*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9516
/*  9457*/  OPC_RecordChild0, // #0 = $lhs
/*  9458*/  OPC_Scope, 31, /*->9491*/ // 2 children in Scope
/*  9460*/   OPC_MoveChild1,
/*  9461*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9476
/*  9464*/    OPC_CheckAndImm, 31, 
/*  9466*/    OPC_RecordChild0, // #1 = $rhs
/*  9467*/    OPC_MoveParent,
/*  9468*/    OPC_CheckTypeI32,
/*  9469*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9476*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9490
/*  9478*/    OPC_CheckAndImm, 63, 
/*  9480*/    OPC_RecordChild0, // #1 = $rhs
/*  9481*/    OPC_MoveParent,
/*  9482*/    OPC_CheckTypeI64,
/*  9483*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9490*/   0, // EndSwitchType
/*  9491*/  /*Scope*/ 23, /*->9515*/
/*  9492*/   OPC_RecordChild1, // #1 = $rhs
/*  9493*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9504
/*  9496*/    OPC_CheckChild1TypeI32,
/*  9497*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9504*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9514
/*  9506*/    OPC_CheckChild1TypeI64,
/*  9507*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9514*/   0, // EndSwitchType
/*  9515*/  0, /*End of Scope*/
/*  9516*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9578
/*  9519*/  OPC_RecordChild0, // #0 = $lhs
/*  9520*/  OPC_Scope, 31, /*->9553*/ // 2 children in Scope
/*  9522*/   OPC_MoveChild1,
/*  9523*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9538
/*  9526*/    OPC_CheckAndImm, 31, 
/*  9528*/    OPC_RecordChild0, // #1 = $rhs
/*  9529*/    OPC_MoveParent,
/*  9530*/    OPC_CheckTypeI32,
/*  9531*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9538*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9552
/*  9540*/    OPC_CheckAndImm, 63, 
/*  9542*/    OPC_RecordChild0, // #1 = $rhs
/*  9543*/    OPC_MoveParent,
/*  9544*/    OPC_CheckTypeI64,
/*  9545*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9552*/   0, // EndSwitchType
/*  9553*/  /*Scope*/ 23, /*->9577*/
/*  9554*/   OPC_RecordChild1, // #1 = $rhs
/*  9555*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9566
/*  9558*/    OPC_CheckChild1TypeI32,
/*  9559*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9566*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9576
/*  9568*/    OPC_CheckChild1TypeI64,
/*  9569*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9576*/   0, // EndSwitchType
/*  9577*/  0, /*End of Scope*/
/*  9578*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9640
/*  9581*/  OPC_RecordChild0, // #0 = $lhs
/*  9582*/  OPC_Scope, 31, /*->9615*/ // 2 children in Scope
/*  9584*/   OPC_MoveChild1,
/*  9585*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9600
/*  9588*/    OPC_CheckAndImm, 31, 
/*  9590*/    OPC_RecordChild0, // #1 = $rhs
/*  9591*/    OPC_MoveParent,
/*  9592*/    OPC_CheckTypeI32,
/*  9593*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9600*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9614
/*  9602*/    OPC_CheckAndImm, 63, 
/*  9604*/    OPC_RecordChild0, // #1 = $rhs
/*  9605*/    OPC_MoveParent,
/*  9606*/    OPC_CheckTypeI64,
/*  9607*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9614*/   0, // EndSwitchType
/*  9615*/  /*Scope*/ 23, /*->9639*/
/*  9616*/   OPC_RecordChild1, // #1 = $rhs
/*  9617*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9628
/*  9620*/    OPC_CheckChild1TypeI32,
/*  9621*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9628*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9638
/*  9630*/    OPC_CheckChild1TypeI64,
/*  9631*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9638*/   0, // EndSwitchType
/*  9639*/  0, /*End of Scope*/
/*  9640*/ /*SwitchOpcode*/ 48|128,4/*560*/, TARGET_VAL(ISD::SELECT),// ->10204
/*  9644*/  OPC_Scope, 11|128,1/*139*/, /*->9786*/ // 8 children in Scope
/*  9647*/   OPC_MoveChild0,
/*  9648*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9651*/   OPC_RecordChild0, // #0 = $cond
/*  9652*/   OPC_CheckChild0TypeI32,
/*  9653*/   OPC_CheckChild1Integer, 0, 
/*  9655*/   OPC_CheckTypeI32,
/*  9656*/   OPC_Scope, 63, /*->9721*/ // 2 children in Scope
/*  9658*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9660*/    OPC_MoveParent,
/*  9661*/    OPC_RecordChild1, // #1 = $lhs
/*  9662*/    OPC_RecordChild2, // #2 = $rhs
/*  9663*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9674
/*  9666*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9674*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9684
/*  9676*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9684*/    /*SwitchType*/ 9, /*MVT::funcref*/98|128,1/*226*/, // ->9696
/*  9687*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/98|128,1/*226*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9696*/    /*SwitchType*/ 9, /*MVT::externref*/99|128,1/*227*/, // ->9708
/*  9699*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9708*/    /*SwitchType*/ 9, /*MVT::exnref*/100|128,1/*228*/, // ->9720
/*  9711*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9720*/    0, // EndSwitchType
/*  9721*/   /*Scope*/ 63, /*->9785*/
/*  9722*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9724*/    OPC_MoveParent,
/*  9725*/    OPC_RecordChild1, // #1 = $lhs
/*  9726*/    OPC_RecordChild2, // #2 = $rhs
/*  9727*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9738
/*  9730*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9738*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9748
/*  9740*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9748*/    /*SwitchType*/ 9, /*MVT::funcref*/98|128,1/*226*/, // ->9760
/*  9751*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/98|128,1/*226*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9760*/    /*SwitchType*/ 9, /*MVT::externref*/99|128,1/*227*/, // ->9772
/*  9763*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/99|128,1/*227*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9772*/    /*SwitchType*/ 9, /*MVT::exnref*/100|128,1/*228*/, // ->9784
/*  9775*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/100|128,1/*228*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9784*/    0, // EndSwitchType
/*  9785*/   0, /*End of Scope*/
/*  9786*/  /*Scope*/ 65, /*->9852*/
/*  9787*/   OPC_RecordChild0, // #0 = $cond
/*  9788*/   OPC_CheckChild0TypeI32,
/*  9789*/   OPC_RecordChild1, // #1 = $lhs
/*  9790*/   OPC_RecordChild2, // #2 = $rhs
/*  9791*/   OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9802
/*  9794*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9802*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9812
/*  9804*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9812*/   /*SwitchType*/ 10, /*MVT::funcref*/98|128,1/*226*/, // ->9825
/*  9815*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9816*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  /*MVT::funcref*/98|128,1/*226*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9825*/   /*SwitchType*/ 10, /*MVT::externref*/99|128,1/*227*/, // ->9838
/*  9828*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9829*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  /*MVT::externref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9838*/   /*SwitchType*/ 10, /*MVT::exnref*/100|128,1/*228*/, // ->9851
/*  9841*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9842*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  /*MVT::exnref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9851*/   0, // EndSwitchType
/*  9852*/  /*Scope*/ 67, /*->9920*/
/*  9853*/   OPC_MoveChild0,
/*  9854*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9857*/   OPC_RecordChild0, // #0 = $cond
/*  9858*/   OPC_CheckChild0TypeI32,
/*  9859*/   OPC_CheckChild1Integer, 0, 
/*  9861*/   OPC_CheckTypeI32,
/*  9862*/   OPC_Scope, 27, /*->9891*/ // 2 children in Scope
/*  9864*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9866*/    OPC_MoveParent,
/*  9867*/    OPC_RecordChild1, // #1 = $lhs
/*  9868*/    OPC_RecordChild2, // #2 = $rhs
/*  9869*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9880
/*  9872*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9880*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9890
/*  9882*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9890*/    0, // EndSwitchType
/*  9891*/   /*Scope*/ 27, /*->9919*/
/*  9892*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9894*/    OPC_MoveParent,
/*  9895*/    OPC_RecordChild1, // #1 = $lhs
/*  9896*/    OPC_RecordChild2, // #2 = $rhs
/*  9897*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9908
/*  9900*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9908*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9918
/*  9910*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9918*/    0, // EndSwitchType
/*  9919*/   0, /*End of Scope*/
/*  9920*/  /*Scope*/ 26, /*->9947*/
/*  9921*/   OPC_RecordChild0, // #0 = $cond
/*  9922*/   OPC_CheckChild0TypeI32,
/*  9923*/   OPC_RecordChild1, // #1 = $lhs
/*  9924*/   OPC_RecordChild2, // #2 = $rhs
/*  9925*/   OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9936
/*  9928*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9936*/   /*SwitchType*/ 8, /*MVT::f64*/13, // ->9946
/*  9938*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9946*/   0, // EndSwitchType
/*  9947*/  /*Scope*/ 107, /*->10055*/
/*  9948*/   OPC_MoveChild0,
/*  9949*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9952*/   OPC_RecordChild0, // #0 = $cond
/*  9953*/   OPC_CheckChild0TypeI32,
/*  9954*/   OPC_CheckChild1Integer, 0, 
/*  9956*/   OPC_CheckTypeI32,
/*  9957*/   OPC_Scope, 47, /*->10006*/ // 2 children in Scope
/*  9959*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9961*/    OPC_MoveParent,
/*  9962*/    OPC_RecordChild1, // #1 = $lhs
/*  9963*/    OPC_RecordChild2, // #2 = $rhs
/*  9964*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->9975
/*  9967*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9975*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->9985
/*  9977*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9985*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->9995
/*  9987*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/*  9995*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10005
/*  9997*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10005*/    0, // EndSwitchType
/* 10006*/   /*Scope*/ 47, /*->10054*/
/* 10007*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10009*/    OPC_MoveParent,
/* 10010*/    OPC_RecordChild1, // #1 = $lhs
/* 10011*/    OPC_RecordChild2, // #2 = $rhs
/* 10012*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10023
/* 10015*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10023*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10033
/* 10025*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10033*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10043
/* 10035*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10043*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10053
/* 10045*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10053*/    0, // EndSwitchType
/* 10054*/   0, /*End of Scope*/
/* 10055*/  /*Scope*/ 46, /*->10102*/
/* 10056*/   OPC_RecordChild0, // #0 = $cond
/* 10057*/   OPC_CheckChild0TypeI32,
/* 10058*/   OPC_RecordChild1, // #1 = $lhs
/* 10059*/   OPC_RecordChild2, // #2 = $rhs
/* 10060*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10071
/* 10063*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10071*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10081
/* 10073*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10081*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10091
/* 10083*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10091*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10101
/* 10093*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10101*/   0, // EndSwitchType
/* 10102*/  /*Scope*/ 71, /*->10174*/
/* 10103*/   OPC_MoveChild0,
/* 10104*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10107*/   OPC_RecordChild0, // #0 = $cond
/* 10108*/   OPC_CheckChild0TypeI32,
/* 10109*/   OPC_CheckChild1Integer, 0, 
/* 10111*/   OPC_CheckTypeI32,
/* 10112*/   OPC_Scope, 29, /*->10143*/ // 2 children in Scope
/* 10114*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10116*/    OPC_MoveParent,
/* 10117*/    OPC_RecordChild1, // #1 = $lhs
/* 10118*/    OPC_RecordChild2, // #2 = $rhs
/* 10119*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->10130
/* 10122*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/110, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10130*/    /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->10142
/* 10133*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10142*/    0, // EndSwitchType
/* 10143*/   /*Scope*/ 29, /*->10173*/
/* 10144*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10146*/    OPC_MoveParent,
/* 10147*/    OPC_RecordChild1, // #1 = $lhs
/* 10148*/    OPC_RecordChild2, // #2 = $rhs
/* 10149*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->10160
/* 10152*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/110, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10160*/    /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->10172
/* 10163*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10172*/    0, // EndSwitchType
/* 10173*/   0, /*End of Scope*/
/* 10174*/  /*Scope*/ 28, /*->10203*/
/* 10175*/   OPC_RecordChild0, // #0 = $cond
/* 10176*/   OPC_CheckChild0TypeI32,
/* 10177*/   OPC_RecordChild1, // #1 = $lhs
/* 10178*/   OPC_RecordChild2, // #2 = $rhs
/* 10179*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->10190
/* 10182*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10190*/   /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->10202
/* 10193*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10202*/   0, // EndSwitchType
/* 10203*/  0, /*End of Scope*/
/* 10204*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10337
/* 10208*/  OPC_Scope, 57, /*->10267*/ // 2 children in Scope
/* 10210*/   OPC_MoveChild0,
/* 10211*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10214*/   OPC_RecordChild0, // #0 = $vec
/* 10215*/   OPC_Scope, 24, /*->10241*/ // 2 children in Scope
/* 10217*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 10219*/    OPC_RecordChild1, // #1 = $idx
/* 10220*/    OPC_MoveChild1,
/* 10221*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10224*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/* 10226*/    OPC_CheckTypeI32,
/* 10227*/    OPC_MoveParent,
/* 10228*/    OPC_MoveSibling1,
/* 10229*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10231*/    OPC_MoveParent,
/* 10232*/    OPC_CheckTypeI32,
/* 10233*/    OPC_EmitConvertToTarget1,
/* 10234*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10241*/   /*Scope*/ 24, /*->10266*/
/* 10242*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 10244*/    OPC_RecordChild1, // #1 = $idx
/* 10245*/    OPC_MoveChild1,
/* 10246*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10249*/    OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/* 10251*/    OPC_CheckTypeI32,
/* 10252*/    OPC_MoveParent,
/* 10253*/    OPC_MoveSibling1,
/* 10254*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10256*/    OPC_MoveParent,
/* 10257*/    OPC_CheckTypeI32,
/* 10258*/    OPC_EmitConvertToTarget1,
/* 10259*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10266*/   0, /*End of Scope*/
/* 10267*/  /*Scope*/ 68, /*->10336*/
/* 10268*/   OPC_RecordChild0, // #0 = $src
/* 10269*/   OPC_MoveChild1,
/* 10270*/   OPC_Scope, 25, /*->10297*/ // 3 children in Scope
/* 10272*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10274*/    OPC_MoveParent,
/* 10275*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10286
/* 10278*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10280*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10286*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10296
/* 10288*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10290*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10296*/    0, // EndSwitchType
/* 10297*/   /*Scope*/ 25, /*->10323*/
/* 10298*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10300*/    OPC_MoveParent,
/* 10301*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10312
/* 10304*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10306*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10312*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10322
/* 10314*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10316*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10322*/    0, // EndSwitchType
/* 10323*/   /*Scope*/ 11, /*->10335*/
/* 10324*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 10326*/    OPC_MoveParent,
/* 10327*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10329*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10335*/   0, /*End of Scope*/
/* 10336*/  0, /*End of Scope*/
/* 10337*/ /*SwitchOpcode*/ 46|128,1/*174*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10515
/* 10341*/  OPC_RecordMemRef,
/* 10342*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10343*/  OPC_MoveChild1,
/* 10344*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10347*/  OPC_RecordChild0, // #1 = $addr
/* 10348*/  OPC_MoveChild0,
/* 10349*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10352*/  OPC_MoveParent,
/* 10353*/  OPC_MoveParent,
/* 10354*/  OPC_SwitchType /*14 cases */, 8, /*MVT::i32*/7, // ->10365
/* 10357*/   OPC_EmitMergeInputChains1_0,
/* 10358*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10365*/  /*SwitchType*/ 8, /*MVT::i64*/8, // ->10375
/* 10367*/   OPC_EmitMergeInputChains1_0,
/* 10368*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10375*/  /*SwitchType*/ 10, /*MVT::funcref*/98|128,1/*226*/, // ->10388
/* 10378*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10379*/   OPC_EmitMergeInputChains1_0,
/* 10380*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/98|128,1/*226*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10388*/  /*SwitchType*/ 10, /*MVT::externref*/99|128,1/*227*/, // ->10401
/* 10391*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10392*/   OPC_EmitMergeInputChains1_0,
/* 10393*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10401*/  /*SwitchType*/ 11, /*MVT::exnref*/100|128,1/*228*/, // ->10415
/* 10404*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10406*/   OPC_EmitMergeInputChains1_0,
/* 10407*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10415*/  /*SwitchType*/ 8, /*MVT::f32*/12, // ->10425
/* 10417*/   OPC_EmitMergeInputChains1_0,
/* 10418*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10425*/  /*SwitchType*/ 8, /*MVT::f64*/13, // ->10435
/* 10427*/   OPC_EmitMergeInputChains1_0,
/* 10428*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10435*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->10446
/* 10437*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10438*/   OPC_EmitMergeInputChains1_0,
/* 10439*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10446*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->10457
/* 10448*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10449*/   OPC_EmitMergeInputChains1_0,
/* 10450*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10457*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->10468
/* 10459*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10460*/   OPC_EmitMergeInputChains1_0,
/* 10461*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10468*/  /*SwitchType*/ 9, /*MVT::v8i16*/50, // ->10479
/* 10470*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10471*/   OPC_EmitMergeInputChains1_0,
/* 10472*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10479*/  /*SwitchType*/ 9, /*MVT::v8f16*/92, // ->10490
/* 10481*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10482*/   OPC_EmitMergeInputChains1_0,
/* 10483*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10490*/  /*SwitchType*/ 9, /*MVT::v4f32*/110, // ->10501
/* 10492*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10493*/   OPC_EmitMergeInputChains1_0,
/* 10494*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4f32*/110, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10501*/  /*SwitchType*/ 10, /*MVT::v2f64*/0|128,1/*128*/, // ->10514
/* 10504*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10505*/   OPC_EmitMergeInputChains1_0,
/* 10506*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10514*/  0, // EndSwitchType
/* 10515*/ /*SwitchOpcode*/ 70|128,2/*326*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10845
/* 10519*/  OPC_RecordMemRef,
/* 10520*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10521*/  OPC_RecordChild1, // #1 = $src
/* 10522*/  OPC_Scope, 20, /*->10544*/ // 14 children in Scope
/* 10524*/   OPC_CheckChild1TypeI32,
/* 10525*/   OPC_MoveChild2,
/* 10526*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10529*/   OPC_RecordChild0, // #2 = $addr
/* 10530*/   OPC_MoveChild0,
/* 10531*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10534*/   OPC_MoveParent,
/* 10535*/   OPC_MoveParent,
/* 10536*/   OPC_EmitMergeInputChains1_0,
/* 10537*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10544*/  /*Scope*/ 20, /*->10565*/
/* 10545*/   OPC_CheckChild1TypeI64,
/* 10546*/   OPC_MoveChild2,
/* 10547*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10550*/   OPC_RecordChild0, // #2 = $addr
/* 10551*/   OPC_MoveChild0,
/* 10552*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10555*/   OPC_MoveParent,
/* 10556*/   OPC_MoveParent,
/* 10557*/   OPC_EmitMergeInputChains1_0,
/* 10558*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10565*/  /*Scope*/ 21, /*->10587*/
/* 10566*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 10568*/   OPC_MoveChild2,
/* 10569*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10572*/   OPC_RecordChild0, // #2 = $addr
/* 10573*/   OPC_MoveChild0,
/* 10574*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10577*/   OPC_MoveParent,
/* 10578*/   OPC_MoveParent,
/* 10579*/   OPC_EmitMergeInputChains1_0,
/* 10580*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10587*/  /*Scope*/ 21, /*->10609*/
/* 10588*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 10590*/   OPC_MoveChild2,
/* 10591*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10594*/   OPC_RecordChild0, // #2 = $addr
/* 10595*/   OPC_MoveChild0,
/* 10596*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10599*/   OPC_MoveParent,
/* 10600*/   OPC_MoveParent,
/* 10601*/   OPC_EmitMergeInputChains1_0,
/* 10602*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10609*/  /*Scope*/ 22, /*->10632*/
/* 10610*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 10612*/   OPC_MoveChild2,
/* 10613*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10616*/   OPC_RecordChild0, // #2 = $addr
/* 10617*/   OPC_MoveChild0,
/* 10618*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10621*/   OPC_MoveParent,
/* 10622*/   OPC_MoveParent,
/* 10623*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10624*/   OPC_EmitMergeInputChains1_0,
/* 10625*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10632*/  /*Scope*/ 22, /*->10655*/
/* 10633*/   OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 10635*/   OPC_MoveChild2,
/* 10636*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10639*/   OPC_RecordChild0, // #2 = $addr
/* 10640*/   OPC_MoveChild0,
/* 10641*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10644*/   OPC_MoveParent,
/* 10645*/   OPC_MoveParent,
/* 10646*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10647*/   OPC_EmitMergeInputChains1_0,
/* 10648*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10655*/  /*Scope*/ 23, /*->10679*/
/* 10656*/   OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 10659*/   OPC_MoveChild2,
/* 10660*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10663*/   OPC_RecordChild0, // #2 = $addr
/* 10664*/   OPC_MoveChild0,
/* 10665*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10668*/   OPC_MoveParent,
/* 10669*/   OPC_MoveParent,
/* 10670*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10671*/   OPC_EmitMergeInputChains1_0,
/* 10672*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10679*/  /*Scope*/ 22, /*->10702*/
/* 10680*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 10682*/   OPC_MoveChild2,
/* 10683*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10686*/   OPC_RecordChild0, // #2 = $addr
/* 10687*/   OPC_MoveChild0,
/* 10688*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10691*/   OPC_MoveParent,
/* 10692*/   OPC_MoveParent,
/* 10693*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10694*/   OPC_EmitMergeInputChains1_0,
/* 10695*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10702*/  /*Scope*/ 22, /*->10725*/
/* 10703*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 10705*/   OPC_MoveChild2,
/* 10706*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10709*/   OPC_RecordChild0, // #2 = $addr
/* 10710*/   OPC_MoveChild0,
/* 10711*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10714*/   OPC_MoveParent,
/* 10715*/   OPC_MoveParent,
/* 10716*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10717*/   OPC_EmitMergeInputChains1_0,
/* 10718*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10725*/  /*Scope*/ 22, /*->10748*/
/* 10726*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 10728*/   OPC_MoveChild2,
/* 10729*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10732*/   OPC_RecordChild0, // #2 = $addr
/* 10733*/   OPC_MoveChild0,
/* 10734*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10737*/   OPC_MoveParent,
/* 10738*/   OPC_MoveParent,
/* 10739*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10740*/   OPC_EmitMergeInputChains1_0,
/* 10741*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10748*/  /*Scope*/ 22, /*->10771*/
/* 10749*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 10751*/   OPC_MoveChild2,
/* 10752*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10755*/   OPC_RecordChild0, // #2 = $addr
/* 10756*/   OPC_MoveChild0,
/* 10757*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10760*/   OPC_MoveParent,
/* 10761*/   OPC_MoveParent,
/* 10762*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10763*/   OPC_EmitMergeInputChains1_0,
/* 10764*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10771*/  /*Scope*/ 23, /*->10795*/
/* 10772*/   OPC_CheckChild1Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 10775*/   OPC_MoveChild2,
/* 10776*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10779*/   OPC_RecordChild0, // #2 = $addr
/* 10780*/   OPC_MoveChild0,
/* 10781*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10784*/   OPC_MoveParent,
/* 10785*/   OPC_MoveParent,
/* 10786*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10787*/   OPC_EmitMergeInputChains1_0,
/* 10788*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10795*/  /*Scope*/ 23, /*->10819*/
/* 10796*/   OPC_CheckChild1Type, /*MVT::externref*/99|128,1/*227*/, 
/* 10799*/   OPC_MoveChild2,
/* 10800*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10803*/   OPC_RecordChild0, // #2 = $addr
/* 10804*/   OPC_MoveChild0,
/* 10805*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10808*/   OPC_MoveParent,
/* 10809*/   OPC_MoveParent,
/* 10810*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10811*/   OPC_EmitMergeInputChains1_0,
/* 10812*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10819*/  /*Scope*/ 24, /*->10844*/
/* 10820*/   OPC_CheckChild1Type, /*MVT::exnref*/100|128,1/*228*/, 
/* 10823*/   OPC_MoveChild2,
/* 10824*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10827*/   OPC_RecordChild0, // #2 = $addr
/* 10828*/   OPC_MoveChild0,
/* 10829*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10832*/   OPC_MoveParent,
/* 10833*/   OPC_MoveParent,
/* 10834*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10836*/   OPC_EmitMergeInputChains1_0,
/* 10837*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10844*/  0, /*End of Scope*/
/* 10845*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10869
/* 10848*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10849*/  OPC_RecordChild1, // #1 = $amt
/* 10850*/  OPC_MoveChild1,
/* 10851*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10854*/  OPC_MoveSibling2,
/* 10855*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10858*/  OPC_RecordNode, // #2 = $amt2
/* 10859*/  OPC_MoveParent,
/* 10860*/  OPC_EmitMergeInputChains1_0,
/* 10861*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10869*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10894
/* 10872*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10873*/  OPC_CaptureGlueInput,
/* 10874*/  OPC_RecordChild1, // #1 = $amt
/* 10875*/  OPC_MoveChild1,
/* 10876*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10879*/  OPC_MoveSibling2,
/* 10880*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10883*/  OPC_RecordNode, // #2 = $amt2
/* 10884*/  OPC_MoveParent,
/* 10885*/  OPC_EmitMergeInputChains1_0,
/* 10886*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10894*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->10954
/* 10897*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 10898*/  OPC_RecordChild1, // #1 = $src_idx
/* 10899*/  OPC_MoveChild1,
/* 10900*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10903*/  OPC_CheckTypeI32,
/* 10904*/  OPC_MoveSibling2,
/* 10905*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10908*/  OPC_RecordNode, // #2 = $dst_idx
/* 10909*/  OPC_CheckTypeI32,
/* 10910*/  OPC_MoveParent,
/* 10911*/  OPC_RecordChild3, // #3 = $dst
/* 10912*/  OPC_Scope, 19, /*->10933*/ // 2 children in Scope
/* 10914*/   OPC_CheckChild3TypeI32,
/* 10915*/   OPC_RecordChild4, // #4 = $src
/* 10916*/   OPC_CheckChild4TypeI32,
/* 10917*/   OPC_RecordChild5, // #5 = $len
/* 10918*/   OPC_CheckChild5TypeI32,
/* 10919*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10921*/   OPC_EmitMergeInputChains1_0,
/* 10922*/   OPC_EmitConvertToTarget1,
/* 10923*/   OPC_EmitConvertToTarget2,
/* 10924*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8923MEMORY_COPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_8923MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 10933*/  /*Scope*/ 19, /*->10953*/
/* 10934*/   OPC_CheckChild3TypeI64,
/* 10935*/   OPC_RecordChild4, // #4 = $src
/* 10936*/   OPC_CheckChild4TypeI64,
/* 10937*/   OPC_RecordChild5, // #5 = $len
/* 10938*/   OPC_CheckChild5TypeI64,
/* 10939*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 10941*/   OPC_EmitMergeInputChains1_0,
/* 10942*/   OPC_EmitConvertToTarget1,
/* 10943*/   OPC_EmitConvertToTarget2,
/* 10944*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8924MEMORY_COPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_8924MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 10953*/  0, /*End of Scope*/
/* 10954*/ /*SwitchOpcode*/ 60, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->11017
/* 10957*/  OPC_RecordMemRef,
/* 10958*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10959*/  OPC_MoveChild1,
/* 10960*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10963*/  OPC_RecordChild0, // #1 = $table
/* 10964*/  OPC_MoveChild0,
/* 10965*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10968*/  OPC_MoveParent,
/* 10969*/  OPC_MoveParent,
/* 10970*/  OPC_RecordChild2, // #2 = $idx
/* 10971*/  OPC_CheckChild2TypeI32,
/* 10972*/  OPC_SwitchType /*3 cases */, 11, /*MVT::funcref*/98|128,1/*226*/, // ->10987
/* 10976*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10977*/   OPC_EmitMergeInputChains1_0,
/* 10978*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/98|128,1/*226*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 10987*/  /*SwitchType*/ 11, /*MVT::externref*/99|128,1/*227*/, // ->11001
/* 10990*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10991*/   OPC_EmitMergeInputChains1_0,
/* 10992*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11001*/  /*SwitchType*/ 12, /*MVT::exnref*/100|128,1/*228*/, // ->11016
/* 11004*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11006*/   OPC_EmitMergeInputChains1_0,
/* 11007*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11016*/  0, // EndSwitchType
/* 11017*/ /*SwitchOpcode*/ 87, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11107
/* 11020*/  OPC_RecordMemRef,
/* 11021*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 11022*/  OPC_Scope, 59, /*->11083*/ // 2 children in Scope
/* 11024*/   OPC_MoveChild1,
/* 11025*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11028*/   OPC_RecordChild0, // #1 = $table
/* 11029*/   OPC_MoveChild0,
/* 11030*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11033*/   OPC_MoveParent,
/* 11034*/   OPC_MoveParent,
/* 11035*/   OPC_RecordChild2, // #2 = $idx
/* 11036*/   OPC_CheckChild2TypeI32,
/* 11037*/   OPC_RecordChild3, // #3 = $src
/* 11038*/   OPC_Scope, 13, /*->11053*/ // 3 children in Scope
/* 11040*/    OPC_CheckChild3Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 11043*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11044*/    OPC_EmitMergeInputChains1_0,
/* 11045*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 11053*/   /*Scope*/ 13, /*->11067*/
/* 11054*/    OPC_CheckChild3Type, /*MVT::externref*/99|128,1/*227*/, 
/* 11057*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11058*/    OPC_EmitMergeInputChains1_0,
/* 11059*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11067*/   /*Scope*/ 14, /*->11082*/
/* 11068*/    OPC_CheckChild3Type, /*MVT::exnref*/100|128,1/*228*/, 
/* 11071*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11073*/    OPC_EmitMergeInputChains1_0,
/* 11074*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11082*/   0, /*End of Scope*/
/* 11083*/  /*Scope*/ 22, /*->11106*/
/* 11084*/   OPC_RecordChild1, // #1 = $table
/* 11085*/   OPC_MoveChild1,
/* 11086*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11089*/   OPC_MoveParent,
/* 11090*/   OPC_RecordChild2, // #2 = $idx
/* 11091*/   OPC_CheckChild2TypeI32,
/* 11092*/   OPC_RecordChild3, // #3 = $r
/* 11093*/   OPC_CheckChild3Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 11096*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11097*/   OPC_EmitMergeInputChains1_0,
/* 11098*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11106*/  0, /*End of Scope*/
/* 11107*/ /*SwitchOpcode*/ 67|128,10/*1347*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12458
/* 11111*/  OPC_Scope, 49, /*->11162*/ // 41 children in Scope
/* 11113*/   OPC_CheckChild0Integer, 26|128,68|128,1/*25114*/, 
/* 11117*/   OPC_RecordChild1, // #0 = $src
/* 11118*/   OPC_Scope, 20, /*->11140*/ // 2 children in Scope
/* 11120*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11122*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11131
/* 11125*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12557:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11131*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11139
/* 11133*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12557:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11139*/    0, // EndSwitchType
/* 11140*/   /*Scope*/ 20, /*->11161*/
/* 11141*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11143*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11152
/* 11146*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12557:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11152*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11160
/* 11154*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12557:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11160*/    0, // EndSwitchType
/* 11161*/   0, /*End of Scope*/
/* 11162*/  /*Scope*/ 49, /*->11212*/
/* 11163*/   OPC_CheckChild0Integer, 28|128,68|128,1/*25116*/, 
/* 11167*/   OPC_RecordChild1, // #0 = $src
/* 11168*/   OPC_Scope, 20, /*->11190*/ // 2 children in Scope
/* 11170*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11172*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11181
/* 11175*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12558:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11181*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11189
/* 11183*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12558:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11189*/    0, // EndSwitchType
/* 11190*/   /*Scope*/ 20, /*->11211*/
/* 11191*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11193*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11202
/* 11196*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12558:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11202*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11210
/* 11204*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12558:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11210*/    0, // EndSwitchType
/* 11211*/   0, /*End of Scope*/
/* 11212*/  /*Scope*/ 43, /*->11256*/
/* 11213*/   OPC_CheckChild0Integer, 10|128,67|128,1/*24970*/, 
/* 11217*/   OPC_RecordChild1, // #0 = $vec
/* 11218*/   OPC_Scope, 8, /*->11228*/ // 4 children in Scope
/* 11220*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11222*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11228*/   /*Scope*/ 8, /*->11237*/
/* 11229*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11231*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11237*/   /*Scope*/ 8, /*->11246*/
/* 11238*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11240*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11246*/   /*Scope*/ 8, /*->11255*/
/* 11247*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11249*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12485:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11255*/   0, /*End of Scope*/
/* 11256*/  /*Scope*/ 47, /*->11304*/
/* 11257*/   OPC_CheckChild0Integer, 8|128,67|128,1/*24968*/, 
/* 11261*/   OPC_RecordChild1, // #0 = $vec
/* 11262*/   OPC_Scope, 9, /*->11273*/ // 4 children in Scope
/* 11264*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11266*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11267*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11273*/   /*Scope*/ 9, /*->11283*/
/* 11274*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11276*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11277*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11283*/   /*Scope*/ 9, /*->11293*/
/* 11284*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11286*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11287*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11293*/   /*Scope*/ 9, /*->11303*/
/* 11294*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11296*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11297*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12484:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11303*/   0, /*End of Scope*/
/* 11304*/  /*Scope*/ 47, /*->11352*/
/* 11305*/   OPC_CheckChild0Integer, 14|128,67|128,1/*24974*/, 
/* 11309*/   OPC_RecordChild1, // #0 = $vec
/* 11310*/   OPC_Scope, 9, /*->11321*/ // 4 children in Scope
/* 11312*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11314*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11315*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11321*/   /*Scope*/ 9, /*->11331*/
/* 11322*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11324*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11325*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11331*/   /*Scope*/ 9, /*->11341*/
/* 11332*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11334*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11335*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11341*/   /*Scope*/ 9, /*->11351*/
/* 11342*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11344*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12487:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11351*/   0, /*End of Scope*/
/* 11352*/  /*Scope*/ 11, /*->11364*/
/* 11353*/   OPC_CheckChild0Integer, 68|128,67|128,1/*25028*/, 
/* 11357*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11358*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 /*MVT::funcref*/98|128,1/*226*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12514:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11364*/  /*Scope*/ 12, /*->11377*/
/* 11365*/   OPC_CheckChild0Integer, 62|128,67|128,1/*25022*/, 
/* 11369*/   OPC_RecordChild1, // #0 = $ref
/* 11370*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11371*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12511:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11377*/  /*Scope*/ 11, /*->11389*/
/* 11378*/   OPC_CheckChild0Integer, 66|128,67|128,1/*25026*/, 
/* 11382*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11383*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 /*MVT::externref*/99|128,1/*227*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12513:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11389*/  /*Scope*/ 12, /*->11402*/
/* 11390*/   OPC_CheckChild0Integer, 60|128,67|128,1/*25020*/, 
/* 11394*/   OPC_RecordChild1, // #0 = $ref
/* 11395*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11396*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12510:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11402*/  /*Scope*/ 11, /*->11414*/
/* 11403*/   OPC_CheckChild0Integer, 64|128,67|128,1/*25024*/, 
/* 11407*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11408*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 /*MVT::exnref*/100|128,1/*228*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 12512:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11414*/  /*Scope*/ 12, /*->11427*/
/* 11415*/   OPC_CheckChild0Integer, 58|128,67|128,1/*25018*/, 
/* 11419*/   OPC_RecordChild1, // #0 = $ref
/* 11420*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11421*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12509:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11427*/  /*Scope*/ 23, /*->11451*/
/* 11428*/   OPC_CheckChild0Integer, 26|128,67|128,1/*24986*/, 
/* 11432*/   OPC_RecordChild1, // #0 = $vec
/* 11433*/   OPC_RecordChild2, // #1 = $idx
/* 11434*/   OPC_MoveChild2,
/* 11435*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11438*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/* 11440*/   OPC_MoveParent,
/* 11441*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 11443*/   OPC_EmitConvertToTarget1,
/* 11444*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 12493:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11451*/  /*Scope*/ 13, /*->11465*/
/* 11452*/   OPC_CheckChild0Integer, 112|128,67|128,1/*25072*/, 
/* 11456*/   OPC_RecordChild1, // #0 = $src
/* 11457*/   OPC_RecordChild2, // #1 = $mask
/* 11458*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12536:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11465*/  /*Scope*/ 120, /*->11586*/
/* 11466*/   OPC_CheckChild0Integer, 16|128,67|128,1/*24976*/, 
/* 11470*/   OPC_RecordChild1, // #0 = $v1
/* 11471*/   OPC_SwitchType /*6 cases */, 16, /*MVT::v16i8*/39, // ->11490
/* 11474*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11476*/    OPC_RecordChild2, // #1 = $v2
/* 11477*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11479*/    OPC_RecordChild3, // #2 = $c
/* 11480*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11482*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12488:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11490*/   /*SwitchType*/ 16, /*MVT::v8i16*/50, // ->11508
/* 11492*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11494*/    OPC_RecordChild2, // #1 = $v2
/* 11495*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11497*/    OPC_RecordChild3, // #2 = $c
/* 11498*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11500*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12488:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11508*/   /*SwitchType*/ 16, /*MVT::v4i32*/60, // ->11526
/* 11510*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11512*/    OPC_RecordChild2, // #1 = $v2
/* 11513*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11515*/    OPC_RecordChild3, // #2 = $c
/* 11516*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11518*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12488:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11526*/   /*SwitchType*/ 16, /*MVT::v2i64*/78, // ->11544
/* 11528*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11530*/    OPC_RecordChild2, // #1 = $v2
/* 11531*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 11533*/    OPC_RecordChild3, // #2 = $c
/* 11534*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 11536*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12488:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11544*/   /*SwitchType*/ 16, /*MVT::v4f32*/110, // ->11562
/* 11546*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 11548*/    OPC_RecordChild2, // #1 = $v2
/* 11549*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 11551*/    OPC_RecordChild3, // #2 = $c
/* 11552*/    OPC_CheckChild3Type, /*MVT::v4f32*/110, 
/* 11554*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12488:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11562*/   /*SwitchType*/ 20, /*MVT::v2f64*/0|128,1/*128*/, // ->11585
/* 11565*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 11568*/    OPC_RecordChild2, // #1 = $v2
/* 11569*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 11572*/    OPC_RecordChild3, // #2 = $c
/* 11573*/    OPC_CheckChild3Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 11576*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12488:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11585*/   0, // EndSwitchType
/* 11586*/  /*Scope*/ 37, /*->11624*/
/* 11587*/   OPC_CheckChild0Integer, 108|128,67|128,1/*25068*/, 
/* 11591*/   OPC_RecordChild1, // #0 = $lhs
/* 11592*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11608
/* 11595*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11597*/    OPC_RecordChild2, // #1 = $rhs
/* 11598*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11600*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11601*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12534:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11608*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11623
/* 11610*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11612*/    OPC_RecordChild2, // #1 = $rhs
/* 11613*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11615*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11616*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12534:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11623*/   0, // EndSwitchType
/* 11624*/  /*Scope*/ 37, /*->11662*/
/* 11625*/   OPC_CheckChild0Integer, 110|128,67|128,1/*25070*/, 
/* 11629*/   OPC_RecordChild1, // #0 = $lhs
/* 11630*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11646
/* 11633*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11635*/    OPC_RecordChild2, // #1 = $rhs
/* 11636*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11638*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11639*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12535:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11646*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11661
/* 11648*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11650*/    OPC_RecordChild2, // #1 = $rhs
/* 11651*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11653*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11654*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12535:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11661*/   0, // EndSwitchType
/* 11662*/  /*Scope*/ 37, /*->11700*/
/* 11663*/   OPC_CheckChild0Integer, 12|128,67|128,1/*24972*/, 
/* 11667*/   OPC_RecordChild1, // #0 = $lhs
/* 11668*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11684
/* 11671*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11673*/    OPC_RecordChild2, // #1 = $rhs
/* 11674*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11676*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11677*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12486:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11684*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11699
/* 11686*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11688*/    OPC_RecordChild2, // #1 = $rhs
/* 11689*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11691*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11692*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12486:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11699*/   0, // EndSwitchType
/* 11700*/  /*Scope*/ 14, /*->11715*/
/* 11701*/   OPC_CheckChild0Integer, 20|128,67|128,1/*24980*/, 
/* 11705*/   OPC_RecordChild1, // #0 = $lhs
/* 11706*/   OPC_RecordChild2, // #1 = $rhs
/* 11707*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11708*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12490:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11715*/  /*Scope*/ 37, /*->11753*/
/* 11716*/   OPC_CheckChild0Integer, 48|128,67|128,1/*25008*/, 
/* 11720*/   OPC_RecordChild1, // #0 = $low
/* 11721*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11737
/* 11724*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11726*/    OPC_RecordChild2, // #1 = $high
/* 11727*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11729*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11730*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12504:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11737*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11752
/* 11739*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11741*/    OPC_RecordChild2, // #1 = $high
/* 11742*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11744*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11745*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12504:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11752*/   0, // EndSwitchType
/* 11753*/  /*Scope*/ 37, /*->11791*/
/* 11754*/   OPC_CheckChild0Integer, 50|128,67|128,1/*25010*/, 
/* 11758*/   OPC_RecordChild1, // #0 = $low
/* 11759*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11775
/* 11762*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11764*/    OPC_RecordChild2, // #1 = $high
/* 11765*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11767*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12505:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11775*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11790
/* 11777*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11779*/    OPC_RecordChild2, // #1 = $high
/* 11780*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11782*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11783*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12505:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11790*/   0, // EndSwitchType
/* 11791*/  /*Scope*/ 29, /*->11821*/
/* 11792*/   OPC_CheckChild0Integer, 22|128,67|128,1/*24982*/, 
/* 11796*/   OPC_RecordChild1, // #0 = $vec
/* 11797*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11809
/* 11800*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11802*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11803*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12491:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11809*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11820
/* 11811*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11813*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11814*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12491:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11820*/   0, // EndSwitchType
/* 11821*/  /*Scope*/ 29, /*->11851*/
/* 11822*/   OPC_CheckChild0Integer, 24|128,67|128,1/*24984*/, 
/* 11826*/   OPC_RecordChild1, // #0 = $vec
/* 11827*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11839
/* 11830*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11832*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11833*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12492:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11839*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11850
/* 11841*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11843*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11844*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12492:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11850*/   0, // EndSwitchType
/* 11851*/  /*Scope*/ 14, /*->11866*/
/* 11852*/   OPC_CheckChild0Integer, 56|128,67|128,1/*25016*/, 
/* 11856*/   OPC_RecordChild1, // #0 = $lhs
/* 11857*/   OPC_RecordChild2, // #1 = $rhs
/* 11858*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11859*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12508:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11866*/  /*Scope*/ 14, /*->11881*/
/* 11867*/   OPC_CheckChild0Integer, 88|128,67|128,1/*25048*/, 
/* 11871*/   OPC_RecordChild1, // #0 = $src
/* 11872*/   OPC_RecordChild2, // #1 = $mask
/* 11873*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11874*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11881*/  /*Scope*/ 12, /*->11894*/
/* 11882*/   OPC_CheckChild0Integer, 90|128,67|128,1/*25050*/, 
/* 11886*/   OPC_RecordChild1, // #0 = $vec
/* 11887*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11888*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12525:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11894*/  /*Scope*/ 12, /*->11907*/
/* 11895*/   OPC_CheckChild0Integer, 94|128,67|128,1/*25054*/, 
/* 11899*/   OPC_RecordChild1, // #0 = $vec
/* 11900*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11901*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12527:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11907*/  /*Scope*/ 12, /*->11920*/
/* 11908*/   OPC_CheckChild0Integer, 92|128,67|128,1/*25052*/, 
/* 11912*/   OPC_RecordChild1, // #0 = $vec
/* 11913*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11914*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12526:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11920*/  /*Scope*/ 12, /*->11933*/
/* 11921*/   OPC_CheckChild0Integer, 96|128,67|128,1/*25056*/, 
/* 11925*/   OPC_RecordChild1, // #0 = $vec
/* 11926*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11927*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12528:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11933*/  /*Scope*/ 83, /*->12017*/
/* 11934*/   OPC_CheckChild0Integer, 76|128,67|128,1/*25036*/, 
/* 11938*/   OPC_RecordChild1, // #0 = $a
/* 11939*/   OPC_SwitchType /*4 cases */, 17, /*MVT::v16i8*/39, // ->11959
/* 11942*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11944*/    OPC_RecordChild2, // #1 = $b
/* 11945*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11947*/    OPC_RecordChild3, // #2 = $c
/* 11948*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11950*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11951*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11959*/   /*SwitchType*/ 17, /*MVT::v8i16*/50, // ->11978
/* 11961*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11963*/    OPC_RecordChild2, // #1 = $b
/* 11964*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11966*/    OPC_RecordChild3, // #2 = $c
/* 11967*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11969*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11970*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11978*/   /*SwitchType*/ 17, /*MVT::v4i32*/60, // ->11997
/* 11980*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11982*/    OPC_RecordChild2, // #1 = $b
/* 11983*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11985*/    OPC_RecordChild3, // #2 = $c
/* 11986*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11988*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11989*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11997*/   /*SwitchType*/ 17, /*MVT::v2i64*/78, // ->12016
/* 11999*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 12001*/    OPC_RecordChild2, // #1 = $b
/* 12002*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12004*/    OPC_RecordChild3, // #2 = $c
/* 12005*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 12007*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12008*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 12016*/   0, // EndSwitchType
/* 12017*/  /*Scope*/ 14, /*->12032*/
/* 12018*/   OPC_CheckChild0Integer, 86|128,67|128,1/*25046*/, 
/* 12022*/   OPC_RecordChild1, // #0 = $lhs
/* 12023*/   OPC_RecordChild2, // #1 = $rhs
/* 12024*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12025*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12523:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12032*/  /*Scope*/ 14, /*->12047*/
/* 12033*/   OPC_CheckChild0Integer, 74|128,67|128,1/*25034*/, 
/* 12037*/   OPC_RecordChild1, // #0 = $lhs
/* 12038*/   OPC_RecordChild2, // #1 = $rhs
/* 12039*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12040*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12047*/  /*Scope*/ 16, /*->12064*/
/* 12048*/   OPC_CheckChild0Integer, 72|128,67|128,1/*25032*/, 
/* 12052*/   OPC_RecordChild1, // #0 = $lhs
/* 12053*/   OPC_RecordChild2, // #1 = $rhs
/* 12054*/   OPC_RecordChild3, // #2 = $acc
/* 12055*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 12064*/  /*Scope*/ 25, /*->12090*/
/* 12065*/   OPC_CheckChild0Integer, 98|128,67|128,1/*25058*/, 
/* 12069*/   OPC_RecordChild1, // #0 = $vec
/* 12070*/   OPC_RecordChild2, // #1 = $idx
/* 12071*/   OPC_MoveChild2,
/* 12072*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12075*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/* 12077*/   OPC_MoveParent,
/* 12078*/   OPC_RecordChild3, // #2 = $x
/* 12079*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 12081*/   OPC_EmitConvertToTarget1,
/* 12082*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F16x8),
                 /*MVT::v8f16*/92, 3/*#Ops*/, 0, 3, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12529:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx, F32:{ *:[f32] }:$x) - Complexity = 12
             // Dst: (REPLACE_LANE_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 12090*/  /*Scope*/ 13, /*->12104*/
/* 12091*/   OPC_CheckChild0Integer, 104|128,67|128,1/*25064*/, 
/* 12095*/   OPC_RecordChild1, // #0 = $x
/* 12096*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 12098*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12532:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12104*/  /*Scope*/ 53, /*->12158*/
/* 12105*/   OPC_CheckChild0Integer, 54|128,67|128,1/*25014*/, 
/* 12109*/   OPC_RecordChild1, // #0 = $lhs
/* 12110*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/110, // ->12125
/* 12113*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12115*/    OPC_RecordChild2, // #1 = $rhs
/* 12116*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12118*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12507:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12125*/   /*SwitchType*/ 15, /*MVT::v2f64*/0|128,1/*128*/, // ->12143
/* 12128*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12131*/    OPC_RecordChild2, // #1 = $rhs
/* 12132*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12135*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12507:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12143*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12157
/* 12145*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12147*/    OPC_RecordChild2, // #1 = $rhs
/* 12148*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12150*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12507:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12157*/   0, // EndSwitchType
/* 12158*/  /*Scope*/ 53, /*->12212*/
/* 12159*/   OPC_CheckChild0Integer, 52|128,67|128,1/*25012*/, 
/* 12163*/   OPC_RecordChild1, // #0 = $lhs
/* 12164*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/110, // ->12179
/* 12167*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12169*/    OPC_RecordChild2, // #1 = $rhs
/* 12170*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12172*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12506:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12179*/   /*SwitchType*/ 15, /*MVT::v2f64*/0|128,1/*128*/, // ->12197
/* 12182*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12185*/    OPC_RecordChild2, // #1 = $rhs
/* 12186*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12189*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12506:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12197*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12211
/* 12199*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12201*/    OPC_RecordChild2, // #1 = $rhs
/* 12202*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12204*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12506:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12211*/   0, // EndSwitchType
/* 12212*/  /*Scope*/ 71, /*->12284*/
/* 12213*/   OPC_CheckChild0Integer, 78|128,67|128,1/*25038*/, 
/* 12217*/   OPC_RecordChild1, // #0 = $a
/* 12218*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/110, // ->12239
/* 12221*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12223*/    OPC_RecordChild2, // #1 = $b
/* 12224*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12226*/    OPC_RecordChild3, // #2 = $c
/* 12227*/    OPC_CheckChild3Type, /*MVT::v4f32*/110, 
/* 12229*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12231*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12519:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12239*/   /*SwitchType*/ 22, /*MVT::v2f64*/0|128,1/*128*/, // ->12264
/* 12242*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12245*/    OPC_RecordChild2, // #1 = $b
/* 12246*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12249*/    OPC_RecordChild3, // #2 = $c
/* 12250*/    OPC_CheckChild3Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12253*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12255*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12519:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12264*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12283
/* 12266*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12268*/    OPC_RecordChild2, // #1 = $b
/* 12269*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12271*/    OPC_RecordChild3, // #2 = $c
/* 12272*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12274*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12275*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12519:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12283*/   0, // EndSwitchType
/* 12284*/  /*Scope*/ 71, /*->12356*/
/* 12285*/   OPC_CheckChild0Integer, 84|128,67|128,1/*25044*/, 
/* 12289*/   OPC_RecordChild1, // #0 = $a
/* 12290*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/110, // ->12311
/* 12293*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12295*/    OPC_RecordChild2, // #1 = $b
/* 12296*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12298*/    OPC_RecordChild3, // #2 = $c
/* 12299*/    OPC_CheckChild3Type, /*MVT::v4f32*/110, 
/* 12301*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12522:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12311*/   /*SwitchType*/ 22, /*MVT::v2f64*/0|128,1/*128*/, // ->12336
/* 12314*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12317*/    OPC_RecordChild2, // #1 = $b
/* 12318*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12321*/    OPC_RecordChild3, // #2 = $c
/* 12322*/    OPC_CheckChild3Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12325*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12327*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12522:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12336*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12355
/* 12338*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12340*/    OPC_RecordChild2, // #1 = $b
/* 12341*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12343*/    OPC_RecordChild3, // #2 = $c
/* 12344*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12346*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12347*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12522:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12355*/   0, // EndSwitchType
/* 12356*/  /*Scope*/ 41, /*->12398*/
/* 12357*/   OPC_CheckChild0Integer, 82|128,67|128,1/*25042*/, 
/* 12361*/   OPC_RecordChild1, // #0 = $lhs
/* 12362*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/110, // ->12378
/* 12365*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12367*/    OPC_RecordChild2, // #1 = $rhs
/* 12368*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12370*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12371*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12521:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12378*/   /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->12397
/* 12381*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12384*/    OPC_RecordChild2, // #1 = $rhs
/* 12385*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12388*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12389*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12521:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12397*/   0, // EndSwitchType
/* 12398*/  /*Scope*/ 41, /*->12440*/
/* 12399*/   OPC_CheckChild0Integer, 80|128,67|128,1/*25040*/, 
/* 12403*/   OPC_RecordChild1, // #0 = $lhs
/* 12404*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/110, // ->12420
/* 12407*/    OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 12409*/    OPC_RecordChild2, // #1 = $rhs
/* 12410*/    OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12412*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12413*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12520:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12420*/   /*SwitchType*/ 16, /*MVT::v2f64*/0|128,1/*128*/, // ->12439
/* 12423*/    OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12426*/    OPC_RecordChild2, // #1 = $rhs
/* 12427*/    OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12430*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12431*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12520:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12439*/   0, // EndSwitchType
/* 12440*/  /*Scope*/ 16, /*->12457*/
/* 12441*/   OPC_CheckChild0Integer, 70|128,67|128,1/*25030*/, 
/* 12445*/   OPC_RecordChild1, // #0 = $lhs
/* 12446*/   OPC_RecordChild2, // #1 = $rhs
/* 12447*/   OPC_RecordChild3, // #2 = $acc
/* 12448*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12449*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 /*MVT::v4f32*/110, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12457*/  0, /*End of Scope*/
/* 12458*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12594
/* 12462*/  OPC_RecordChild0, // #0 = $vec
/* 12463*/  OPC_Scope, 20, /*->12485*/ // 6 children in Scope
/* 12465*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 12467*/   OPC_RecordChild1, // #1 = $idx
/* 12468*/   OPC_MoveChild1,
/* 12469*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12472*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/* 12474*/   OPC_CheckTypeI32,
/* 12475*/   OPC_MoveParent,
/* 12476*/   OPC_CheckTypeI32,
/* 12477*/   OPC_EmitConvertToTarget1,
/* 12478*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12485*/  /*Scope*/ 20, /*->12506*/
/* 12486*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 12488*/   OPC_RecordChild1, // #1 = $idx
/* 12489*/   OPC_MoveChild1,
/* 12490*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12493*/   OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/* 12495*/   OPC_CheckTypeI32,
/* 12496*/   OPC_MoveParent,
/* 12497*/   OPC_CheckTypeI32,
/* 12498*/   OPC_EmitConvertToTarget1,
/* 12499*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12506*/  /*Scope*/ 20, /*->12527*/
/* 12507*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 12509*/   OPC_RecordChild1, // #1 = $idx
/* 12510*/   OPC_MoveChild1,
/* 12511*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12514*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12516*/   OPC_CheckTypeI32,
/* 12517*/   OPC_MoveParent,
/* 12518*/   OPC_CheckTypeI32,
/* 12519*/   OPC_EmitConvertToTarget1,
/* 12520*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12527*/  /*Scope*/ 20, /*->12548*/
/* 12528*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 12530*/   OPC_RecordChild1, // #1 = $idx
/* 12531*/   OPC_MoveChild1,
/* 12532*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12535*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12537*/   OPC_CheckTypeI32,
/* 12538*/   OPC_MoveParent,
/* 12539*/   OPC_CheckTypeI64,
/* 12540*/   OPC_EmitConvertToTarget1,
/* 12541*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12548*/  /*Scope*/ 21, /*->12570*/
/* 12549*/   OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 12551*/   OPC_RecordChild1, // #1 = $idx
/* 12552*/   OPC_MoveChild1,
/* 12553*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12556*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12558*/   OPC_CheckTypeI32,
/* 12559*/   OPC_MoveParent,
/* 12560*/   OPC_CheckType, /*MVT::f32*/12, 
/* 12562*/   OPC_EmitConvertToTarget1,
/* 12563*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12570*/  /*Scope*/ 22, /*->12593*/
/* 12571*/   OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12574*/   OPC_RecordChild1, // #1 = $idx
/* 12575*/   OPC_MoveChild1,
/* 12576*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12579*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12581*/   OPC_CheckTypeI32,
/* 12582*/   OPC_MoveParent,
/* 12583*/   OPC_CheckType, /*MVT::f64*/13, 
/* 12585*/   OPC_EmitConvertToTarget1,
/* 12586*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12593*/  0, /*End of Scope*/
/* 12594*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12726
/* 12598*/  OPC_RecordChild0, // #0 = $argno
/* 12599*/  OPC_MoveChild0,
/* 12600*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12603*/  OPC_MoveParent,
/* 12604*/  OPC_SwitchType /*14 cases */, 6, /*MVT::i32*/7, // ->12613
/* 12607*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12613*/  /*SwitchType*/ 6, /*MVT::i64*/8, // ->12621
/* 12615*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12621*/  /*SwitchType*/ 7, /*MVT::funcref*/98|128,1/*226*/, // ->12631
/* 12624*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 /*MVT::funcref*/98|128,1/*226*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12631*/  /*SwitchType*/ 7, /*MVT::externref*/99|128,1/*227*/, // ->12641
/* 12634*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 /*MVT::externref*/99|128,1/*227*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12641*/  /*SwitchType*/ 7, /*MVT::exnref*/100|128,1/*228*/, // ->12651
/* 12644*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 /*MVT::exnref*/100|128,1/*228*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12651*/  /*SwitchType*/ 6, /*MVT::f32*/12, // ->12659
/* 12653*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12659*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->12667
/* 12661*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12667*/  /*SwitchType*/ 6, /*MVT::v16i8*/39, // ->12675
/* 12669*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12675*/  /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->12683
/* 12677*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12683*/  /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->12691
/* 12685*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12691*/  /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->12699
/* 12693*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12699*/  /*SwitchType*/ 6, /*MVT::v4f32*/110, // ->12707
/* 12701*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12707*/  /*SwitchType*/ 7, /*MVT::v2f64*/0|128,1/*128*/, // ->12717
/* 12710*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12717*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->12725
/* 12719*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12725*/  0, // EndSwitchType
/* 12726*/ /*SwitchOpcode*/ 26|128,1/*154*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12884
/* 12730*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12731*/  OPC_RecordChild1, // #1 = $local
/* 12732*/  OPC_MoveChild1,
/* 12733*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12736*/  OPC_MoveParent,
/* 12737*/  OPC_SwitchType /*14 cases */, 7, /*MVT::i32*/7, // ->12747
/* 12740*/   OPC_EmitMergeInputChains1_0,
/* 12741*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12747*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->12756
/* 12749*/   OPC_EmitMergeInputChains1_0,
/* 12750*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12756*/  /*SwitchType*/ 9, /*MVT::funcref*/98|128,1/*226*/, // ->12768
/* 12759*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12760*/   OPC_EmitMergeInputChains1_0,
/* 12761*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 /*MVT::funcref*/98|128,1/*226*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12768*/  /*SwitchType*/ 9, /*MVT::externref*/99|128,1/*227*/, // ->12780
/* 12771*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12772*/   OPC_EmitMergeInputChains1_0,
/* 12773*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 /*MVT::externref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12780*/  /*SwitchType*/ 10, /*MVT::exnref*/100|128,1/*228*/, // ->12793
/* 12783*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12785*/   OPC_EmitMergeInputChains1_0,
/* 12786*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 /*MVT::exnref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12793*/  /*SwitchType*/ 7, /*MVT::f32*/12, // ->12802
/* 12795*/   OPC_EmitMergeInputChains1_0,
/* 12796*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12802*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->12811
/* 12804*/   OPC_EmitMergeInputChains1_0,
/* 12805*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12811*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->12821
/* 12813*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12814*/   OPC_EmitMergeInputChains1_0,
/* 12815*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12821*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->12831
/* 12823*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12824*/   OPC_EmitMergeInputChains1_0,
/* 12825*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12831*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->12841
/* 12833*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12834*/   OPC_EmitMergeInputChains1_0,
/* 12835*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12841*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->12851
/* 12843*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12844*/   OPC_EmitMergeInputChains1_0,
/* 12845*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12851*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->12861
/* 12853*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12854*/   OPC_EmitMergeInputChains1_0,
/* 12855*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12861*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->12871
/* 12863*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12864*/   OPC_EmitMergeInputChains1_0,
/* 12865*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12871*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->12883
/* 12874*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12875*/   OPC_EmitMergeInputChains1_0,
/* 12876*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12883*/  0, // EndSwitchType
/* 12884*/ /*SwitchOpcode*/ 35|128,1/*163*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->13051
/* 12888*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12889*/  OPC_RecordChild1, // #1 = $local
/* 12890*/  OPC_MoveChild1,
/* 12891*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12894*/  OPC_MoveParent,
/* 12895*/  OPC_RecordChild2, // #2 = $src
/* 12896*/  OPC_Scope, 8, /*->12906*/ // 14 children in Scope
/* 12898*/   OPC_CheckChild2TypeI32,
/* 12899*/   OPC_EmitMergeInputChains1_0,
/* 12900*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12906*/  /*Scope*/ 8, /*->12915*/
/* 12907*/   OPC_CheckChild2TypeI64,
/* 12908*/   OPC_EmitMergeInputChains1_0,
/* 12909*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12915*/  /*Scope*/ 9, /*->12925*/
/* 12916*/   OPC_CheckChild2Type, /*MVT::f32*/12, 
/* 12918*/   OPC_EmitMergeInputChains1_0,
/* 12919*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12925*/  /*Scope*/ 9, /*->12935*/
/* 12926*/   OPC_CheckChild2Type, /*MVT::f64*/13, 
/* 12928*/   OPC_EmitMergeInputChains1_0,
/* 12929*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12935*/  /*Scope*/ 10, /*->12946*/
/* 12936*/   OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12938*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12939*/   OPC_EmitMergeInputChains1_0,
/* 12940*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 12946*/  /*Scope*/ 10, /*->12957*/
/* 12947*/   OPC_CheckChild2Type, /*MVT::v4f32*/110, 
/* 12949*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12950*/   OPC_EmitMergeInputChains1_0,
/* 12951*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12957*/  /*Scope*/ 11, /*->12969*/
/* 12958*/   OPC_CheckChild2Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 12961*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12962*/   OPC_EmitMergeInputChains1_0,
/* 12963*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12969*/  /*Scope*/ 10, /*->12980*/
/* 12970*/   OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12972*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12973*/   OPC_EmitMergeInputChains1_0,
/* 12974*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12980*/  /*Scope*/ 10, /*->12991*/
/* 12981*/   OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 12983*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12984*/   OPC_EmitMergeInputChains1_0,
/* 12985*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12991*/  /*Scope*/ 10, /*->13002*/
/* 12992*/   OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 12994*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12995*/   OPC_EmitMergeInputChains1_0,
/* 12996*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 13002*/  /*Scope*/ 10, /*->13013*/
/* 13003*/   OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 13005*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13006*/   OPC_EmitMergeInputChains1_0,
/* 13007*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 13013*/  /*Scope*/ 11, /*->13025*/
/* 13014*/   OPC_CheckChild2Type, /*MVT::funcref*/98|128,1/*226*/, 
/* 13017*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13018*/   OPC_EmitMergeInputChains1_0,
/* 13019*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 13025*/  /*Scope*/ 11, /*->13037*/
/* 13026*/   OPC_CheckChild2Type, /*MVT::externref*/99|128,1/*227*/, 
/* 13029*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13030*/   OPC_EmitMergeInputChains1_0,
/* 13031*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 13037*/  /*Scope*/ 12, /*->13050*/
/* 13038*/   OPC_CheckChild2Type, /*MVT::exnref*/100|128,1/*228*/, 
/* 13041*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 13043*/   OPC_EmitMergeInputChains1_0,
/* 13044*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 13050*/  0, /*End of Scope*/
/* 13051*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13183
/* 13055*/  OPC_RecordChild0, // #0 = $addr
/* 13056*/  OPC_MoveChild0,
/* 13057*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->13108
/* 13061*/   OPC_MoveParent,
/* 13062*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13085
/* 13065*/    OPC_Scope, 8, /*->13075*/ // 2 children in Scope
/* 13067*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13069*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13075*/    /*Scope*/ 8, /*->13084*/
/* 13076*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13078*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13084*/    0, /*End of Scope*/
/* 13085*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13107
/* 13087*/    OPC_Scope, 8, /*->13097*/ // 2 children in Scope
/* 13089*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13091*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13097*/    /*Scope*/ 8, /*->13106*/
/* 13098*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13100*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13106*/    0, /*End of Scope*/
/* 13107*/   0, // EndSwitchType
/* 13108*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13132
/* 13111*/   OPC_MoveParent,
/* 13112*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13122
/* 13115*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13116*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13122*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13131
/* 13124*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13125*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13131*/   0, // EndSwitchType
/* 13132*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13182
/* 13135*/   OPC_MoveParent,
/* 13136*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13159
/* 13139*/    OPC_Scope, 8, /*->13149*/ // 2 children in Scope
/* 13141*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13143*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13149*/    /*Scope*/ 8, /*->13158*/
/* 13150*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13152*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13158*/    0, /*End of Scope*/
/* 13159*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13181
/* 13161*/    OPC_Scope, 8, /*->13171*/ // 2 children in Scope
/* 13163*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13165*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13171*/    /*Scope*/ 8, /*->13180*/
/* 13172*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13174*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13180*/    0, /*End of Scope*/
/* 13181*/   0, // EndSwitchType
/* 13182*/  0, // EndSwitchOpcode
/* 13183*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13266
/* 13186*/  OPC_RecordChild0, // #0 = $addr
/* 13187*/  OPC_MoveChild0,
/* 13188*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13215
/* 13192*/   OPC_MoveParent,
/* 13193*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13204
/* 13196*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13198*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13204*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13214
/* 13206*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13208*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13214*/   0, // EndSwitchType
/* 13215*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13239
/* 13218*/   OPC_MoveParent,
/* 13219*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13229
/* 13222*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13223*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13229*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13238
/* 13231*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13232*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13238*/   0, // EndSwitchType
/* 13239*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13265
/* 13242*/   OPC_MoveParent,
/* 13243*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13254
/* 13246*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13248*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13254*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13264
/* 13256*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13258*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13264*/   0, // EndSwitchType
/* 13265*/  0, // EndSwitchOpcode
/* 13266*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->13316
/* 13269*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13270*/  OPC_RecordChild1, // #1 = $idx
/* 13271*/  OPC_MoveChild1,
/* 13272*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13275*/  OPC_CheckTypeI32,
/* 13276*/  OPC_MoveParent,
/* 13277*/  OPC_RecordChild2, // #2 = $dst
/* 13278*/  OPC_Scope, 17, /*->13297*/ // 2 children in Scope
/* 13280*/   OPC_CheckChild2TypeI32,
/* 13281*/   OPC_RecordChild3, // #3 = $value
/* 13282*/   OPC_CheckChild3TypeI32,
/* 13283*/   OPC_RecordChild4, // #4 = $size
/* 13284*/   OPC_CheckChild4TypeI32,
/* 13285*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13287*/   OPC_EmitMergeInputChains1_0,
/* 13288*/   OPC_EmitConvertToTarget1,
/* 13289*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8923MEMORY_FILL_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_8923MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13297*/  /*Scope*/ 17, /*->13315*/
/* 13298*/   OPC_CheckChild2TypeI64,
/* 13299*/   OPC_RecordChild3, // #3 = $value
/* 13300*/   OPC_CheckChild3TypeI32,
/* 13301*/   OPC_RecordChild4, // #4 = $size
/* 13302*/   OPC_CheckChild4TypeI64,
/* 13303*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13305*/   OPC_EmitMergeInputChains1_0,
/* 13306*/   OPC_EmitConvertToTarget1,
/* 13307*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::anonymous_8924MEMORY_FILL_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_8924MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13315*/  0, /*End of Scope*/
/* 13316*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13340
/* 13319*/  OPC_RecordNode, // #0 = $imm
/* 13320*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13330
/* 13323*/   OPC_EmitConvertToTarget0,
/* 13324*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13330*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13339
/* 13332*/   OPC_EmitConvertToTarget0,
/* 13333*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13339*/  0, // EndSwitchType
/* 13340*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13356
/* 13343*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13344*/  OPC_RecordChild1, // #1 = $dst
/* 13345*/  OPC_MoveChild1,
/* 13346*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13349*/  OPC_MoveParent,
/* 13350*/  OPC_EmitMergeInputChains1_0,
/* 13351*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13356*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13381
/* 13359*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13360*/  OPC_RecordChild1, // #1 = $index
/* 13361*/  OPC_Scope, 8, /*->13371*/ // 2 children in Scope
/* 13363*/   OPC_CheckChild1TypeI32,
/* 13364*/   OPC_EmitMergeInputChains1_0,
/* 13365*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13371*/  /*Scope*/ 8, /*->13380*/
/* 13372*/   OPC_CheckChild1TypeI64,
/* 13373*/   OPC_EmitMergeInputChains1_0,
/* 13374*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13380*/  0, /*End of Scope*/
/* 13381*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13391
/* 13384*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13385*/  OPC_EmitMergeInputChains1_0,
/* 13386*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13391*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13400
/* 13394*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13395*/  OPC_EmitMergeInputChains1_0,
/* 13396*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13400*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13409
/* 13403*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13404*/  OPC_EmitMergeInputChains1_0,
/* 13405*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13409*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->13420
/* 13412*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13413*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13415*/  OPC_EmitMergeInputChains1_0,
/* 13416*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 13420*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13444
/* 13423*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13424*/  OPC_RecordChild1, // #1 = $dst
/* 13425*/  OPC_MoveChild1,
/* 13426*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13429*/  OPC_MoveSibling2,
/* 13430*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13433*/  OPC_RecordNode, // #2 = $from
/* 13434*/  OPC_MoveParent,
/* 13435*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13437*/  OPC_EmitMergeInputChains1_0,
/* 13438*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13444*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13509
/* 13447*/  OPC_RecordChild0, // #0 = $lhs
/* 13448*/  OPC_RecordChild1, // #1 = $rhs
/* 13449*/  OPC_SwitchType /*6 cases */, 7, /*MVT::i32*/7, // ->13459
/* 13452*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13459*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13468
/* 13461*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13468*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->13478
/* 13470*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13471*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13478*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13488
/* 13480*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13481*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13488*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13498
/* 13490*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13491*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13498*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13508
/* 13500*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13501*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13508*/  0, // EndSwitchType
/* 13509*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13625
/* 13512*/  OPC_Scope, 22, /*->13536*/ // 3 children in Scope
/* 13514*/   OPC_RecordChild0, // #0 = $lhs
/* 13515*/   OPC_RecordChild1, // #1 = $rhs
/* 13516*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13526
/* 13519*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13526*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13535
/* 13528*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13535*/   0, // EndSwitchType
/* 13536*/  /*Scope*/ 42, /*->13579*/
/* 13537*/   OPC_MoveChild0,
/* 13538*/   OPC_CheckImmAllZerosV,
/* 13539*/   OPC_MoveParent,
/* 13540*/   OPC_RecordChild1, // #0 = $v
/* 13541*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->13551
/* 13544*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13545*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13551*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->13560
/* 13553*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13554*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13560*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->13569
/* 13562*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13563*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13569*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->13578
/* 13571*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13572*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13578*/   0, // EndSwitchType
/* 13579*/  /*Scope*/ 44, /*->13624*/
/* 13580*/   OPC_RecordChild0, // #0 = $lhs
/* 13581*/   OPC_RecordChild1, // #1 = $rhs
/* 13582*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->13593
/* 13585*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13586*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13593*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13603
/* 13595*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13596*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13603*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13613
/* 13605*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13606*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13613*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13623
/* 13615*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13616*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13623*/   0, // EndSwitchType
/* 13624*/  0, /*End of Scope*/
/* 13625*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13970
/* 13629*/  OPC_Scope, 22, /*->13653*/ // 3 children in Scope
/* 13631*/   OPC_RecordChild0, // #0 = $lhs
/* 13632*/   OPC_RecordChild1, // #1 = $rhs
/* 13633*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13643
/* 13636*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13643*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13652
/* 13645*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13652*/   0, // EndSwitchType
/* 13653*/  /*Scope*/ 23|128,2/*279*/, /*->13934*/
/* 13655*/   OPC_MoveChild0,
/* 13656*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13726
/* 13660*/    OPC_RecordChild0, // #0 = $lhs
/* 13661*/    OPC_Scope, 20, /*->13683*/ // 3 children in Scope
/* 13663*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13665*/     OPC_MoveSibling1,
/* 13666*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13669*/     OPC_RecordChild0, // #1 = $rhs
/* 13670*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13672*/     OPC_MoveParent,
/* 13673*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13675*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13676*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13683*/    /*Scope*/ 20, /*->13704*/
/* 13684*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13686*/     OPC_MoveSibling1,
/* 13687*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13690*/     OPC_RecordChild0, // #1 = $rhs
/* 13691*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13693*/     OPC_MoveParent,
/* 13694*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13696*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13697*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13704*/    /*Scope*/ 20, /*->13725*/
/* 13705*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13707*/     OPC_MoveSibling1,
/* 13708*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13711*/     OPC_RecordChild0, // #1 = $rhs
/* 13712*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13714*/     OPC_MoveParent,
/* 13715*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13717*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13718*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13725*/    0, /*End of Scope*/
/* 13726*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13795
/* 13729*/    OPC_RecordChild0, // #0 = $lhs
/* 13730*/    OPC_Scope, 20, /*->13752*/ // 3 children in Scope
/* 13732*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13734*/     OPC_MoveSibling1,
/* 13735*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13738*/     OPC_RecordChild0, // #1 = $rhs
/* 13739*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13741*/     OPC_MoveParent,
/* 13742*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13744*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13745*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13752*/    /*Scope*/ 20, /*->13773*/
/* 13753*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13755*/     OPC_MoveSibling1,
/* 13756*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13759*/     OPC_RecordChild0, // #1 = $rhs
/* 13760*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13762*/     OPC_MoveParent,
/* 13763*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13765*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13766*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13773*/    /*Scope*/ 20, /*->13794*/
/* 13774*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13776*/     OPC_MoveSibling1,
/* 13777*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13780*/     OPC_RecordChild0, // #1 = $rhs
/* 13781*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13783*/     OPC_MoveParent,
/* 13784*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13786*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13787*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13794*/    0, /*End of Scope*/
/* 13795*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13864
/* 13798*/    OPC_RecordChild0, // #0 = $lhs
/* 13799*/    OPC_Scope, 20, /*->13821*/ // 3 children in Scope
/* 13801*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13803*/     OPC_MoveSibling1,
/* 13804*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13807*/     OPC_RecordChild0, // #1 = $rhs
/* 13808*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13810*/     OPC_MoveParent,
/* 13811*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13813*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13814*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13821*/    /*Scope*/ 20, /*->13842*/
/* 13822*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13824*/     OPC_MoveSibling1,
/* 13825*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13828*/     OPC_RecordChild0, // #1 = $rhs
/* 13829*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13831*/     OPC_MoveParent,
/* 13832*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13834*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13835*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13842*/    /*Scope*/ 20, /*->13863*/
/* 13843*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13845*/     OPC_MoveSibling1,
/* 13846*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13849*/     OPC_RecordChild0, // #1 = $rhs
/* 13850*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13852*/     OPC_MoveParent,
/* 13853*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13855*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13856*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13863*/    0, /*End of Scope*/
/* 13864*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13933
/* 13867*/    OPC_RecordChild0, // #0 = $lhs
/* 13868*/    OPC_Scope, 20, /*->13890*/ // 3 children in Scope
/* 13870*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13872*/     OPC_MoveSibling1,
/* 13873*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13876*/     OPC_RecordChild0, // #1 = $rhs
/* 13877*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13879*/     OPC_MoveParent,
/* 13880*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13882*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13883*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13890*/    /*Scope*/ 20, /*->13911*/
/* 13891*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13893*/     OPC_MoveSibling1,
/* 13894*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13897*/     OPC_RecordChild0, // #1 = $rhs
/* 13898*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13900*/     OPC_MoveParent,
/* 13901*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13903*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13904*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13911*/    /*Scope*/ 20, /*->13932*/
/* 13912*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13914*/     OPC_MoveSibling1,
/* 13915*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13918*/     OPC_RecordChild0, // #1 = $rhs
/* 13919*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13921*/     OPC_MoveParent,
/* 13922*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13924*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13925*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13932*/    0, /*End of Scope*/
/* 13933*/   0, // EndSwitchOpcode
/* 13934*/  /*Scope*/ 34, /*->13969*/
/* 13935*/   OPC_RecordChild0, // #0 = $lhs
/* 13936*/   OPC_RecordChild1, // #1 = $rhs
/* 13937*/   OPC_SwitchType /*3 cases */, 8, /*MVT::v8i16*/50, // ->13948
/* 13940*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13941*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13948*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13958
/* 13950*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13951*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13958*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13968
/* 13960*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13961*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13968*/   0, // EndSwitchType
/* 13969*/  0, /*End of Scope*/
/* 13970*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13995
/* 13973*/  OPC_RecordChild0, // #0 = $lhs
/* 13974*/  OPC_RecordChild1, // #1 = $rhs
/* 13975*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13985
/* 13978*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13985*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13994
/* 13987*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13994*/  0, // EndSwitchType
/* 13995*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->14020
/* 13998*/  OPC_RecordChild0, // #0 = $lhs
/* 13999*/  OPC_RecordChild1, // #1 = $rhs
/* 14000*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14010
/* 14003*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14010*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14019
/* 14012*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14019*/  0, // EndSwitchType
/* 14020*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->14045
/* 14023*/  OPC_RecordChild0, // #0 = $lhs
/* 14024*/  OPC_RecordChild1, // #1 = $rhs
/* 14025*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14035
/* 14028*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14035*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14044
/* 14037*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14044*/  0, // EndSwitchType
/* 14045*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->14070
/* 14048*/  OPC_RecordChild0, // #0 = $lhs
/* 14049*/  OPC_RecordChild1, // #1 = $rhs
/* 14050*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14060
/* 14053*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14060*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14069
/* 14062*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14069*/  0, // EndSwitchType
/* 14070*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14898
/* 14074*/  OPC_Scope, 22, /*->14098*/ // 3 children in Scope
/* 14076*/   OPC_RecordChild0, // #0 = $lhs
/* 14077*/   OPC_RecordChild1, // #1 = $rhs
/* 14078*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14088
/* 14081*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14088*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14097
/* 14090*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14097*/   0, // EndSwitchType
/* 14098*/  /*Scope*/ 116|128,5/*756*/, /*->14856*/
/* 14100*/   OPC_MoveChild0,
/* 14101*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14104*/   OPC_Scope, 4|128,1/*132*/, /*->14239*/ // 9 children in Scope
/* 14107*/    OPC_RecordChild0, // #0 = $c
/* 14108*/    OPC_RecordChild1, // #1 = $v1
/* 14109*/    OPC_MoveSibling1,
/* 14110*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14113*/    OPC_Scope, 54, /*->14169*/ // 4 children in Scope
/* 14115*/     OPC_MoveChild0,
/* 14116*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14119*/     OPC_CheckChild0Same, 0,
/* 14121*/     OPC_MoveChild1,
/* 14122*/     OPC_CheckImmAllOnesV,
/* 14123*/     OPC_MoveParent,
/* 14124*/     OPC_MoveParent,
/* 14125*/     OPC_RecordChild1, // #2 = $v2
/* 14126*/     OPC_MoveParent,
/* 14127*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14138
/* 14130*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14138*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14148
/* 14140*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14148*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14158
/* 14150*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14158*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14168
/* 14160*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14168*/     0, // EndSwitchType
/* 14169*/    /*Scope*/ 22, /*->14192*/
/* 14170*/     OPC_RecordChild0, // #2 = $v2
/* 14171*/     OPC_MoveChild1,
/* 14172*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14175*/     OPC_CheckChild0Same, 0,
/* 14177*/     OPC_MoveChild1,
/* 14178*/     OPC_CheckImmAllOnesV,
/* 14179*/     OPC_MoveParent,
/* 14180*/     OPC_MoveParent,
/* 14181*/     OPC_MoveParent,
/* 14182*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14184*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14192*/    /*Scope*/ 22, /*->14215*/
/* 14193*/     OPC_MoveChild0,
/* 14194*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14197*/     OPC_CheckChild0Same, 1,
/* 14199*/     OPC_MoveChild1,
/* 14200*/     OPC_CheckImmAllOnesV,
/* 14201*/     OPC_MoveParent,
/* 14202*/     OPC_MoveParent,
/* 14203*/     OPC_RecordChild1, // #2 = $v2
/* 14204*/     OPC_MoveParent,
/* 14205*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14207*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14215*/    /*Scope*/ 22, /*->14238*/
/* 14216*/     OPC_RecordChild0, // #2 = $v2
/* 14217*/     OPC_MoveChild1,
/* 14218*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14221*/     OPC_CheckChild0Same, 1,
/* 14223*/     OPC_MoveChild1,
/* 14224*/     OPC_CheckImmAllOnesV,
/* 14225*/     OPC_MoveParent,
/* 14226*/     OPC_MoveParent,
/* 14227*/     OPC_MoveParent,
/* 14228*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14238*/    0, /*End of Scope*/
/* 14239*/   /*Scope*/ 46, /*->14286*/
/* 14240*/    OPC_MoveChild0,
/* 14241*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14244*/    OPC_RecordChild0, // #0 = $c
/* 14245*/    OPC_MoveChild1,
/* 14246*/    OPC_CheckImmAllOnesV,
/* 14247*/    OPC_MoveParent,
/* 14248*/    OPC_MoveParent,
/* 14249*/    OPC_RecordChild1, // #1 = $v2
/* 14250*/    OPC_MoveSibling1,
/* 14251*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14254*/    OPC_Scope, 14, /*->14270*/ // 2 children in Scope
/* 14256*/     OPC_CheckChild0Same, 0,
/* 14258*/     OPC_RecordChild1, // #2 = $v1
/* 14259*/     OPC_MoveParent,
/* 14260*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14262*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14270*/    /*Scope*/ 14, /*->14285*/
/* 14271*/     OPC_RecordChild0, // #2 = $v1
/* 14272*/     OPC_CheckChild1Same, 0,
/* 14274*/     OPC_MoveParent,
/* 14275*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14277*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14285*/    0, /*End of Scope*/
/* 14286*/   /*Scope*/ 126, /*->14413*/
/* 14287*/    OPC_RecordChild0, // #0 = $v2
/* 14288*/    OPC_Scope, 45, /*->14335*/ // 2 children in Scope
/* 14290*/     OPC_MoveChild1,
/* 14291*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14294*/     OPC_RecordChild0, // #1 = $c
/* 14295*/     OPC_MoveChild1,
/* 14296*/     OPC_CheckImmAllOnesV,
/* 14297*/     OPC_MoveParent,
/* 14298*/     OPC_MoveParent,
/* 14299*/     OPC_MoveSibling1,
/* 14300*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14303*/     OPC_Scope, 14, /*->14319*/ // 2 children in Scope
/* 14305*/      OPC_CheckChild0Same, 1,
/* 14307*/      OPC_RecordChild1, // #2 = $v1
/* 14308*/      OPC_MoveParent,
/* 14309*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14311*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14319*/     /*Scope*/ 14, /*->14334*/
/* 14320*/      OPC_RecordChild0, // #2 = $v1
/* 14321*/      OPC_CheckChild1Same, 1,
/* 14323*/      OPC_MoveParent,
/* 14324*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14326*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14334*/     0, /*End of Scope*/
/* 14335*/    /*Scope*/ 76, /*->14412*/
/* 14336*/     OPC_RecordChild1, // #1 = $v1
/* 14337*/     OPC_MoveSibling1,
/* 14338*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14341*/     OPC_Scope, 22, /*->14365*/ // 3 children in Scope
/* 14343*/      OPC_RecordChild0, // #2 = $v2
/* 14344*/      OPC_MoveChild1,
/* 14345*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14348*/      OPC_CheckChild0Same, 0,
/* 14350*/      OPC_MoveChild1,
/* 14351*/      OPC_CheckImmAllOnesV,
/* 14352*/      OPC_MoveParent,
/* 14353*/      OPC_MoveParent,
/* 14354*/      OPC_MoveParent,
/* 14355*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14357*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14365*/     /*Scope*/ 22, /*->14388*/
/* 14366*/      OPC_MoveChild0,
/* 14367*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14370*/      OPC_CheckChild0Same, 1,
/* 14372*/      OPC_MoveChild1,
/* 14373*/      OPC_CheckImmAllOnesV,
/* 14374*/      OPC_MoveParent,
/* 14375*/      OPC_MoveParent,
/* 14376*/      OPC_RecordChild1, // #2 = $v2
/* 14377*/      OPC_MoveParent,
/* 14378*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14380*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14388*/     /*Scope*/ 22, /*->14411*/
/* 14389*/      OPC_RecordChild0, // #2 = $v2
/* 14390*/      OPC_MoveChild1,
/* 14391*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14394*/      OPC_CheckChild0Same, 1,
/* 14396*/      OPC_MoveChild1,
/* 14397*/      OPC_CheckImmAllOnesV,
/* 14398*/      OPC_MoveParent,
/* 14399*/      OPC_MoveParent,
/* 14400*/      OPC_MoveParent,
/* 14401*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14403*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14411*/     0, /*End of Scope*/
/* 14412*/    0, /*End of Scope*/
/* 14413*/   /*Scope*/ 46, /*->14460*/
/* 14414*/    OPC_MoveChild0,
/* 14415*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14418*/    OPC_RecordChild0, // #0 = $c
/* 14419*/    OPC_MoveChild1,
/* 14420*/    OPC_CheckImmAllOnesV,
/* 14421*/    OPC_MoveParent,
/* 14422*/    OPC_MoveParent,
/* 14423*/    OPC_RecordChild1, // #1 = $v2
/* 14424*/    OPC_MoveSibling1,
/* 14425*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14428*/    OPC_Scope, 14, /*->14444*/ // 2 children in Scope
/* 14430*/     OPC_CheckChild0Same, 0,
/* 14432*/     OPC_RecordChild1, // #2 = $v1
/* 14433*/     OPC_MoveParent,
/* 14434*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14436*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14444*/    /*Scope*/ 14, /*->14459*/
/* 14445*/     OPC_RecordChild0, // #2 = $v1
/* 14446*/     OPC_CheckChild1Same, 0,
/* 14448*/     OPC_MoveParent,
/* 14449*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14451*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14459*/    0, /*End of Scope*/
/* 14460*/   /*Scope*/ 126, /*->14587*/
/* 14461*/    OPC_RecordChild0, // #0 = $v2
/* 14462*/    OPC_Scope, 45, /*->14509*/ // 2 children in Scope
/* 14464*/     OPC_MoveChild1,
/* 14465*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14468*/     OPC_RecordChild0, // #1 = $c
/* 14469*/     OPC_MoveChild1,
/* 14470*/     OPC_CheckImmAllOnesV,
/* 14471*/     OPC_MoveParent,
/* 14472*/     OPC_MoveParent,
/* 14473*/     OPC_MoveSibling1,
/* 14474*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14477*/     OPC_Scope, 14, /*->14493*/ // 2 children in Scope
/* 14479*/      OPC_CheckChild0Same, 1,
/* 14481*/      OPC_RecordChild1, // #2 = $v1
/* 14482*/      OPC_MoveParent,
/* 14483*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14485*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14493*/     /*Scope*/ 14, /*->14508*/
/* 14494*/      OPC_RecordChild0, // #2 = $v1
/* 14495*/      OPC_CheckChild1Same, 1,
/* 14497*/      OPC_MoveParent,
/* 14498*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14500*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14508*/     0, /*End of Scope*/
/* 14509*/    /*Scope*/ 76, /*->14586*/
/* 14510*/     OPC_RecordChild1, // #1 = $v1
/* 14511*/     OPC_MoveSibling1,
/* 14512*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14515*/     OPC_Scope, 22, /*->14539*/ // 3 children in Scope
/* 14517*/      OPC_RecordChild0, // #2 = $v2
/* 14518*/      OPC_MoveChild1,
/* 14519*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14522*/      OPC_CheckChild0Same, 0,
/* 14524*/      OPC_MoveChild1,
/* 14525*/      OPC_CheckImmAllOnesV,
/* 14526*/      OPC_MoveParent,
/* 14527*/      OPC_MoveParent,
/* 14528*/      OPC_MoveParent,
/* 14529*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14531*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14539*/     /*Scope*/ 22, /*->14562*/
/* 14540*/      OPC_MoveChild0,
/* 14541*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14544*/      OPC_CheckChild0Same, 1,
/* 14546*/      OPC_MoveChild1,
/* 14547*/      OPC_CheckImmAllOnesV,
/* 14548*/      OPC_MoveParent,
/* 14549*/      OPC_MoveParent,
/* 14550*/      OPC_RecordChild1, // #2 = $v2
/* 14551*/      OPC_MoveParent,
/* 14552*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14554*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14562*/     /*Scope*/ 22, /*->14585*/
/* 14563*/      OPC_RecordChild0, // #2 = $v2
/* 14564*/      OPC_MoveChild1,
/* 14565*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14568*/      OPC_CheckChild0Same, 1,
/* 14570*/      OPC_MoveChild1,
/* 14571*/      OPC_CheckImmAllOnesV,
/* 14572*/      OPC_MoveParent,
/* 14573*/      OPC_MoveParent,
/* 14574*/      OPC_MoveParent,
/* 14575*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14577*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14585*/     0, /*End of Scope*/
/* 14586*/    0, /*End of Scope*/
/* 14587*/   /*Scope*/ 46, /*->14634*/
/* 14588*/    OPC_MoveChild0,
/* 14589*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14592*/    OPC_RecordChild0, // #0 = $c
/* 14593*/    OPC_MoveChild1,
/* 14594*/    OPC_CheckImmAllOnesV,
/* 14595*/    OPC_MoveParent,
/* 14596*/    OPC_MoveParent,
/* 14597*/    OPC_RecordChild1, // #1 = $v2
/* 14598*/    OPC_MoveSibling1,
/* 14599*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14602*/    OPC_Scope, 14, /*->14618*/ // 2 children in Scope
/* 14604*/     OPC_CheckChild0Same, 0,
/* 14606*/     OPC_RecordChild1, // #2 = $v1
/* 14607*/     OPC_MoveParent,
/* 14608*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14610*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14618*/    /*Scope*/ 14, /*->14633*/
/* 14619*/     OPC_RecordChild0, // #2 = $v1
/* 14620*/     OPC_CheckChild1Same, 0,
/* 14622*/     OPC_MoveParent,
/* 14623*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14625*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14633*/    0, /*End of Scope*/
/* 14634*/   /*Scope*/ 126, /*->14761*/
/* 14635*/    OPC_RecordChild0, // #0 = $v2
/* 14636*/    OPC_Scope, 45, /*->14683*/ // 2 children in Scope
/* 14638*/     OPC_MoveChild1,
/* 14639*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14642*/     OPC_RecordChild0, // #1 = $c
/* 14643*/     OPC_MoveChild1,
/* 14644*/     OPC_CheckImmAllOnesV,
/* 14645*/     OPC_MoveParent,
/* 14646*/     OPC_MoveParent,
/* 14647*/     OPC_MoveSibling1,
/* 14648*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14651*/     OPC_Scope, 14, /*->14667*/ // 2 children in Scope
/* 14653*/      OPC_CheckChild0Same, 1,
/* 14655*/      OPC_RecordChild1, // #2 = $v1
/* 14656*/      OPC_MoveParent,
/* 14657*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14659*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14667*/     /*Scope*/ 14, /*->14682*/
/* 14668*/      OPC_RecordChild0, // #2 = $v1
/* 14669*/      OPC_CheckChild1Same, 1,
/* 14671*/      OPC_MoveParent,
/* 14672*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14674*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14682*/     0, /*End of Scope*/
/* 14683*/    /*Scope*/ 76, /*->14760*/
/* 14684*/     OPC_RecordChild1, // #1 = $v1
/* 14685*/     OPC_MoveSibling1,
/* 14686*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14689*/     OPC_Scope, 22, /*->14713*/ // 3 children in Scope
/* 14691*/      OPC_RecordChild0, // #2 = $v2
/* 14692*/      OPC_MoveChild1,
/* 14693*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14696*/      OPC_CheckChild0Same, 0,
/* 14698*/      OPC_MoveChild1,
/* 14699*/      OPC_CheckImmAllOnesV,
/* 14700*/      OPC_MoveParent,
/* 14701*/      OPC_MoveParent,
/* 14702*/      OPC_MoveParent,
/* 14703*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14705*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14713*/     /*Scope*/ 22, /*->14736*/
/* 14714*/      OPC_MoveChild0,
/* 14715*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14718*/      OPC_CheckChild0Same, 1,
/* 14720*/      OPC_MoveChild1,
/* 14721*/      OPC_CheckImmAllOnesV,
/* 14722*/      OPC_MoveParent,
/* 14723*/      OPC_MoveParent,
/* 14724*/      OPC_RecordChild1, // #2 = $v2
/* 14725*/      OPC_MoveParent,
/* 14726*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14728*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14736*/     /*Scope*/ 22, /*->14759*/
/* 14737*/      OPC_RecordChild0, // #2 = $v2
/* 14738*/      OPC_MoveChild1,
/* 14739*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14742*/      OPC_CheckChild0Same, 1,
/* 14744*/      OPC_MoveChild1,
/* 14745*/      OPC_CheckImmAllOnesV,
/* 14746*/      OPC_MoveParent,
/* 14747*/      OPC_MoveParent,
/* 14748*/      OPC_MoveParent,
/* 14749*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14751*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14759*/     0, /*End of Scope*/
/* 14760*/    0, /*End of Scope*/
/* 14761*/   /*Scope*/ 46, /*->14808*/
/* 14762*/    OPC_MoveChild0,
/* 14763*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14766*/    OPC_RecordChild0, // #0 = $c
/* 14767*/    OPC_MoveChild1,
/* 14768*/    OPC_CheckImmAllOnesV,
/* 14769*/    OPC_MoveParent,
/* 14770*/    OPC_MoveParent,
/* 14771*/    OPC_RecordChild1, // #1 = $v2
/* 14772*/    OPC_MoveSibling1,
/* 14773*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14776*/    OPC_Scope, 14, /*->14792*/ // 2 children in Scope
/* 14778*/     OPC_CheckChild0Same, 0,
/* 14780*/     OPC_RecordChild1, // #2 = $v1
/* 14781*/     OPC_MoveParent,
/* 14782*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14784*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14792*/    /*Scope*/ 14, /*->14807*/
/* 14793*/     OPC_RecordChild0, // #2 = $v1
/* 14794*/     OPC_CheckChild1Same, 0,
/* 14796*/     OPC_MoveParent,
/* 14797*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14799*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14807*/    0, /*End of Scope*/
/* 14808*/   /*Scope*/ 46, /*->14855*/
/* 14809*/    OPC_RecordChild0, // #0 = $v2
/* 14810*/    OPC_MoveChild1,
/* 14811*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14814*/    OPC_RecordChild0, // #1 = $c
/* 14815*/    OPC_MoveChild1,
/* 14816*/    OPC_CheckImmAllOnesV,
/* 14817*/    OPC_MoveParent,
/* 14818*/    OPC_MoveParent,
/* 14819*/    OPC_MoveSibling1,
/* 14820*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14823*/    OPC_Scope, 14, /*->14839*/ // 2 children in Scope
/* 14825*/     OPC_CheckChild0Same, 1,
/* 14827*/     OPC_RecordChild1, // #2 = $v1
/* 14828*/     OPC_MoveParent,
/* 14829*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14831*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14839*/    /*Scope*/ 14, /*->14854*/
/* 14840*/     OPC_RecordChild0, // #2 = $v1
/* 14841*/     OPC_CheckChild1Same, 1,
/* 14843*/     OPC_MoveParent,
/* 14844*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14846*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14854*/    0, /*End of Scope*/
/* 14855*/   0, /*End of Scope*/
/* 14856*/  /*Scope*/ 40, /*->14897*/
/* 14857*/   OPC_RecordChild0, // #0 = $lhs
/* 14858*/   OPC_RecordChild1, // #1 = $rhs
/* 14859*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->14869
/* 14862*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14869*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->14878
/* 14871*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14878*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->14887
/* 14880*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14887*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->14896
/* 14889*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14896*/   0, // EndSwitchType
/* 14897*/  0, /*End of Scope*/
/* 14898*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16431
/* 14902*/  OPC_Scope, 22, /*->14926*/ // 17 children in Scope
/* 14904*/   OPC_RecordChild0, // #0 = $lhs
/* 14905*/   OPC_RecordChild1, // #1 = $rhs
/* 14906*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14916
/* 14909*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14916*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14925
/* 14918*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14925*/   0, // EndSwitchType
/* 14926*/  /*Scope*/ 121, /*->15048*/
/* 14927*/   OPC_MoveChild0,
/* 14928*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14931*/   OPC_MoveChild0,
/* 14932*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14935*/   OPC_RecordChild0, // #0 = $v1
/* 14936*/   OPC_Scope, 71, /*->15009*/ // 2 children in Scope
/* 14938*/    OPC_RecordChild1, // #1 = $v2
/* 14939*/    OPC_MoveSibling1,
/* 14940*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14943*/    OPC_RecordChild0, // #2 = $c
/* 14944*/    OPC_MoveChild1,
/* 14945*/    OPC_CheckImmAllOnesV,
/* 14946*/    OPC_MoveParent,
/* 14947*/    OPC_MoveParent,
/* 14948*/    OPC_MoveParent,
/* 14949*/    OPC_Scope, 44, /*->14995*/ // 2 children in Scope
/* 14951*/     OPC_CheckChild1Same, 1,
/* 14953*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14964
/* 14956*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14964*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14974
/* 14966*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14974*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14984
/* 14976*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14984*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14994
/* 14986*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14994*/     0, // EndSwitchType
/* 14995*/    /*Scope*/ 12, /*->15008*/
/* 14996*/     OPC_CheckChild1Same, 0,
/* 14998*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15000*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15008*/    0, /*End of Scope*/
/* 15009*/   /*Scope*/ 37, /*->15047*/
/* 15010*/    OPC_MoveChild1,
/* 15011*/    OPC_CheckImmAllOnesV,
/* 15012*/    OPC_MoveParent,
/* 15013*/    OPC_MoveSibling1,
/* 15014*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15017*/    OPC_RecordChild0, // #1 = $v1
/* 15018*/    OPC_RecordChild1, // #2 = $v2
/* 15019*/    OPC_MoveParent,
/* 15020*/    OPC_MoveParent,
/* 15021*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15023*/    OPC_Scope, 10, /*->15035*/ // 2 children in Scope
/* 15025*/     OPC_CheckChild1Same, 2,
/* 15027*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15035*/    /*Scope*/ 10, /*->15046*/
/* 15036*/     OPC_CheckChild1Same, 1,
/* 15038*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15046*/    0, /*End of Scope*/
/* 15047*/   0, /*End of Scope*/
/* 15048*/  /*Scope*/ 102, /*->15151*/
/* 15049*/   OPC_RecordChild0, // #0 = $v2
/* 15050*/   OPC_MoveChild1,
/* 15051*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15054*/   OPC_MoveChild0,
/* 15055*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15058*/   OPC_Scope, 23, /*->15083*/ // 3 children in Scope
/* 15060*/    OPC_RecordChild0, // #1 = $v1
/* 15061*/    OPC_CheckChild1Same, 0,
/* 15063*/    OPC_MoveSibling1,
/* 15064*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15067*/    OPC_RecordChild0, // #2 = $c
/* 15068*/    OPC_MoveChild1,
/* 15069*/    OPC_CheckImmAllOnesV,
/* 15070*/    OPC_MoveParent,
/* 15071*/    OPC_MoveParent,
/* 15072*/    OPC_MoveParent,
/* 15073*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15075*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15083*/   /*Scope*/ 23, /*->15107*/
/* 15084*/    OPC_CheckChild0Same, 0,
/* 15086*/    OPC_RecordChild1, // #1 = $v1
/* 15087*/    OPC_MoveSibling1,
/* 15088*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15091*/    OPC_RecordChild0, // #2 = $c
/* 15092*/    OPC_MoveChild1,
/* 15093*/    OPC_CheckImmAllOnesV,
/* 15094*/    OPC_MoveParent,
/* 15095*/    OPC_MoveParent,
/* 15096*/    OPC_MoveParent,
/* 15097*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15099*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15107*/   /*Scope*/ 42, /*->15150*/
/* 15108*/    OPC_RecordChild0, // #1 = $c
/* 15109*/    OPC_MoveChild1,
/* 15110*/    OPC_CheckImmAllOnesV,
/* 15111*/    OPC_MoveParent,
/* 15112*/    OPC_MoveSibling1,
/* 15113*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15116*/    OPC_Scope, 15, /*->15133*/ // 2 children in Scope
/* 15118*/     OPC_RecordChild0, // #2 = $v1
/* 15119*/     OPC_CheckChild1Same, 0,
/* 15121*/     OPC_MoveParent,
/* 15122*/     OPC_MoveParent,
/* 15123*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15125*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15133*/    /*Scope*/ 15, /*->15149*/
/* 15134*/     OPC_CheckChild0Same, 0,
/* 15136*/     OPC_RecordChild1, // #2 = $v1
/* 15137*/     OPC_MoveParent,
/* 15138*/     OPC_MoveParent,
/* 15139*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15141*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15149*/    0, /*End of Scope*/
/* 15150*/   0, /*End of Scope*/
/* 15151*/  /*Scope*/ 73, /*->15225*/
/* 15152*/   OPC_MoveChild0,
/* 15153*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15156*/   OPC_MoveChild0,
/* 15157*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15160*/   OPC_RecordChild0, // #0 = $v2
/* 15161*/   OPC_Scope, 23, /*->15186*/ // 2 children in Scope
/* 15163*/    OPC_RecordChild1, // #1 = $v1
/* 15164*/    OPC_MoveSibling1,
/* 15165*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15168*/    OPC_RecordChild0, // #2 = $c
/* 15169*/    OPC_MoveChild1,
/* 15170*/    OPC_CheckImmAllOnesV,
/* 15171*/    OPC_MoveParent,
/* 15172*/    OPC_MoveParent,
/* 15173*/    OPC_MoveParent,
/* 15174*/    OPC_CheckChild1Same, 0,
/* 15176*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15178*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15186*/   /*Scope*/ 37, /*->15224*/
/* 15187*/    OPC_MoveChild1,
/* 15188*/    OPC_CheckImmAllOnesV,
/* 15189*/    OPC_MoveParent,
/* 15190*/    OPC_MoveSibling1,
/* 15191*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15194*/    OPC_RecordChild0, // #1 = $v1
/* 15195*/    OPC_RecordChild1, // #2 = $v2
/* 15196*/    OPC_MoveParent,
/* 15197*/    OPC_MoveParent,
/* 15198*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15200*/    OPC_Scope, 10, /*->15212*/ // 2 children in Scope
/* 15202*/     OPC_CheckChild1Same, 2,
/* 15204*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15212*/    /*Scope*/ 10, /*->15223*/
/* 15213*/     OPC_CheckChild1Same, 1,
/* 15215*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15223*/    0, /*End of Scope*/
/* 15224*/   0, /*End of Scope*/
/* 15225*/  /*Scope*/ 102, /*->15328*/
/* 15226*/   OPC_RecordChild0, // #0 = $v2
/* 15227*/   OPC_MoveChild1,
/* 15228*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15231*/   OPC_MoveChild0,
/* 15232*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15235*/   OPC_Scope, 23, /*->15260*/ // 3 children in Scope
/* 15237*/    OPC_RecordChild0, // #1 = $v1
/* 15238*/    OPC_CheckChild1Same, 0,
/* 15240*/    OPC_MoveSibling1,
/* 15241*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15244*/    OPC_RecordChild0, // #2 = $c
/* 15245*/    OPC_MoveChild1,
/* 15246*/    OPC_CheckImmAllOnesV,
/* 15247*/    OPC_MoveParent,
/* 15248*/    OPC_MoveParent,
/* 15249*/    OPC_MoveParent,
/* 15250*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15252*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15260*/   /*Scope*/ 23, /*->15284*/
/* 15261*/    OPC_CheckChild0Same, 0,
/* 15263*/    OPC_RecordChild1, // #1 = $v1
/* 15264*/    OPC_MoveSibling1,
/* 15265*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15268*/    OPC_RecordChild0, // #2 = $c
/* 15269*/    OPC_MoveChild1,
/* 15270*/    OPC_CheckImmAllOnesV,
/* 15271*/    OPC_MoveParent,
/* 15272*/    OPC_MoveParent,
/* 15273*/    OPC_MoveParent,
/* 15274*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15276*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15284*/   /*Scope*/ 42, /*->15327*/
/* 15285*/    OPC_RecordChild0, // #1 = $c
/* 15286*/    OPC_MoveChild1,
/* 15287*/    OPC_CheckImmAllOnesV,
/* 15288*/    OPC_MoveParent,
/* 15289*/    OPC_MoveSibling1,
/* 15290*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15293*/    OPC_Scope, 15, /*->15310*/ // 2 children in Scope
/* 15295*/     OPC_RecordChild0, // #2 = $v1
/* 15296*/     OPC_CheckChild1Same, 0,
/* 15298*/     OPC_MoveParent,
/* 15299*/     OPC_MoveParent,
/* 15300*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15302*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15310*/    /*Scope*/ 15, /*->15326*/
/* 15311*/     OPC_CheckChild0Same, 0,
/* 15313*/     OPC_RecordChild1, // #2 = $v1
/* 15314*/     OPC_MoveParent,
/* 15315*/     OPC_MoveParent,
/* 15316*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15318*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15326*/    0, /*End of Scope*/
/* 15327*/   0, /*End of Scope*/
/* 15328*/  /*Scope*/ 73, /*->15402*/
/* 15329*/   OPC_MoveChild0,
/* 15330*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15333*/   OPC_MoveChild0,
/* 15334*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15337*/   OPC_RecordChild0, // #0 = $v2
/* 15338*/   OPC_Scope, 23, /*->15363*/ // 2 children in Scope
/* 15340*/    OPC_RecordChild1, // #1 = $v1
/* 15341*/    OPC_MoveSibling1,
/* 15342*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15345*/    OPC_RecordChild0, // #2 = $c
/* 15346*/    OPC_MoveChild1,
/* 15347*/    OPC_CheckImmAllOnesV,
/* 15348*/    OPC_MoveParent,
/* 15349*/    OPC_MoveParent,
/* 15350*/    OPC_MoveParent,
/* 15351*/    OPC_CheckChild1Same, 0,
/* 15353*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15355*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15363*/   /*Scope*/ 37, /*->15401*/
/* 15364*/    OPC_MoveChild1,
/* 15365*/    OPC_CheckImmAllOnesV,
/* 15366*/    OPC_MoveParent,
/* 15367*/    OPC_MoveSibling1,
/* 15368*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15371*/    OPC_RecordChild0, // #1 = $v1
/* 15372*/    OPC_RecordChild1, // #2 = $v2
/* 15373*/    OPC_MoveParent,
/* 15374*/    OPC_MoveParent,
/* 15375*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15377*/    OPC_Scope, 10, /*->15389*/ // 2 children in Scope
/* 15379*/     OPC_CheckChild1Same, 2,
/* 15381*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15389*/    /*Scope*/ 10, /*->15400*/
/* 15390*/     OPC_CheckChild1Same, 1,
/* 15392*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15400*/    0, /*End of Scope*/
/* 15401*/   0, /*End of Scope*/
/* 15402*/  /*Scope*/ 102, /*->15505*/
/* 15403*/   OPC_RecordChild0, // #0 = $v2
/* 15404*/   OPC_MoveChild1,
/* 15405*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15408*/   OPC_MoveChild0,
/* 15409*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15412*/   OPC_Scope, 23, /*->15437*/ // 3 children in Scope
/* 15414*/    OPC_RecordChild0, // #1 = $v1
/* 15415*/    OPC_CheckChild1Same, 0,
/* 15417*/    OPC_MoveSibling1,
/* 15418*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15421*/    OPC_RecordChild0, // #2 = $c
/* 15422*/    OPC_MoveChild1,
/* 15423*/    OPC_CheckImmAllOnesV,
/* 15424*/    OPC_MoveParent,
/* 15425*/    OPC_MoveParent,
/* 15426*/    OPC_MoveParent,
/* 15427*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15429*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15437*/   /*Scope*/ 23, /*->15461*/
/* 15438*/    OPC_CheckChild0Same, 0,
/* 15440*/    OPC_RecordChild1, // #1 = $v1
/* 15441*/    OPC_MoveSibling1,
/* 15442*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15445*/    OPC_RecordChild0, // #2 = $c
/* 15446*/    OPC_MoveChild1,
/* 15447*/    OPC_CheckImmAllOnesV,
/* 15448*/    OPC_MoveParent,
/* 15449*/    OPC_MoveParent,
/* 15450*/    OPC_MoveParent,
/* 15451*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15453*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15461*/   /*Scope*/ 42, /*->15504*/
/* 15462*/    OPC_RecordChild0, // #1 = $c
/* 15463*/    OPC_MoveChild1,
/* 15464*/    OPC_CheckImmAllOnesV,
/* 15465*/    OPC_MoveParent,
/* 15466*/    OPC_MoveSibling1,
/* 15467*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15470*/    OPC_Scope, 15, /*->15487*/ // 2 children in Scope
/* 15472*/     OPC_RecordChild0, // #2 = $v1
/* 15473*/     OPC_CheckChild1Same, 0,
/* 15475*/     OPC_MoveParent,
/* 15476*/     OPC_MoveParent,
/* 15477*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15479*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15487*/    /*Scope*/ 15, /*->15503*/
/* 15488*/     OPC_CheckChild0Same, 0,
/* 15490*/     OPC_RecordChild1, // #2 = $v1
/* 15491*/     OPC_MoveParent,
/* 15492*/     OPC_MoveParent,
/* 15493*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15495*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15503*/    0, /*End of Scope*/
/* 15504*/   0, /*End of Scope*/
/* 15505*/  /*Scope*/ 73, /*->15579*/
/* 15506*/   OPC_MoveChild0,
/* 15507*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15510*/   OPC_MoveChild0,
/* 15511*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15514*/   OPC_RecordChild0, // #0 = $v2
/* 15515*/   OPC_Scope, 23, /*->15540*/ // 2 children in Scope
/* 15517*/    OPC_RecordChild1, // #1 = $v1
/* 15518*/    OPC_MoveSibling1,
/* 15519*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15522*/    OPC_RecordChild0, // #2 = $c
/* 15523*/    OPC_MoveChild1,
/* 15524*/    OPC_CheckImmAllOnesV,
/* 15525*/    OPC_MoveParent,
/* 15526*/    OPC_MoveParent,
/* 15527*/    OPC_MoveParent,
/* 15528*/    OPC_CheckChild1Same, 0,
/* 15530*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15532*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15540*/   /*Scope*/ 37, /*->15578*/
/* 15541*/    OPC_MoveChild1,
/* 15542*/    OPC_CheckImmAllOnesV,
/* 15543*/    OPC_MoveParent,
/* 15544*/    OPC_MoveSibling1,
/* 15545*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15548*/    OPC_RecordChild0, // #1 = $v1
/* 15549*/    OPC_RecordChild1, // #2 = $v2
/* 15550*/    OPC_MoveParent,
/* 15551*/    OPC_MoveParent,
/* 15552*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15554*/    OPC_Scope, 10, /*->15566*/ // 2 children in Scope
/* 15556*/     OPC_CheckChild1Same, 2,
/* 15558*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15566*/    /*Scope*/ 10, /*->15577*/
/* 15567*/     OPC_CheckChild1Same, 1,
/* 15569*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15577*/    0, /*End of Scope*/
/* 15578*/   0, /*End of Scope*/
/* 15579*/  /*Scope*/ 102, /*->15682*/
/* 15580*/   OPC_RecordChild0, // #0 = $v2
/* 15581*/   OPC_MoveChild1,
/* 15582*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15585*/   OPC_MoveChild0,
/* 15586*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15589*/   OPC_Scope, 23, /*->15614*/ // 3 children in Scope
/* 15591*/    OPC_RecordChild0, // #1 = $v1
/* 15592*/    OPC_CheckChild1Same, 0,
/* 15594*/    OPC_MoveSibling1,
/* 15595*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15598*/    OPC_RecordChild0, // #2 = $c
/* 15599*/    OPC_MoveChild1,
/* 15600*/    OPC_CheckImmAllOnesV,
/* 15601*/    OPC_MoveParent,
/* 15602*/    OPC_MoveParent,
/* 15603*/    OPC_MoveParent,
/* 15604*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15606*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15614*/   /*Scope*/ 23, /*->15638*/
/* 15615*/    OPC_CheckChild0Same, 0,
/* 15617*/    OPC_RecordChild1, // #1 = $v1
/* 15618*/    OPC_MoveSibling1,
/* 15619*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15622*/    OPC_RecordChild0, // #2 = $c
/* 15623*/    OPC_MoveChild1,
/* 15624*/    OPC_CheckImmAllOnesV,
/* 15625*/    OPC_MoveParent,
/* 15626*/    OPC_MoveParent,
/* 15627*/    OPC_MoveParent,
/* 15628*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15630*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15638*/   /*Scope*/ 42, /*->15681*/
/* 15639*/    OPC_RecordChild0, // #1 = $c
/* 15640*/    OPC_MoveChild1,
/* 15641*/    OPC_CheckImmAllOnesV,
/* 15642*/    OPC_MoveParent,
/* 15643*/    OPC_MoveSibling1,
/* 15644*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15647*/    OPC_Scope, 15, /*->15664*/ // 2 children in Scope
/* 15649*/     OPC_RecordChild0, // #2 = $v1
/* 15650*/     OPC_CheckChild1Same, 0,
/* 15652*/     OPC_MoveParent,
/* 15653*/     OPC_MoveParent,
/* 15654*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15656*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15664*/    /*Scope*/ 15, /*->15680*/
/* 15665*/     OPC_CheckChild0Same, 0,
/* 15667*/     OPC_RecordChild1, // #2 = $v1
/* 15668*/     OPC_MoveParent,
/* 15669*/     OPC_MoveParent,
/* 15670*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15672*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15680*/    0, /*End of Scope*/
/* 15681*/   0, /*End of Scope*/
/* 15682*/  /*Scope*/ 112, /*->15795*/
/* 15683*/   OPC_MoveChild0,
/* 15684*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15687*/   OPC_Scope, 69, /*->15758*/ // 2 children in Scope
/* 15689*/    OPC_MoveChild0,
/* 15690*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15693*/    OPC_RecordChild0, // #0 = $v1
/* 15694*/    OPC_RecordChild1, // #1 = $v2
/* 15695*/    OPC_MoveParent,
/* 15696*/    OPC_RecordChild1, // #2 = $c
/* 15697*/    OPC_MoveParent,
/* 15698*/    OPC_Scope, 44, /*->15744*/ // 2 children in Scope
/* 15700*/     OPC_CheckChild1Same, 1,
/* 15702*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15713
/* 15705*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15713*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15723
/* 15715*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15723*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15733
/* 15725*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15733*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15743
/* 15735*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15743*/     0, // EndSwitchType
/* 15744*/    /*Scope*/ 12, /*->15757*/
/* 15745*/     OPC_CheckChild1Same, 0,
/* 15747*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15749*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15757*/    0, /*End of Scope*/
/* 15758*/   /*Scope*/ 35, /*->15794*/
/* 15759*/    OPC_RecordChild0, // #0 = $c
/* 15760*/    OPC_MoveChild1,
/* 15761*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15764*/    OPC_RecordChild0, // #1 = $v1
/* 15765*/    OPC_RecordChild1, // #2 = $v2
/* 15766*/    OPC_MoveParent,
/* 15767*/    OPC_MoveParent,
/* 15768*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15770*/    OPC_Scope, 10, /*->15782*/ // 2 children in Scope
/* 15772*/     OPC_CheckChild1Same, 2,
/* 15774*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15782*/    /*Scope*/ 10, /*->15793*/
/* 15783*/     OPC_CheckChild1Same, 1,
/* 15785*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15793*/    0, /*End of Scope*/
/* 15794*/   0, /*End of Scope*/
/* 15795*/  /*Scope*/ 88, /*->15884*/
/* 15796*/   OPC_RecordChild0, // #0 = $v2
/* 15797*/   OPC_MoveChild1,
/* 15798*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15801*/   OPC_Scope, 40, /*->15843*/ // 2 children in Scope
/* 15803*/    OPC_MoveChild0,
/* 15804*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15807*/    OPC_Scope, 16, /*->15825*/ // 2 children in Scope
/* 15809*/     OPC_RecordChild0, // #1 = $v1
/* 15810*/     OPC_CheckChild1Same, 0,
/* 15812*/     OPC_MoveParent,
/* 15813*/     OPC_RecordChild1, // #2 = $c
/* 15814*/     OPC_MoveParent,
/* 15815*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15817*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15825*/    /*Scope*/ 16, /*->15842*/
/* 15826*/     OPC_CheckChild0Same, 0,
/* 15828*/     OPC_RecordChild1, // #1 = $v1
/* 15829*/     OPC_MoveParent,
/* 15830*/     OPC_RecordChild1, // #2 = $c
/* 15831*/     OPC_MoveParent,
/* 15832*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15834*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15842*/    0, /*End of Scope*/
/* 15843*/   /*Scope*/ 39, /*->15883*/
/* 15844*/    OPC_RecordChild0, // #1 = $c
/* 15845*/    OPC_MoveChild1,
/* 15846*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15849*/    OPC_Scope, 15, /*->15866*/ // 2 children in Scope
/* 15851*/     OPC_RecordChild0, // #2 = $v1
/* 15852*/     OPC_CheckChild1Same, 0,
/* 15854*/     OPC_MoveParent,
/* 15855*/     OPC_MoveParent,
/* 15856*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15858*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15866*/    /*Scope*/ 15, /*->15882*/
/* 15867*/     OPC_CheckChild0Same, 0,
/* 15869*/     OPC_RecordChild1, // #2 = $v1
/* 15870*/     OPC_MoveParent,
/* 15871*/     OPC_MoveParent,
/* 15872*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15874*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15882*/    0, /*End of Scope*/
/* 15883*/   0, /*End of Scope*/
/* 15884*/  /*Scope*/ 64, /*->15949*/
/* 15885*/   OPC_MoveChild0,
/* 15886*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15889*/   OPC_Scope, 21, /*->15912*/ // 2 children in Scope
/* 15891*/    OPC_MoveChild0,
/* 15892*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15895*/    OPC_RecordChild0, // #0 = $v2
/* 15896*/    OPC_RecordChild1, // #1 = $v1
/* 15897*/    OPC_MoveParent,
/* 15898*/    OPC_RecordChild1, // #2 = $c
/* 15899*/    OPC_MoveParent,
/* 15900*/    OPC_CheckChild1Same, 0,
/* 15902*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15904*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15912*/   /*Scope*/ 35, /*->15948*/
/* 15913*/    OPC_RecordChild0, // #0 = $c
/* 15914*/    OPC_MoveChild1,
/* 15915*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15918*/    OPC_RecordChild0, // #1 = $v1
/* 15919*/    OPC_RecordChild1, // #2 = $v2
/* 15920*/    OPC_MoveParent,
/* 15921*/    OPC_MoveParent,
/* 15922*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15924*/    OPC_Scope, 10, /*->15936*/ // 2 children in Scope
/* 15926*/     OPC_CheckChild1Same, 2,
/* 15928*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15936*/    /*Scope*/ 10, /*->15947*/
/* 15937*/     OPC_CheckChild1Same, 1,
/* 15939*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15947*/    0, /*End of Scope*/
/* 15948*/   0, /*End of Scope*/
/* 15949*/  /*Scope*/ 88, /*->16038*/
/* 15950*/   OPC_RecordChild0, // #0 = $v2
/* 15951*/   OPC_MoveChild1,
/* 15952*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15955*/   OPC_Scope, 40, /*->15997*/ // 2 children in Scope
/* 15957*/    OPC_MoveChild0,
/* 15958*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15961*/    OPC_Scope, 16, /*->15979*/ // 2 children in Scope
/* 15963*/     OPC_RecordChild0, // #1 = $v1
/* 15964*/     OPC_CheckChild1Same, 0,
/* 15966*/     OPC_MoveParent,
/* 15967*/     OPC_RecordChild1, // #2 = $c
/* 15968*/     OPC_MoveParent,
/* 15969*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15971*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15979*/    /*Scope*/ 16, /*->15996*/
/* 15980*/     OPC_CheckChild0Same, 0,
/* 15982*/     OPC_RecordChild1, // #1 = $v1
/* 15983*/     OPC_MoveParent,
/* 15984*/     OPC_RecordChild1, // #2 = $c
/* 15985*/     OPC_MoveParent,
/* 15986*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15988*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15996*/    0, /*End of Scope*/
/* 15997*/   /*Scope*/ 39, /*->16037*/
/* 15998*/    OPC_RecordChild0, // #1 = $c
/* 15999*/    OPC_MoveChild1,
/* 16000*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16003*/    OPC_Scope, 15, /*->16020*/ // 2 children in Scope
/* 16005*/     OPC_RecordChild0, // #2 = $v1
/* 16006*/     OPC_CheckChild1Same, 0,
/* 16008*/     OPC_MoveParent,
/* 16009*/     OPC_MoveParent,
/* 16010*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16012*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16020*/    /*Scope*/ 15, /*->16036*/
/* 16021*/     OPC_CheckChild0Same, 0,
/* 16023*/     OPC_RecordChild1, // #2 = $v1
/* 16024*/     OPC_MoveParent,
/* 16025*/     OPC_MoveParent,
/* 16026*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16028*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16036*/    0, /*End of Scope*/
/* 16037*/   0, /*End of Scope*/
/* 16038*/  /*Scope*/ 64, /*->16103*/
/* 16039*/   OPC_MoveChild0,
/* 16040*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16043*/   OPC_Scope, 21, /*->16066*/ // 2 children in Scope
/* 16045*/    OPC_MoveChild0,
/* 16046*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16049*/    OPC_RecordChild0, // #0 = $v2
/* 16050*/    OPC_RecordChild1, // #1 = $v1
/* 16051*/    OPC_MoveParent,
/* 16052*/    OPC_RecordChild1, // #2 = $c
/* 16053*/    OPC_MoveParent,
/* 16054*/    OPC_CheckChild1Same, 0,
/* 16056*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16058*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16066*/   /*Scope*/ 35, /*->16102*/
/* 16067*/    OPC_RecordChild0, // #0 = $c
/* 16068*/    OPC_MoveChild1,
/* 16069*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16072*/    OPC_RecordChild0, // #1 = $v1
/* 16073*/    OPC_RecordChild1, // #2 = $v2
/* 16074*/    OPC_MoveParent,
/* 16075*/    OPC_MoveParent,
/* 16076*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16078*/    OPC_Scope, 10, /*->16090*/ // 2 children in Scope
/* 16080*/     OPC_CheckChild1Same, 2,
/* 16082*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16090*/    /*Scope*/ 10, /*->16101*/
/* 16091*/     OPC_CheckChild1Same, 1,
/* 16093*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16101*/    0, /*End of Scope*/
/* 16102*/   0, /*End of Scope*/
/* 16103*/  /*Scope*/ 88, /*->16192*/
/* 16104*/   OPC_RecordChild0, // #0 = $v2
/* 16105*/   OPC_MoveChild1,
/* 16106*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16109*/   OPC_Scope, 40, /*->16151*/ // 2 children in Scope
/* 16111*/    OPC_MoveChild0,
/* 16112*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16115*/    OPC_Scope, 16, /*->16133*/ // 2 children in Scope
/* 16117*/     OPC_RecordChild0, // #1 = $v1
/* 16118*/     OPC_CheckChild1Same, 0,
/* 16120*/     OPC_MoveParent,
/* 16121*/     OPC_RecordChild1, // #2 = $c
/* 16122*/     OPC_MoveParent,
/* 16123*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16125*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16133*/    /*Scope*/ 16, /*->16150*/
/* 16134*/     OPC_CheckChild0Same, 0,
/* 16136*/     OPC_RecordChild1, // #1 = $v1
/* 16137*/     OPC_MoveParent,
/* 16138*/     OPC_RecordChild1, // #2 = $c
/* 16139*/     OPC_MoveParent,
/* 16140*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16142*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16150*/    0, /*End of Scope*/
/* 16151*/   /*Scope*/ 39, /*->16191*/
/* 16152*/    OPC_RecordChild0, // #1 = $c
/* 16153*/    OPC_MoveChild1,
/* 16154*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16157*/    OPC_Scope, 15, /*->16174*/ // 2 children in Scope
/* 16159*/     OPC_RecordChild0, // #2 = $v1
/* 16160*/     OPC_CheckChild1Same, 0,
/* 16162*/     OPC_MoveParent,
/* 16163*/     OPC_MoveParent,
/* 16164*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16166*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16174*/    /*Scope*/ 15, /*->16190*/
/* 16175*/     OPC_CheckChild0Same, 0,
/* 16177*/     OPC_RecordChild1, // #2 = $v1
/* 16178*/     OPC_MoveParent,
/* 16179*/     OPC_MoveParent,
/* 16180*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16182*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16190*/    0, /*End of Scope*/
/* 16191*/   0, /*End of Scope*/
/* 16192*/  /*Scope*/ 64, /*->16257*/
/* 16193*/   OPC_MoveChild0,
/* 16194*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16197*/   OPC_Scope, 21, /*->16220*/ // 2 children in Scope
/* 16199*/    OPC_MoveChild0,
/* 16200*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16203*/    OPC_RecordChild0, // #0 = $v2
/* 16204*/    OPC_RecordChild1, // #1 = $v1
/* 16205*/    OPC_MoveParent,
/* 16206*/    OPC_RecordChild1, // #2 = $c
/* 16207*/    OPC_MoveParent,
/* 16208*/    OPC_CheckChild1Same, 0,
/* 16210*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16212*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16220*/   /*Scope*/ 35, /*->16256*/
/* 16221*/    OPC_RecordChild0, // #0 = $c
/* 16222*/    OPC_MoveChild1,
/* 16223*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16226*/    OPC_RecordChild0, // #1 = $v1
/* 16227*/    OPC_RecordChild1, // #2 = $v2
/* 16228*/    OPC_MoveParent,
/* 16229*/    OPC_MoveParent,
/* 16230*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16232*/    OPC_Scope, 10, /*->16244*/ // 2 children in Scope
/* 16234*/     OPC_CheckChild1Same, 2,
/* 16236*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16244*/    /*Scope*/ 10, /*->16255*/
/* 16245*/     OPC_CheckChild1Same, 1,
/* 16247*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16255*/    0, /*End of Scope*/
/* 16256*/   0, /*End of Scope*/
/* 16257*/  /*Scope*/ 43|128,1/*171*/, /*->16430*/
/* 16259*/   OPC_RecordChild0, // #0 = $v2
/* 16260*/   OPC_Scope, 127, /*->16389*/ // 2 children in Scope
/* 16262*/    OPC_MoveChild1,
/* 16263*/    OPC_Scope, 86, /*->16351*/ // 2 children in Scope
/* 16265*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16268*/     OPC_Scope, 40, /*->16310*/ // 2 children in Scope
/* 16270*/      OPC_MoveChild0,
/* 16271*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16274*/      OPC_Scope, 16, /*->16292*/ // 2 children in Scope
/* 16276*/       OPC_RecordChild0, // #1 = $v1
/* 16277*/       OPC_CheckChild1Same, 0,
/* 16279*/       OPC_MoveParent,
/* 16280*/       OPC_RecordChild1, // #2 = $c
/* 16281*/       OPC_MoveParent,
/* 16282*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16284*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16292*/      /*Scope*/ 16, /*->16309*/
/* 16293*/       OPC_CheckChild0Same, 0,
/* 16295*/       OPC_RecordChild1, // #1 = $v1
/* 16296*/       OPC_MoveParent,
/* 16297*/       OPC_RecordChild1, // #2 = $c
/* 16298*/       OPC_MoveParent,
/* 16299*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16301*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16309*/      0, /*End of Scope*/
/* 16310*/     /*Scope*/ 39, /*->16350*/
/* 16311*/      OPC_RecordChild0, // #1 = $c
/* 16312*/      OPC_MoveChild1,
/* 16313*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16316*/      OPC_Scope, 15, /*->16333*/ // 2 children in Scope
/* 16318*/       OPC_RecordChild0, // #2 = $v1
/* 16319*/       OPC_CheckChild1Same, 0,
/* 16321*/       OPC_MoveParent,
/* 16322*/       OPC_MoveParent,
/* 16323*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16325*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16333*/      /*Scope*/ 15, /*->16349*/
/* 16334*/       OPC_CheckChild0Same, 0,
/* 16336*/       OPC_RecordChild1, // #2 = $v1
/* 16337*/       OPC_MoveParent,
/* 16338*/       OPC_MoveParent,
/* 16339*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16341*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16349*/      0, /*End of Scope*/
/* 16350*/     0, /*End of Scope*/
/* 16351*/    /*Scope*/ 36, /*->16388*/
/* 16352*/     OPC_CheckImmAllOnesV,
/* 16353*/     OPC_MoveParent,
/* 16354*/     OPC_SwitchType /*4 cases */, 6, /*MVT::v16i8*/39, // ->16363
/* 16357*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16363*/     /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->16371
/* 16365*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16371*/     /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->16379
/* 16373*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16379*/     /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->16387
/* 16381*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16387*/     0, // EndSwitchType
/* 16388*/    0, /*End of Scope*/
/* 16389*/   /*Scope*/ 39, /*->16429*/
/* 16390*/    OPC_RecordChild1, // #1 = $rhs
/* 16391*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->16401
/* 16394*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16401*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->16410
/* 16403*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16410*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->16419
/* 16412*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16419*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->16428
/* 16421*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16428*/    0, // EndSwitchType
/* 16429*/   0, /*End of Scope*/
/* 16430*/  0, /*End of Scope*/
/* 16431*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16455
/* 16434*/  OPC_RecordChild0, // #0 = $src
/* 16435*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16445
/* 16438*/   OPC_CheckChild0TypeI32,
/* 16439*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16445*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16454
/* 16447*/   OPC_CheckChild0TypeI64,
/* 16448*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16454*/  0, // EndSwitchType
/* 16455*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16479
/* 16458*/  OPC_RecordChild0, // #0 = $src
/* 16459*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16469
/* 16462*/   OPC_CheckChild0TypeI32,
/* 16463*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16469*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16478
/* 16471*/   OPC_CheckChild0TypeI64,
/* 16472*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16478*/  0, // EndSwitchType
/* 16479*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16514
/* 16482*/  OPC_RecordChild0, // #0 = $src
/* 16483*/  OPC_SwitchType /*3 cases */, 7, /*MVT::i32*/7, // ->16493
/* 16486*/   OPC_CheckChild0TypeI32,
/* 16487*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16493*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16502
/* 16495*/   OPC_CheckChild0TypeI64,
/* 16496*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16502*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->16513
/* 16504*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 16506*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16507*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16513*/  0, // EndSwitchType
/* 16514*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16524
/* 16517*/  OPC_RecordChild0, // #0 = $src
/* 16518*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                /*MVT::i32*/7, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16524*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16534
/* 16527*/  OPC_RecordChild0, // #0 = $src
/* 16528*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                /*MVT::i64*/8, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16534*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->16658
/* 16537*/  OPC_RecordChild0, // #0 = $src
/* 16538*/  OPC_Scope, 48, /*->16588*/ // 4 children in Scope
/* 16540*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16542*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16565
/* 16545*/    OPC_Scope, 8, /*->16555*/ // 2 children in Scope
/* 16547*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16549*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16555*/    /*Scope*/ 8, /*->16564*/
/* 16556*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16558*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16564*/    0, /*End of Scope*/
/* 16565*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16587
/* 16567*/    OPC_Scope, 8, /*->16577*/ // 2 children in Scope
/* 16569*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16571*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16577*/    /*Scope*/ 8, /*->16586*/
/* 16578*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16580*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16586*/    0, /*End of Scope*/
/* 16587*/   0, // EndSwitchType
/* 16588*/  /*Scope*/ 48, /*->16637*/
/* 16589*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16591*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16614
/* 16594*/    OPC_Scope, 8, /*->16604*/ // 2 children in Scope
/* 16596*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16598*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16604*/    /*Scope*/ 8, /*->16613*/
/* 16605*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16607*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16613*/    0, /*End of Scope*/
/* 16614*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16636
/* 16616*/    OPC_Scope, 8, /*->16626*/ // 2 children in Scope
/* 16618*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16620*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16626*/    /*Scope*/ 8, /*->16635*/
/* 16627*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16629*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16635*/    0, /*End of Scope*/
/* 16636*/   0, // EndSwitchType
/* 16637*/  /*Scope*/ 9, /*->16647*/
/* 16638*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16640*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16641*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16647*/  /*Scope*/ 9, /*->16657*/
/* 16648*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16650*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16651*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16657*/  0, /*End of Scope*/
/* 16658*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->16782
/* 16661*/  OPC_RecordChild0, // #0 = $src
/* 16662*/  OPC_Scope, 48, /*->16712*/ // 4 children in Scope
/* 16664*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16666*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16689
/* 16669*/    OPC_Scope, 8, /*->16679*/ // 2 children in Scope
/* 16671*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16673*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16679*/    /*Scope*/ 8, /*->16688*/
/* 16680*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16682*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16688*/    0, /*End of Scope*/
/* 16689*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16711
/* 16691*/    OPC_Scope, 8, /*->16701*/ // 2 children in Scope
/* 16693*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16695*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16701*/    /*Scope*/ 8, /*->16710*/
/* 16702*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16704*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16710*/    0, /*End of Scope*/
/* 16711*/   0, // EndSwitchType
/* 16712*/  /*Scope*/ 48, /*->16761*/
/* 16713*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16715*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16738
/* 16718*/    OPC_Scope, 8, /*->16728*/ // 2 children in Scope
/* 16720*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16722*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16728*/    /*Scope*/ 8, /*->16737*/
/* 16729*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16731*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16737*/    0, /*End of Scope*/
/* 16738*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16760
/* 16740*/    OPC_Scope, 8, /*->16750*/ // 2 children in Scope
/* 16742*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16744*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16750*/    /*Scope*/ 8, /*->16759*/
/* 16751*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16753*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16759*/    0, /*End of Scope*/
/* 16760*/   0, // EndSwitchType
/* 16761*/  /*Scope*/ 9, /*->16771*/
/* 16762*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16764*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16765*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16771*/  /*Scope*/ 9, /*->16781*/
/* 16772*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16774*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16775*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16781*/  0, /*End of Scope*/
/* 16782*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16872
/* 16785*/  OPC_RecordChild0, // #0 = $src
/* 16786*/  OPC_Scope, 27, /*->16815*/ // 3 children in Scope
/* 16788*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16790*/   OPC_MoveChild1,
/* 16791*/   OPC_Scope, 10, /*->16803*/ // 2 children in Scope
/* 16793*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16795*/    OPC_MoveParent,
/* 16796*/    OPC_CheckTypeI32,
/* 16797*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16803*/   /*Scope*/ 10, /*->16814*/
/* 16804*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16806*/    OPC_MoveParent,
/* 16807*/    OPC_CheckTypeI64,
/* 16808*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16814*/   0, /*End of Scope*/
/* 16815*/  /*Scope*/ 27, /*->16843*/
/* 16816*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16818*/   OPC_MoveChild1,
/* 16819*/   OPC_Scope, 10, /*->16831*/ // 2 children in Scope
/* 16821*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16823*/    OPC_MoveParent,
/* 16824*/    OPC_CheckTypeI32,
/* 16825*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16831*/   /*Scope*/ 10, /*->16842*/
/* 16832*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16834*/    OPC_MoveParent,
/* 16835*/    OPC_CheckTypeI64,
/* 16836*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16842*/   0, /*End of Scope*/
/* 16843*/  /*Scope*/ 27, /*->16871*/
/* 16844*/   OPC_MoveChild1,
/* 16845*/   OPC_Scope, 11, /*->16858*/ // 2 children in Scope
/* 16847*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16849*/    OPC_MoveParent,
/* 16850*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16852*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16858*/   /*Scope*/ 11, /*->16870*/
/* 16859*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 16861*/    OPC_MoveParent,
/* 16862*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16864*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 16870*/   0, /*End of Scope*/
/* 16871*/  0, /*End of Scope*/
/* 16872*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->16962
/* 16875*/  OPC_RecordChild0, // #0 = $src
/* 16876*/  OPC_Scope, 27, /*->16905*/ // 3 children in Scope
/* 16878*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16880*/   OPC_MoveChild1,
/* 16881*/   OPC_Scope, 10, /*->16893*/ // 2 children in Scope
/* 16883*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16885*/    OPC_MoveParent,
/* 16886*/    OPC_CheckTypeI32,
/* 16887*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16893*/   /*Scope*/ 10, /*->16904*/
/* 16894*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16896*/    OPC_MoveParent,
/* 16897*/    OPC_CheckTypeI64,
/* 16898*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16904*/   0, /*End of Scope*/
/* 16905*/  /*Scope*/ 27, /*->16933*/
/* 16906*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16908*/   OPC_MoveChild1,
/* 16909*/   OPC_Scope, 10, /*->16921*/ // 2 children in Scope
/* 16911*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16913*/    OPC_MoveParent,
/* 16914*/    OPC_CheckTypeI32,
/* 16915*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16921*/   /*Scope*/ 10, /*->16932*/
/* 16922*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16924*/    OPC_MoveParent,
/* 16925*/    OPC_CheckTypeI64,
/* 16926*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16932*/   0, /*End of Scope*/
/* 16933*/  /*Scope*/ 27, /*->16961*/
/* 16934*/   OPC_MoveChild1,
/* 16935*/   OPC_Scope, 11, /*->16948*/ // 2 children in Scope
/* 16937*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16939*/    OPC_MoveParent,
/* 16940*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16942*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16948*/   /*Scope*/ 11, /*->16960*/
/* 16949*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 16951*/    OPC_MoveParent,
/* 16952*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16954*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 16960*/   0, /*End of Scope*/
/* 16961*/  0, /*End of Scope*/
/* 16962*/ /*SwitchOpcode*/ 39|128,2/*295*/, TARGET_VAL(ISD::BITCAST),// ->17261
/* 16966*/  OPC_RecordChild0, // #0 = $src
/* 16967*/  OPC_Scope, 9, /*->16978*/ // 11 children in Scope
/* 16969*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16971*/   OPC_CheckTypeI32,
/* 16972*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16978*/  /*Scope*/ 9, /*->16988*/
/* 16979*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16981*/   OPC_CheckTypeI64,
/* 16982*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16988*/  /*Scope*/ 9, /*->16998*/
/* 16989*/   OPC_CheckChild0TypeI32,
/* 16990*/   OPC_CheckType, /*MVT::f32*/12, 
/* 16992*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 16998*/  /*Scope*/ 9, /*->17008*/
/* 16999*/   OPC_CheckChild0TypeI64,
/* 17000*/   OPC_CheckType, /*MVT::f64*/13, 
/* 17002*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17008*/  /*Scope*/ 35, /*->17044*/
/* 17009*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 17011*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17017
/* 17014*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17017*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17022
/* 17019*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17022*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17027
/* 17024*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17027*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17032
/* 17029*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17032*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17038
/* 17035*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17038*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17043
/* 17040*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17043*/   0, // EndSwitchType
/* 17044*/  /*Scope*/ 35, /*->17080*/
/* 17045*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 17047*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17053
/* 17050*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17053*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17058
/* 17055*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17058*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17063
/* 17060*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17063*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17068
/* 17065*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17068*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17074
/* 17071*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17074*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17079
/* 17076*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17079*/   0, // EndSwitchType
/* 17080*/  /*Scope*/ 35, /*->17116*/
/* 17081*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 17083*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17089
/* 17086*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17089*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17094
/* 17091*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17094*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17099
/* 17096*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17099*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17104
/* 17101*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17104*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17110
/* 17107*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17110*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17115
/* 17112*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17115*/   0, // EndSwitchType
/* 17116*/  /*Scope*/ 35, /*->17152*/
/* 17117*/   OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 17119*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17125
/* 17122*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17125*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17130
/* 17127*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17130*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17135
/* 17132*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17135*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17140
/* 17137*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17140*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17146
/* 17143*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17146*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17151
/* 17148*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17151*/   0, // EndSwitchType
/* 17152*/  /*Scope*/ 35, /*->17188*/
/* 17153*/   OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 17156*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17162
/* 17159*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17162*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17167
/* 17164*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17167*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17172
/* 17169*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17172*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17177
/* 17174*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17177*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17182
/* 17179*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17182*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17187
/* 17184*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17187*/   0, // EndSwitchType
/* 17188*/  /*Scope*/ 35, /*->17224*/
/* 17189*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 17191*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17197
/* 17194*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17197*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17202
/* 17199*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17202*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17207
/* 17204*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17207*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17212
/* 17209*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17212*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17217
/* 17214*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17217*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17223
/* 17220*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17223*/   0, // EndSwitchType
/* 17224*/  /*Scope*/ 35, /*->17260*/
/* 17225*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 17227*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v8i16*/50, // ->17233
/* 17230*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17233*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17238
/* 17235*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17238*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17243
/* 17240*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17243*/   /*SwitchType*/ 3, /*MVT::v4f32*/110, // ->17248
/* 17245*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17248*/   /*SwitchType*/ 3, /*MVT::v2f64*/0|128,1/*128*/, // ->17254
/* 17251*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17254*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17259
/* 17256*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17259*/   0, // EndSwitchType
/* 17260*/  0, /*End of Scope*/
/* 17261*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17285
/* 17264*/  OPC_RecordNode, // #0 = $imm
/* 17265*/  OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17275
/* 17268*/   OPC_EmitConvertToTarget0,
/* 17269*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17275*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17284
/* 17277*/   OPC_EmitConvertToTarget0,
/* 17278*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17284*/  0, // EndSwitchType
/* 17285*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::SINT_TO_FP),// ->17351
/* 17288*/  OPC_RecordChild0, // #0 = $src
/* 17289*/  OPC_Scope, 19, /*->17310*/ // 4 children in Scope
/* 17291*/   OPC_CheckChild0TypeI32,
/* 17292*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17301
/* 17295*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17301*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17309
/* 17303*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17309*/   0, // EndSwitchType
/* 17310*/  /*Scope*/ 19, /*->17330*/
/* 17311*/   OPC_CheckChild0TypeI64,
/* 17312*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17321
/* 17315*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17321*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17329
/* 17323*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17329*/   0, // EndSwitchType
/* 17330*/  /*Scope*/ 9, /*->17340*/
/* 17331*/   OPC_CheckType, /*MVT::v4f32*/110, 
/* 17333*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17334*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17340*/  /*Scope*/ 9, /*->17350*/
/* 17341*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17343*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17344*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17350*/  0, /*End of Scope*/
/* 17351*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::UINT_TO_FP),// ->17417
/* 17354*/  OPC_RecordChild0, // #0 = $src
/* 17355*/  OPC_Scope, 19, /*->17376*/ // 4 children in Scope
/* 17357*/   OPC_CheckChild0TypeI32,
/* 17358*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17367
/* 17361*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17367*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17375
/* 17369*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17375*/   0, // EndSwitchType
/* 17376*/  /*Scope*/ 19, /*->17396*/
/* 17377*/   OPC_CheckChild0TypeI64,
/* 17378*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17387
/* 17381*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17387*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17395
/* 17389*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17395*/   0, // EndSwitchType
/* 17396*/  /*Scope*/ 9, /*->17406*/
/* 17397*/   OPC_CheckType, /*MVT::v4f32*/110, 
/* 17399*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17400*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17406*/  /*Scope*/ 9, /*->17416*/
/* 17407*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17409*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17410*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17416*/  0, /*End of Scope*/
/* 17417*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17427
/* 17420*/  OPC_RecordChild0, // #0 = $src
/* 17421*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                /*MVT::f64*/13, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17427*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17437
/* 17430*/  OPC_RecordChild0, // #0 = $src
/* 17431*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                /*MVT::f32*/12, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17437*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FADD),// ->17494
/* 17440*/  OPC_RecordChild0, // #0 = $lhs
/* 17441*/  OPC_RecordChild1, // #1 = $rhs
/* 17442*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17452
/* 17445*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17452*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17461
/* 17454*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17461*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17471
/* 17463*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17464*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17471*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17483
/* 17474*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17475*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17483*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17493
/* 17485*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17493*/  0, // EndSwitchType
/* 17494*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FSUB),// ->17551
/* 17497*/  OPC_RecordChild0, // #0 = $lhs
/* 17498*/  OPC_RecordChild1, // #1 = $rhs
/* 17499*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17509
/* 17502*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17509*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17518
/* 17511*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17518*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17528
/* 17520*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17521*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17528*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17540
/* 17531*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17532*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17540*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17550
/* 17542*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17543*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17550*/  0, // EndSwitchType
/* 17551*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMUL),// ->17608
/* 17554*/  OPC_RecordChild0, // #0 = $lhs
/* 17555*/  OPC_RecordChild1, // #1 = $rhs
/* 17556*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17566
/* 17559*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17566*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17575
/* 17568*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17575*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17585
/* 17577*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17578*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17585*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17597
/* 17588*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17589*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17597*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17607
/* 17599*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17600*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17607*/  0, // EndSwitchType
/* 17608*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FDIV),// ->17665
/* 17611*/  OPC_RecordChild0, // #0 = $lhs
/* 17612*/  OPC_RecordChild1, // #1 = $rhs
/* 17613*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17623
/* 17616*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17623*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17632
/* 17625*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17632*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17642
/* 17634*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17635*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17642*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17654
/* 17645*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17646*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17654*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17664
/* 17656*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17657*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17664*/  0, // EndSwitchType
/* 17665*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSQRT),// ->17716
/* 17668*/  OPC_RecordChild0, // #0 = $src
/* 17669*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17678
/* 17672*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17678*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17686
/* 17680*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17686*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->17695
/* 17688*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17689*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17695*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->17706
/* 17698*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17699*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17706*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17715
/* 17708*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17709*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17715*/  0, // EndSwitchType
/* 17716*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FABS),// ->17767
/* 17719*/  OPC_RecordChild0, // #0 = $src
/* 17720*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17729
/* 17723*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17729*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17737
/* 17731*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17737*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->17746
/* 17739*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17740*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17746*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->17757
/* 17749*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17750*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17757*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17766
/* 17759*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17760*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17766*/  0, // EndSwitchType
/* 17767*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEG),// ->17818
/* 17770*/  OPC_RecordChild0, // #0 = $src
/* 17771*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17780
/* 17774*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17780*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17788
/* 17782*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17788*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->17797
/* 17790*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17791*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17797*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->17808
/* 17800*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17801*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17808*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17817
/* 17810*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17811*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17817*/  0, // EndSwitchType
/* 17818*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17883
/* 17821*/  OPC_RecordChild0, // #0 = $lhs
/* 17822*/  OPC_RecordChild1, // #1 = $rhs
/* 17823*/  OPC_Scope, 28, /*->17853*/ // 2 children in Scope
/* 17825*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 17827*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17837
/* 17830*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17837*/   /*SwitchType*/ 13, /*MVT::f64*/13, // ->17852
/* 17839*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  /*MVT::f64*/13, 1/*#Ops*/, 1,  // Results = #2
/* 17845*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17852*/   0, // EndSwitchType
/* 17853*/  /*Scope*/ 28, /*->17882*/
/* 17854*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 17856*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f64*/13, // ->17866
/* 17859*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17866*/   /*SwitchType*/ 13, /*MVT::f32*/12, // ->17881
/* 17868*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  /*MVT::f32*/12, 1/*#Ops*/, 1,  // Results = #2
/* 17874*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17881*/   0, // EndSwitchType
/* 17882*/  0, /*End of Scope*/
/* 17883*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMINIMUM),// ->17940
/* 17886*/  OPC_RecordChild0, // #0 = $lhs
/* 17887*/  OPC_RecordChild1, // #1 = $rhs
/* 17888*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17898
/* 17891*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17898*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17907
/* 17900*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17907*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17917
/* 17909*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17910*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17917*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17929
/* 17920*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17921*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17929*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17939
/* 17931*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17932*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17939*/  0, // EndSwitchType
/* 17940*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMAXIMUM),// ->17997
/* 17943*/  OPC_RecordChild0, // #0 = $lhs
/* 17944*/  OPC_RecordChild1, // #1 = $rhs
/* 17945*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17955
/* 17948*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17955*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17964
/* 17957*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17964*/  /*SwitchType*/ 8, /*MVT::v4f32*/110, // ->17974
/* 17966*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17967*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17974*/  /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->17986
/* 17977*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17978*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17986*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17996
/* 17988*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17989*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17996*/  0, // EndSwitchType
/* 17997*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FCEIL),// ->18048
/* 18000*/  OPC_RecordChild0, // #0 = $src
/* 18001*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18010
/* 18004*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18010*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18018
/* 18012*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18018*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18027
/* 18020*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18021*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18027*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18038
/* 18030*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18031*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18038*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18047
/* 18040*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18041*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18047*/  0, // EndSwitchType
/* 18048*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FFLOOR),// ->18099
/* 18051*/  OPC_RecordChild0, // #0 = $src
/* 18052*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18061
/* 18055*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18061*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18069
/* 18063*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18069*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18078
/* 18071*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18072*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18078*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18089
/* 18081*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18082*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18089*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18098
/* 18091*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18092*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18098*/  0, // EndSwitchType
/* 18099*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FTRUNC),// ->18150
/* 18102*/  OPC_RecordChild0, // #0 = $src
/* 18103*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18112
/* 18106*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18112*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18120
/* 18114*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18120*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18129
/* 18122*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18123*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18129*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18140
/* 18132*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18133*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18140*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18149
/* 18142*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18143*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18149*/  0, // EndSwitchType
/* 18150*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEARBYINT),// ->18201
/* 18153*/  OPC_RecordChild0, // #0 = $src
/* 18154*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18163
/* 18157*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18163*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18171
/* 18165*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18171*/  /*SwitchType*/ 7, /*MVT::v4f32*/110, // ->18180
/* 18173*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18174*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18180*/  /*SwitchType*/ 8, /*MVT::v2f64*/0|128,1/*128*/, // ->18191
/* 18183*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18184*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18191*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18200
/* 18193*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18200*/  0, // EndSwitchType
/* 18201*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FRINT),// ->18249
/* 18204*/  OPC_RecordChild0, // #0 = $src
/* 18205*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18214
/* 18208*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18214*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18222
/* 18216*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18222*/  /*SwitchType*/ 6, /*MVT::v4f32*/110, // ->18230
/* 18224*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18230*/  /*SwitchType*/ 7, /*MVT::v2f64*/0|128,1/*128*/, // ->18240
/* 18233*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18240*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18248
/* 18242*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18248*/  0, // EndSwitchType
/* 18249*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FROUNDEVEN),// ->18297
/* 18252*/  OPC_RecordChild0, // #0 = $src
/* 18253*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18262
/* 18256*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18262*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18270
/* 18264*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18270*/  /*SwitchType*/ 6, /*MVT::v4f32*/110, // ->18278
/* 18272*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18278*/  /*SwitchType*/ 7, /*MVT::v2f64*/0|128,1/*128*/, // ->18288
/* 18281*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18288*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18296
/* 18290*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18296*/  0, // EndSwitchType
/* 18297*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18707
/* 18301*/  OPC_RecordChild0, // #0 = $i0
/* 18302*/  OPC_MoveChild0,
/* 18303*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18637
/* 18308*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, /*MVT::i32*/7, // ->18615
/* 18312*/    OPC_Scope, 51|128,1/*179*/, /*->18494*/ // 3 children in Scope
/* 18315*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18317*/     OPC_MoveSibling1,
/* 18318*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18321*/     OPC_RecordNode, // #1 = $i1
/* 18322*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18324*/     OPC_CheckTypeI32,
/* 18325*/     OPC_MoveSibling2,
/* 18326*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18329*/     OPC_RecordNode, // #2 = $i2
/* 18330*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18332*/     OPC_CheckTypeI32,
/* 18333*/     OPC_MoveSibling3,
/* 18334*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18337*/     OPC_RecordNode, // #3 = $i3
/* 18338*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18340*/     OPC_CheckTypeI32,
/* 18341*/     OPC_MoveSibling4,
/* 18342*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18345*/     OPC_RecordNode, // #4 = $i4
/* 18346*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18348*/     OPC_CheckTypeI32,
/* 18349*/     OPC_MoveSibling5,
/* 18350*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18353*/     OPC_RecordNode, // #5 = $i5
/* 18354*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18356*/     OPC_CheckTypeI32,
/* 18357*/     OPC_MoveSibling6,
/* 18358*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18361*/     OPC_RecordNode, // #6 = $i6
/* 18362*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18364*/     OPC_CheckTypeI32,
/* 18365*/     OPC_MoveSibling7,
/* 18366*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18369*/     OPC_RecordNode, // #7 = $i7
/* 18370*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18372*/     OPC_CheckTypeI32,
/* 18373*/     OPC_MoveSibling, 8,
/* 18375*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18378*/     OPC_RecordNode, // #8 = $i8
/* 18379*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18381*/     OPC_CheckTypeI32,
/* 18382*/     OPC_MoveSibling, 9,
/* 18384*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18387*/     OPC_RecordNode, // #9 = $i9
/* 18388*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18390*/     OPC_CheckTypeI32,
/* 18391*/     OPC_MoveSibling, 10,
/* 18393*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18396*/     OPC_RecordNode, // #10 = $iA
/* 18397*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18399*/     OPC_CheckTypeI32,
/* 18400*/     OPC_MoveSibling, 11,
/* 18402*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18405*/     OPC_RecordNode, // #11 = $iB
/* 18406*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18408*/     OPC_CheckTypeI32,
/* 18409*/     OPC_MoveSibling, 12,
/* 18411*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18414*/     OPC_RecordNode, // #12 = $iC
/* 18415*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18417*/     OPC_CheckTypeI32,
/* 18418*/     OPC_MoveSibling, 13,
/* 18420*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18423*/     OPC_RecordNode, // #13 = $iD
/* 18424*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18426*/     OPC_CheckTypeI32,
/* 18427*/     OPC_MoveSibling, 14,
/* 18429*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18432*/     OPC_RecordNode, // #14 = $iE
/* 18433*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18435*/     OPC_CheckTypeI32,
/* 18436*/     OPC_MoveSibling, 15,
/* 18438*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18441*/     OPC_RecordNode, // #15 = $iF
/* 18442*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18444*/     OPC_CheckTypeI32,
/* 18445*/     OPC_MoveParent,
/* 18446*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 18448*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18449*/     OPC_EmitConvertToTarget0,
/* 18450*/     OPC_EmitConvertToTarget1,
/* 18451*/     OPC_EmitConvertToTarget2,
/* 18452*/     OPC_EmitConvertToTarget3,
/* 18453*/     OPC_EmitConvertToTarget4,
/* 18454*/     OPC_EmitConvertToTarget5,
/* 18455*/     OPC_EmitConvertToTarget6,
/* 18456*/     OPC_EmitConvertToTarget7,
/* 18457*/     OPC_EmitConvertToTarget, 8,
/* 18459*/     OPC_EmitConvertToTarget, 9,
/* 18461*/     OPC_EmitConvertToTarget, 10,
/* 18463*/     OPC_EmitConvertToTarget, 11,
/* 18465*/     OPC_EmitConvertToTarget, 12,
/* 18467*/     OPC_EmitConvertToTarget, 13,
/* 18469*/     OPC_EmitConvertToTarget, 14,
/* 18471*/     OPC_EmitConvertToTarget, 15,
/* 18473*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   /*MVT::v16i8*/39, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18494*/    /*Scope*/ 83, /*->18578*/
/* 18495*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18497*/     OPC_MoveSibling1,
/* 18498*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18501*/     OPC_RecordNode, // #1 = $i1
/* 18502*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18504*/     OPC_CheckTypeI32,
/* 18505*/     OPC_MoveSibling2,
/* 18506*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18509*/     OPC_RecordNode, // #2 = $i2
/* 18510*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18512*/     OPC_CheckTypeI32,
/* 18513*/     OPC_MoveSibling3,
/* 18514*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18517*/     OPC_RecordNode, // #3 = $i3
/* 18518*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18520*/     OPC_CheckTypeI32,
/* 18521*/     OPC_MoveSibling4,
/* 18522*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18525*/     OPC_RecordNode, // #4 = $i4
/* 18526*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18528*/     OPC_CheckTypeI32,
/* 18529*/     OPC_MoveSibling5,
/* 18530*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18533*/     OPC_RecordNode, // #5 = $i5
/* 18534*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18536*/     OPC_CheckTypeI32,
/* 18537*/     OPC_MoveSibling6,
/* 18538*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18541*/     OPC_RecordNode, // #6 = $i6
/* 18542*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18544*/     OPC_CheckTypeI32,
/* 18545*/     OPC_MoveSibling7,
/* 18546*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18549*/     OPC_RecordNode, // #7 = $i7
/* 18550*/     OPC_CheckPredicate, 18, // Predicate_ImmI16
/* 18552*/     OPC_CheckTypeI32,
/* 18553*/     OPC_MoveParent,
/* 18554*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 18556*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18557*/     OPC_EmitConvertToTarget0,
/* 18558*/     OPC_EmitConvertToTarget1,
/* 18559*/     OPC_EmitConvertToTarget2,
/* 18560*/     OPC_EmitConvertToTarget3,
/* 18561*/     OPC_EmitConvertToTarget4,
/* 18562*/     OPC_EmitConvertToTarget5,
/* 18563*/     OPC_EmitConvertToTarget6,
/* 18564*/     OPC_EmitConvertToTarget7,
/* 18565*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   /*MVT::v8i16*/50, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18578*/    /*Scope*/ 35, /*->18614*/
/* 18579*/     OPC_MoveSibling1,
/* 18580*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18583*/     OPC_RecordNode, // #1 = $i1
/* 18584*/     OPC_CheckTypeI32,
/* 18585*/     OPC_MoveSibling2,
/* 18586*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18589*/     OPC_RecordNode, // #2 = $i2
/* 18590*/     OPC_CheckTypeI32,
/* 18591*/     OPC_MoveSibling3,
/* 18592*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18595*/     OPC_RecordNode, // #3 = $i3
/* 18596*/     OPC_CheckTypeI32,
/* 18597*/     OPC_MoveParent,
/* 18598*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 18600*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18601*/     OPC_EmitConvertToTarget0,
/* 18602*/     OPC_EmitConvertToTarget1,
/* 18603*/     OPC_EmitConvertToTarget2,
/* 18604*/     OPC_EmitConvertToTarget3,
/* 18605*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   /*MVT::v4i32*/60, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18614*/    0, /*End of Scope*/
/* 18615*/   /*SwitchType*/ 19, /*MVT::i64*/8, // ->18636
/* 18617*/    OPC_MoveSibling1,
/* 18618*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18621*/    OPC_RecordNode, // #1 = $i1
/* 18622*/    OPC_CheckTypeI64,
/* 18623*/    OPC_MoveParent,
/* 18624*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 18626*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18627*/    OPC_EmitConvertToTarget0,
/* 18628*/    OPC_EmitConvertToTarget1,
/* 18629*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18636*/   0, // EndSwitchType
/* 18637*/  /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ConstantFP),// ->18706
/* 18640*/   OPC_SwitchType /*2 cases */, 38, /*MVT::f32*/12, // ->18681
/* 18643*/    OPC_MoveSibling1,
/* 18644*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18647*/    OPC_RecordNode, // #1 = $i1
/* 18648*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18650*/    OPC_MoveSibling2,
/* 18651*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18654*/    OPC_RecordNode, // #2 = $i2
/* 18655*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18657*/    OPC_MoveSibling3,
/* 18658*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18661*/    OPC_RecordNode, // #3 = $i3
/* 18662*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18664*/    OPC_MoveParent,
/* 18665*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 18667*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18668*/    OPC_EmitConvertToTarget0,
/* 18669*/    OPC_EmitConvertToTarget1,
/* 18670*/    OPC_EmitConvertToTarget2,
/* 18671*/    OPC_EmitConvertToTarget3,
/* 18672*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  /*MVT::v4f32*/110, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18681*/   /*SwitchType*/ 22, /*MVT::f64*/13, // ->18705
/* 18683*/    OPC_MoveSibling1,
/* 18684*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18687*/    OPC_RecordNode, // #1 = $i1
/* 18688*/    OPC_CheckType, /*MVT::f64*/13, 
/* 18690*/    OPC_MoveParent,
/* 18691*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 18694*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18695*/    OPC_EmitConvertToTarget0,
/* 18696*/    OPC_EmitConvertToTarget1,
/* 18697*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18705*/   0, // EndSwitchType
/* 18706*/  0, // EndSwitchOpcode
/* 18707*/ /*SwitchOpcode*/ 7|128,16/*2055*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20766
/* 18711*/  OPC_RecordChild0, // #0 = $x
/* 18712*/  OPC_Scope, 83|128,2/*339*/, /*->19054*/ // 6 children in Scope
/* 18715*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 18717*/   OPC_RecordChild1, // #1 = $y
/* 18718*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 18720*/   OPC_RecordChild2, // #2 = $m0
/* 18721*/   OPC_MoveChild2,
/* 18722*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18896
/* 18727*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18728*/    OPC_CheckTypeI32,
/* 18729*/    OPC_MoveSibling3,
/* 18730*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18733*/    OPC_RecordNode, // #3 = $m1
/* 18734*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18735*/    OPC_CheckTypeI32,
/* 18736*/    OPC_MoveSibling4,
/* 18737*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18740*/    OPC_RecordNode, // #4 = $m2
/* 18741*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18742*/    OPC_CheckTypeI32,
/* 18743*/    OPC_MoveSibling5,
/* 18744*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18747*/    OPC_RecordNode, // #5 = $m3
/* 18748*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18749*/    OPC_CheckTypeI32,
/* 18750*/    OPC_MoveSibling6,
/* 18751*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18754*/    OPC_RecordNode, // #6 = $m4
/* 18755*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18756*/    OPC_CheckTypeI32,
/* 18757*/    OPC_MoveSibling7,
/* 18758*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18761*/    OPC_RecordNode, // #7 = $m5
/* 18762*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18763*/    OPC_CheckTypeI32,
/* 18764*/    OPC_MoveSibling, 8,
/* 18766*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18769*/    OPC_RecordNode, // #8 = $m6
/* 18770*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18771*/    OPC_CheckTypeI32,
/* 18772*/    OPC_MoveSibling, 9,
/* 18774*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18777*/    OPC_RecordNode, // #9 = $m7
/* 18778*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18779*/    OPC_CheckTypeI32,
/* 18780*/    OPC_MoveSibling, 10,
/* 18782*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18785*/    OPC_RecordNode, // #10 = $m8
/* 18786*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18787*/    OPC_CheckTypeI32,
/* 18788*/    OPC_MoveSibling, 11,
/* 18790*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18793*/    OPC_RecordNode, // #11 = $m9
/* 18794*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18795*/    OPC_CheckTypeI32,
/* 18796*/    OPC_MoveSibling, 12,
/* 18798*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18801*/    OPC_RecordNode, // #12 = $mA
/* 18802*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18803*/    OPC_CheckTypeI32,
/* 18804*/    OPC_MoveSibling, 13,
/* 18806*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18809*/    OPC_RecordNode, // #13 = $mB
/* 18810*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18811*/    OPC_CheckTypeI32,
/* 18812*/    OPC_MoveSibling, 14,
/* 18814*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18817*/    OPC_RecordNode, // #14 = $mC
/* 18818*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18819*/    OPC_CheckTypeI32,
/* 18820*/    OPC_MoveSibling, 15,
/* 18822*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18825*/    OPC_RecordNode, // #15 = $mD
/* 18826*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18827*/    OPC_CheckTypeI32,
/* 18828*/    OPC_MoveSibling, 16,
/* 18830*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18833*/    OPC_RecordNode, // #16 = $mE
/* 18834*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18835*/    OPC_CheckTypeI32,
/* 18836*/    OPC_MoveSibling, 17,
/* 18838*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18841*/    OPC_RecordNode, // #17 = $mF
/* 18842*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18843*/    OPC_CheckTypeI32,
/* 18844*/    OPC_MoveParent,
/* 18845*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 18847*/    OPC_EmitConvertToTarget2,
/* 18848*/    OPC_EmitConvertToTarget3,
/* 18849*/    OPC_EmitConvertToTarget4,
/* 18850*/    OPC_EmitConvertToTarget5,
/* 18851*/    OPC_EmitConvertToTarget6,
/* 18852*/    OPC_EmitConvertToTarget7,
/* 18853*/    OPC_EmitConvertToTarget, 8,
/* 18855*/    OPC_EmitConvertToTarget, 9,
/* 18857*/    OPC_EmitConvertToTarget, 10,
/* 18859*/    OPC_EmitConvertToTarget, 11,
/* 18861*/    OPC_EmitConvertToTarget, 12,
/* 18863*/    OPC_EmitConvertToTarget, 13,
/* 18865*/    OPC_EmitConvertToTarget, 14,
/* 18867*/    OPC_EmitConvertToTarget, 15,
/* 18869*/    OPC_EmitConvertToTarget, 16,
/* 18871*/    OPC_EmitConvertToTarget, 17,
/* 18873*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18896*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19053
/* 18900*/    OPC_CheckTypeI32,
/* 18901*/    OPC_MoveSibling3,
/* 18902*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18905*/    OPC_RecordNode, // #3 = $m1
/* 18906*/    OPC_CheckTypeI32,
/* 18907*/    OPC_MoveSibling4,
/* 18908*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18911*/    OPC_RecordNode, // #4 = $m2
/* 18912*/    OPC_CheckTypeI32,
/* 18913*/    OPC_MoveSibling5,
/* 18914*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18917*/    OPC_RecordNode, // #5 = $m3
/* 18918*/    OPC_CheckTypeI32,
/* 18919*/    OPC_MoveSibling6,
/* 18920*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18923*/    OPC_RecordNode, // #6 = $m4
/* 18924*/    OPC_CheckTypeI32,
/* 18925*/    OPC_MoveSibling7,
/* 18926*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18929*/    OPC_RecordNode, // #7 = $m5
/* 18930*/    OPC_CheckTypeI32,
/* 18931*/    OPC_MoveSibling, 8,
/* 18933*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18936*/    OPC_RecordNode, // #8 = $m6
/* 18937*/    OPC_CheckTypeI32,
/* 18938*/    OPC_MoveSibling, 9,
/* 18940*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18943*/    OPC_RecordNode, // #9 = $m7
/* 18944*/    OPC_CheckTypeI32,
/* 18945*/    OPC_MoveSibling, 10,
/* 18947*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18950*/    OPC_RecordNode, // #10 = $m8
/* 18951*/    OPC_CheckTypeI32,
/* 18952*/    OPC_MoveSibling, 11,
/* 18954*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18957*/    OPC_RecordNode, // #11 = $m9
/* 18958*/    OPC_CheckTypeI32,
/* 18959*/    OPC_MoveSibling, 12,
/* 18961*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18964*/    OPC_RecordNode, // #12 = $mA
/* 18965*/    OPC_CheckTypeI32,
/* 18966*/    OPC_MoveSibling, 13,
/* 18968*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18971*/    OPC_RecordNode, // #13 = $mB
/* 18972*/    OPC_CheckTypeI32,
/* 18973*/    OPC_MoveSibling, 14,
/* 18975*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18978*/    OPC_RecordNode, // #14 = $mC
/* 18979*/    OPC_CheckTypeI32,
/* 18980*/    OPC_MoveSibling, 15,
/* 18982*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18985*/    OPC_RecordNode, // #15 = $mD
/* 18986*/    OPC_CheckTypeI32,
/* 18987*/    OPC_MoveSibling, 16,
/* 18989*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18992*/    OPC_RecordNode, // #16 = $mE
/* 18993*/    OPC_CheckTypeI32,
/* 18994*/    OPC_MoveSibling, 17,
/* 18996*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18999*/    OPC_RecordNode, // #17 = $mF
/* 19000*/    OPC_CheckTypeI32,
/* 19001*/    OPC_MoveParent,
/* 19002*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 19004*/    OPC_EmitConvertToTarget2,
/* 19005*/    OPC_EmitConvertToTarget3,
/* 19006*/    OPC_EmitConvertToTarget4,
/* 19007*/    OPC_EmitConvertToTarget5,
/* 19008*/    OPC_EmitConvertToTarget6,
/* 19009*/    OPC_EmitConvertToTarget7,
/* 19010*/    OPC_EmitConvertToTarget, 8,
/* 19012*/    OPC_EmitConvertToTarget, 9,
/* 19014*/    OPC_EmitConvertToTarget, 10,
/* 19016*/    OPC_EmitConvertToTarget, 11,
/* 19018*/    OPC_EmitConvertToTarget, 12,
/* 19020*/    OPC_EmitConvertToTarget, 13,
/* 19022*/    OPC_EmitConvertToTarget, 14,
/* 19024*/    OPC_EmitConvertToTarget, 15,
/* 19026*/    OPC_EmitConvertToTarget, 16,
/* 19028*/    OPC_EmitConvertToTarget, 17,
/* 19030*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19053*/   0, // EndSwitchOpcode
/* 19054*/  /*Scope*/ 83|128,2/*339*/, /*->19395*/
/* 19056*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 19058*/   OPC_RecordChild1, // #1 = $y
/* 19059*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 19061*/   OPC_RecordChild2, // #2 = $m0
/* 19062*/   OPC_MoveChild2,
/* 19063*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19237
/* 19068*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19069*/    OPC_CheckTypeI32,
/* 19070*/    OPC_MoveSibling3,
/* 19071*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19074*/    OPC_RecordNode, // #3 = $m1
/* 19075*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19076*/    OPC_CheckTypeI32,
/* 19077*/    OPC_MoveSibling4,
/* 19078*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19081*/    OPC_RecordNode, // #4 = $m2
/* 19082*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19083*/    OPC_CheckTypeI32,
/* 19084*/    OPC_MoveSibling5,
/* 19085*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19088*/    OPC_RecordNode, // #5 = $m3
/* 19089*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19090*/    OPC_CheckTypeI32,
/* 19091*/    OPC_MoveSibling6,
/* 19092*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19095*/    OPC_RecordNode, // #6 = $m4
/* 19096*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19097*/    OPC_CheckTypeI32,
/* 19098*/    OPC_MoveSibling7,
/* 19099*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19102*/    OPC_RecordNode, // #7 = $m5
/* 19103*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19104*/    OPC_CheckTypeI32,
/* 19105*/    OPC_MoveSibling, 8,
/* 19107*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19110*/    OPC_RecordNode, // #8 = $m6
/* 19111*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19112*/    OPC_CheckTypeI32,
/* 19113*/    OPC_MoveSibling, 9,
/* 19115*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19118*/    OPC_RecordNode, // #9 = $m7
/* 19119*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19120*/    OPC_CheckTypeI32,
/* 19121*/    OPC_MoveSibling, 10,
/* 19123*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19126*/    OPC_RecordNode, // #10 = $m8
/* 19127*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19128*/    OPC_CheckTypeI32,
/* 19129*/    OPC_MoveSibling, 11,
/* 19131*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19134*/    OPC_RecordNode, // #11 = $m9
/* 19135*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19136*/    OPC_CheckTypeI32,
/* 19137*/    OPC_MoveSibling, 12,
/* 19139*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19142*/    OPC_RecordNode, // #12 = $mA
/* 19143*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19144*/    OPC_CheckTypeI32,
/* 19145*/    OPC_MoveSibling, 13,
/* 19147*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19150*/    OPC_RecordNode, // #13 = $mB
/* 19151*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19152*/    OPC_CheckTypeI32,
/* 19153*/    OPC_MoveSibling, 14,
/* 19155*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19158*/    OPC_RecordNode, // #14 = $mC
/* 19159*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19160*/    OPC_CheckTypeI32,
/* 19161*/    OPC_MoveSibling, 15,
/* 19163*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19166*/    OPC_RecordNode, // #15 = $mD
/* 19167*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19168*/    OPC_CheckTypeI32,
/* 19169*/    OPC_MoveSibling, 16,
/* 19171*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19174*/    OPC_RecordNode, // #16 = $mE
/* 19175*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19176*/    OPC_CheckTypeI32,
/* 19177*/    OPC_MoveSibling, 17,
/* 19179*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19182*/    OPC_RecordNode, // #17 = $mF
/* 19183*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19184*/    OPC_CheckTypeI32,
/* 19185*/    OPC_MoveParent,
/* 19186*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19188*/    OPC_EmitConvertToTarget2,
/* 19189*/    OPC_EmitConvertToTarget3,
/* 19190*/    OPC_EmitConvertToTarget4,
/* 19191*/    OPC_EmitConvertToTarget5,
/* 19192*/    OPC_EmitConvertToTarget6,
/* 19193*/    OPC_EmitConvertToTarget7,
/* 19194*/    OPC_EmitConvertToTarget, 8,
/* 19196*/    OPC_EmitConvertToTarget, 9,
/* 19198*/    OPC_EmitConvertToTarget, 10,
/* 19200*/    OPC_EmitConvertToTarget, 11,
/* 19202*/    OPC_EmitConvertToTarget, 12,
/* 19204*/    OPC_EmitConvertToTarget, 13,
/* 19206*/    OPC_EmitConvertToTarget, 14,
/* 19208*/    OPC_EmitConvertToTarget, 15,
/* 19210*/    OPC_EmitConvertToTarget, 16,
/* 19212*/    OPC_EmitConvertToTarget, 17,
/* 19214*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19237*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19394
/* 19241*/    OPC_CheckTypeI32,
/* 19242*/    OPC_MoveSibling3,
/* 19243*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19246*/    OPC_RecordNode, // #3 = $m1
/* 19247*/    OPC_CheckTypeI32,
/* 19248*/    OPC_MoveSibling4,
/* 19249*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19252*/    OPC_RecordNode, // #4 = $m2
/* 19253*/    OPC_CheckTypeI32,
/* 19254*/    OPC_MoveSibling5,
/* 19255*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19258*/    OPC_RecordNode, // #5 = $m3
/* 19259*/    OPC_CheckTypeI32,
/* 19260*/    OPC_MoveSibling6,
/* 19261*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19264*/    OPC_RecordNode, // #6 = $m4
/* 19265*/    OPC_CheckTypeI32,
/* 19266*/    OPC_MoveSibling7,
/* 19267*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19270*/    OPC_RecordNode, // #7 = $m5
/* 19271*/    OPC_CheckTypeI32,
/* 19272*/    OPC_MoveSibling, 8,
/* 19274*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19277*/    OPC_RecordNode, // #8 = $m6
/* 19278*/    OPC_CheckTypeI32,
/* 19279*/    OPC_MoveSibling, 9,
/* 19281*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19284*/    OPC_RecordNode, // #9 = $m7
/* 19285*/    OPC_CheckTypeI32,
/* 19286*/    OPC_MoveSibling, 10,
/* 19288*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19291*/    OPC_RecordNode, // #10 = $m8
/* 19292*/    OPC_CheckTypeI32,
/* 19293*/    OPC_MoveSibling, 11,
/* 19295*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19298*/    OPC_RecordNode, // #11 = $m9
/* 19299*/    OPC_CheckTypeI32,
/* 19300*/    OPC_MoveSibling, 12,
/* 19302*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19305*/    OPC_RecordNode, // #12 = $mA
/* 19306*/    OPC_CheckTypeI32,
/* 19307*/    OPC_MoveSibling, 13,
/* 19309*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19312*/    OPC_RecordNode, // #13 = $mB
/* 19313*/    OPC_CheckTypeI32,
/* 19314*/    OPC_MoveSibling, 14,
/* 19316*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19319*/    OPC_RecordNode, // #14 = $mC
/* 19320*/    OPC_CheckTypeI32,
/* 19321*/    OPC_MoveSibling, 15,
/* 19323*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19326*/    OPC_RecordNode, // #15 = $mD
/* 19327*/    OPC_CheckTypeI32,
/* 19328*/    OPC_MoveSibling, 16,
/* 19330*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19333*/    OPC_RecordNode, // #16 = $mE
/* 19334*/    OPC_CheckTypeI32,
/* 19335*/    OPC_MoveSibling, 17,
/* 19337*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19340*/    OPC_RecordNode, // #17 = $mF
/* 19341*/    OPC_CheckTypeI32,
/* 19342*/    OPC_MoveParent,
/* 19343*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19345*/    OPC_EmitConvertToTarget2,
/* 19346*/    OPC_EmitConvertToTarget3,
/* 19347*/    OPC_EmitConvertToTarget4,
/* 19348*/    OPC_EmitConvertToTarget5,
/* 19349*/    OPC_EmitConvertToTarget6,
/* 19350*/    OPC_EmitConvertToTarget7,
/* 19351*/    OPC_EmitConvertToTarget, 8,
/* 19353*/    OPC_EmitConvertToTarget, 9,
/* 19355*/    OPC_EmitConvertToTarget, 10,
/* 19357*/    OPC_EmitConvertToTarget, 11,
/* 19359*/    OPC_EmitConvertToTarget, 12,
/* 19361*/    OPC_EmitConvertToTarget, 13,
/* 19363*/    OPC_EmitConvertToTarget, 14,
/* 19365*/    OPC_EmitConvertToTarget, 15,
/* 19367*/    OPC_EmitConvertToTarget, 16,
/* 19369*/    OPC_EmitConvertToTarget, 17,
/* 19371*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19394*/   0, // EndSwitchOpcode
/* 19395*/  /*Scope*/ 83|128,2/*339*/, /*->19736*/
/* 19397*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 19399*/   OPC_RecordChild1, // #1 = $y
/* 19400*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 19402*/   OPC_RecordChild2, // #2 = $m0
/* 19403*/   OPC_MoveChild2,
/* 19404*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19578
/* 19409*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19410*/    OPC_CheckTypeI32,
/* 19411*/    OPC_MoveSibling3,
/* 19412*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19415*/    OPC_RecordNode, // #3 = $m1
/* 19416*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19417*/    OPC_CheckTypeI32,
/* 19418*/    OPC_MoveSibling4,
/* 19419*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19422*/    OPC_RecordNode, // #4 = $m2
/* 19423*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19424*/    OPC_CheckTypeI32,
/* 19425*/    OPC_MoveSibling5,
/* 19426*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19429*/    OPC_RecordNode, // #5 = $m3
/* 19430*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19431*/    OPC_CheckTypeI32,
/* 19432*/    OPC_MoveSibling6,
/* 19433*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19436*/    OPC_RecordNode, // #6 = $m4
/* 19437*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19438*/    OPC_CheckTypeI32,
/* 19439*/    OPC_MoveSibling7,
/* 19440*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19443*/    OPC_RecordNode, // #7 = $m5
/* 19444*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19445*/    OPC_CheckTypeI32,
/* 19446*/    OPC_MoveSibling, 8,
/* 19448*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19451*/    OPC_RecordNode, // #8 = $m6
/* 19452*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19453*/    OPC_CheckTypeI32,
/* 19454*/    OPC_MoveSibling, 9,
/* 19456*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19459*/    OPC_RecordNode, // #9 = $m7
/* 19460*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19461*/    OPC_CheckTypeI32,
/* 19462*/    OPC_MoveSibling, 10,
/* 19464*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19467*/    OPC_RecordNode, // #10 = $m8
/* 19468*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19469*/    OPC_CheckTypeI32,
/* 19470*/    OPC_MoveSibling, 11,
/* 19472*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19475*/    OPC_RecordNode, // #11 = $m9
/* 19476*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19477*/    OPC_CheckTypeI32,
/* 19478*/    OPC_MoveSibling, 12,
/* 19480*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19483*/    OPC_RecordNode, // #12 = $mA
/* 19484*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19485*/    OPC_CheckTypeI32,
/* 19486*/    OPC_MoveSibling, 13,
/* 19488*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19491*/    OPC_RecordNode, // #13 = $mB
/* 19492*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19493*/    OPC_CheckTypeI32,
/* 19494*/    OPC_MoveSibling, 14,
/* 19496*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19499*/    OPC_RecordNode, // #14 = $mC
/* 19500*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19501*/    OPC_CheckTypeI32,
/* 19502*/    OPC_MoveSibling, 15,
/* 19504*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19507*/    OPC_RecordNode, // #15 = $mD
/* 19508*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19509*/    OPC_CheckTypeI32,
/* 19510*/    OPC_MoveSibling, 16,
/* 19512*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19515*/    OPC_RecordNode, // #16 = $mE
/* 19516*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19517*/    OPC_CheckTypeI32,
/* 19518*/    OPC_MoveSibling, 17,
/* 19520*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19523*/    OPC_RecordNode, // #17 = $mF
/* 19524*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19525*/    OPC_CheckTypeI32,
/* 19526*/    OPC_MoveParent,
/* 19527*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19529*/    OPC_EmitConvertToTarget2,
/* 19530*/    OPC_EmitConvertToTarget3,
/* 19531*/    OPC_EmitConvertToTarget4,
/* 19532*/    OPC_EmitConvertToTarget5,
/* 19533*/    OPC_EmitConvertToTarget6,
/* 19534*/    OPC_EmitConvertToTarget7,
/* 19535*/    OPC_EmitConvertToTarget, 8,
/* 19537*/    OPC_EmitConvertToTarget, 9,
/* 19539*/    OPC_EmitConvertToTarget, 10,
/* 19541*/    OPC_EmitConvertToTarget, 11,
/* 19543*/    OPC_EmitConvertToTarget, 12,
/* 19545*/    OPC_EmitConvertToTarget, 13,
/* 19547*/    OPC_EmitConvertToTarget, 14,
/* 19549*/    OPC_EmitConvertToTarget, 15,
/* 19551*/    OPC_EmitConvertToTarget, 16,
/* 19553*/    OPC_EmitConvertToTarget, 17,
/* 19555*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19578*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19735
/* 19582*/    OPC_CheckTypeI32,
/* 19583*/    OPC_MoveSibling3,
/* 19584*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19587*/    OPC_RecordNode, // #3 = $m1
/* 19588*/    OPC_CheckTypeI32,
/* 19589*/    OPC_MoveSibling4,
/* 19590*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19593*/    OPC_RecordNode, // #4 = $m2
/* 19594*/    OPC_CheckTypeI32,
/* 19595*/    OPC_MoveSibling5,
/* 19596*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19599*/    OPC_RecordNode, // #5 = $m3
/* 19600*/    OPC_CheckTypeI32,
/* 19601*/    OPC_MoveSibling6,
/* 19602*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19605*/    OPC_RecordNode, // #6 = $m4
/* 19606*/    OPC_CheckTypeI32,
/* 19607*/    OPC_MoveSibling7,
/* 19608*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19611*/    OPC_RecordNode, // #7 = $m5
/* 19612*/    OPC_CheckTypeI32,
/* 19613*/    OPC_MoveSibling, 8,
/* 19615*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19618*/    OPC_RecordNode, // #8 = $m6
/* 19619*/    OPC_CheckTypeI32,
/* 19620*/    OPC_MoveSibling, 9,
/* 19622*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19625*/    OPC_RecordNode, // #9 = $m7
/* 19626*/    OPC_CheckTypeI32,
/* 19627*/    OPC_MoveSibling, 10,
/* 19629*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19632*/    OPC_RecordNode, // #10 = $m8
/* 19633*/    OPC_CheckTypeI32,
/* 19634*/    OPC_MoveSibling, 11,
/* 19636*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19639*/    OPC_RecordNode, // #11 = $m9
/* 19640*/    OPC_CheckTypeI32,
/* 19641*/    OPC_MoveSibling, 12,
/* 19643*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19646*/    OPC_RecordNode, // #12 = $mA
/* 19647*/    OPC_CheckTypeI32,
/* 19648*/    OPC_MoveSibling, 13,
/* 19650*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19653*/    OPC_RecordNode, // #13 = $mB
/* 19654*/    OPC_CheckTypeI32,
/* 19655*/    OPC_MoveSibling, 14,
/* 19657*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19660*/    OPC_RecordNode, // #14 = $mC
/* 19661*/    OPC_CheckTypeI32,
/* 19662*/    OPC_MoveSibling, 15,
/* 19664*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19667*/    OPC_RecordNode, // #15 = $mD
/* 19668*/    OPC_CheckTypeI32,
/* 19669*/    OPC_MoveSibling, 16,
/* 19671*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19674*/    OPC_RecordNode, // #16 = $mE
/* 19675*/    OPC_CheckTypeI32,
/* 19676*/    OPC_MoveSibling, 17,
/* 19678*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19681*/    OPC_RecordNode, // #17 = $mF
/* 19682*/    OPC_CheckTypeI32,
/* 19683*/    OPC_MoveParent,
/* 19684*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19686*/    OPC_EmitConvertToTarget2,
/* 19687*/    OPC_EmitConvertToTarget3,
/* 19688*/    OPC_EmitConvertToTarget4,
/* 19689*/    OPC_EmitConvertToTarget5,
/* 19690*/    OPC_EmitConvertToTarget6,
/* 19691*/    OPC_EmitConvertToTarget7,
/* 19692*/    OPC_EmitConvertToTarget, 8,
/* 19694*/    OPC_EmitConvertToTarget, 9,
/* 19696*/    OPC_EmitConvertToTarget, 10,
/* 19698*/    OPC_EmitConvertToTarget, 11,
/* 19700*/    OPC_EmitConvertToTarget, 12,
/* 19702*/    OPC_EmitConvertToTarget, 13,
/* 19704*/    OPC_EmitConvertToTarget, 14,
/* 19706*/    OPC_EmitConvertToTarget, 15,
/* 19708*/    OPC_EmitConvertToTarget, 16,
/* 19710*/    OPC_EmitConvertToTarget, 17,
/* 19712*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19735*/   0, // EndSwitchOpcode
/* 19736*/  /*Scope*/ 83|128,2/*339*/, /*->20077*/
/* 19738*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 19740*/   OPC_RecordChild1, // #1 = $y
/* 19741*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 19743*/   OPC_RecordChild2, // #2 = $m0
/* 19744*/   OPC_MoveChild2,
/* 19745*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19919
/* 19750*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19751*/    OPC_CheckTypeI32,
/* 19752*/    OPC_MoveSibling3,
/* 19753*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19756*/    OPC_RecordNode, // #3 = $m1
/* 19757*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19758*/    OPC_CheckTypeI32,
/* 19759*/    OPC_MoveSibling4,
/* 19760*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19763*/    OPC_RecordNode, // #4 = $m2
/* 19764*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19765*/    OPC_CheckTypeI32,
/* 19766*/    OPC_MoveSibling5,
/* 19767*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19770*/    OPC_RecordNode, // #5 = $m3
/* 19771*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19772*/    OPC_CheckTypeI32,
/* 19773*/    OPC_MoveSibling6,
/* 19774*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19777*/    OPC_RecordNode, // #6 = $m4
/* 19778*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19779*/    OPC_CheckTypeI32,
/* 19780*/    OPC_MoveSibling7,
/* 19781*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19784*/    OPC_RecordNode, // #7 = $m5
/* 19785*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19786*/    OPC_CheckTypeI32,
/* 19787*/    OPC_MoveSibling, 8,
/* 19789*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19792*/    OPC_RecordNode, // #8 = $m6
/* 19793*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19794*/    OPC_CheckTypeI32,
/* 19795*/    OPC_MoveSibling, 9,
/* 19797*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19800*/    OPC_RecordNode, // #9 = $m7
/* 19801*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19802*/    OPC_CheckTypeI32,
/* 19803*/    OPC_MoveSibling, 10,
/* 19805*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19808*/    OPC_RecordNode, // #10 = $m8
/* 19809*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19810*/    OPC_CheckTypeI32,
/* 19811*/    OPC_MoveSibling, 11,
/* 19813*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19816*/    OPC_RecordNode, // #11 = $m9
/* 19817*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19818*/    OPC_CheckTypeI32,
/* 19819*/    OPC_MoveSibling, 12,
/* 19821*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19824*/    OPC_RecordNode, // #12 = $mA
/* 19825*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19826*/    OPC_CheckTypeI32,
/* 19827*/    OPC_MoveSibling, 13,
/* 19829*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19832*/    OPC_RecordNode, // #13 = $mB
/* 19833*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19834*/    OPC_CheckTypeI32,
/* 19835*/    OPC_MoveSibling, 14,
/* 19837*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19840*/    OPC_RecordNode, // #14 = $mC
/* 19841*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19842*/    OPC_CheckTypeI32,
/* 19843*/    OPC_MoveSibling, 15,
/* 19845*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19848*/    OPC_RecordNode, // #15 = $mD
/* 19849*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19850*/    OPC_CheckTypeI32,
/* 19851*/    OPC_MoveSibling, 16,
/* 19853*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19856*/    OPC_RecordNode, // #16 = $mE
/* 19857*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19858*/    OPC_CheckTypeI32,
/* 19859*/    OPC_MoveSibling, 17,
/* 19861*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19864*/    OPC_RecordNode, // #17 = $mF
/* 19865*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19866*/    OPC_CheckTypeI32,
/* 19867*/    OPC_MoveParent,
/* 19868*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 19870*/    OPC_EmitConvertToTarget2,
/* 19871*/    OPC_EmitConvertToTarget3,
/* 19872*/    OPC_EmitConvertToTarget4,
/* 19873*/    OPC_EmitConvertToTarget5,
/* 19874*/    OPC_EmitConvertToTarget6,
/* 19875*/    OPC_EmitConvertToTarget7,
/* 19876*/    OPC_EmitConvertToTarget, 8,
/* 19878*/    OPC_EmitConvertToTarget, 9,
/* 19880*/    OPC_EmitConvertToTarget, 10,
/* 19882*/    OPC_EmitConvertToTarget, 11,
/* 19884*/    OPC_EmitConvertToTarget, 12,
/* 19886*/    OPC_EmitConvertToTarget, 13,
/* 19888*/    OPC_EmitConvertToTarget, 14,
/* 19890*/    OPC_EmitConvertToTarget, 15,
/* 19892*/    OPC_EmitConvertToTarget, 16,
/* 19894*/    OPC_EmitConvertToTarget, 17,
/* 19896*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19919*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20076
/* 19923*/    OPC_CheckTypeI32,
/* 19924*/    OPC_MoveSibling3,
/* 19925*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19928*/    OPC_RecordNode, // #3 = $m1
/* 19929*/    OPC_CheckTypeI32,
/* 19930*/    OPC_MoveSibling4,
/* 19931*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19934*/    OPC_RecordNode, // #4 = $m2
/* 19935*/    OPC_CheckTypeI32,
/* 19936*/    OPC_MoveSibling5,
/* 19937*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19940*/    OPC_RecordNode, // #5 = $m3
/* 19941*/    OPC_CheckTypeI32,
/* 19942*/    OPC_MoveSibling6,
/* 19943*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19946*/    OPC_RecordNode, // #6 = $m4
/* 19947*/    OPC_CheckTypeI32,
/* 19948*/    OPC_MoveSibling7,
/* 19949*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19952*/    OPC_RecordNode, // #7 = $m5
/* 19953*/    OPC_CheckTypeI32,
/* 19954*/    OPC_MoveSibling, 8,
/* 19956*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19959*/    OPC_RecordNode, // #8 = $m6
/* 19960*/    OPC_CheckTypeI32,
/* 19961*/    OPC_MoveSibling, 9,
/* 19963*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19966*/    OPC_RecordNode, // #9 = $m7
/* 19967*/    OPC_CheckTypeI32,
/* 19968*/    OPC_MoveSibling, 10,
/* 19970*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19973*/    OPC_RecordNode, // #10 = $m8
/* 19974*/    OPC_CheckTypeI32,
/* 19975*/    OPC_MoveSibling, 11,
/* 19977*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19980*/    OPC_RecordNode, // #11 = $m9
/* 19981*/    OPC_CheckTypeI32,
/* 19982*/    OPC_MoveSibling, 12,
/* 19984*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19987*/    OPC_RecordNode, // #12 = $mA
/* 19988*/    OPC_CheckTypeI32,
/* 19989*/    OPC_MoveSibling, 13,
/* 19991*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19994*/    OPC_RecordNode, // #13 = $mB
/* 19995*/    OPC_CheckTypeI32,
/* 19996*/    OPC_MoveSibling, 14,
/* 19998*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20001*/    OPC_RecordNode, // #14 = $mC
/* 20002*/    OPC_CheckTypeI32,
/* 20003*/    OPC_MoveSibling, 15,
/* 20005*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20008*/    OPC_RecordNode, // #15 = $mD
/* 20009*/    OPC_CheckTypeI32,
/* 20010*/    OPC_MoveSibling, 16,
/* 20012*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20015*/    OPC_RecordNode, // #16 = $mE
/* 20016*/    OPC_CheckTypeI32,
/* 20017*/    OPC_MoveSibling, 17,
/* 20019*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20022*/    OPC_RecordNode, // #17 = $mF
/* 20023*/    OPC_CheckTypeI32,
/* 20024*/    OPC_MoveParent,
/* 20025*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 20027*/    OPC_EmitConvertToTarget2,
/* 20028*/    OPC_EmitConvertToTarget3,
/* 20029*/    OPC_EmitConvertToTarget4,
/* 20030*/    OPC_EmitConvertToTarget5,
/* 20031*/    OPC_EmitConvertToTarget6,
/* 20032*/    OPC_EmitConvertToTarget7,
/* 20033*/    OPC_EmitConvertToTarget, 8,
/* 20035*/    OPC_EmitConvertToTarget, 9,
/* 20037*/    OPC_EmitConvertToTarget, 10,
/* 20039*/    OPC_EmitConvertToTarget, 11,
/* 20041*/    OPC_EmitConvertToTarget, 12,
/* 20043*/    OPC_EmitConvertToTarget, 13,
/* 20045*/    OPC_EmitConvertToTarget, 14,
/* 20047*/    OPC_EmitConvertToTarget, 15,
/* 20049*/    OPC_EmitConvertToTarget, 16,
/* 20051*/    OPC_EmitConvertToTarget, 17,
/* 20053*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20076*/   0, // EndSwitchOpcode
/* 20077*/  /*Scope*/ 83|128,2/*339*/, /*->20418*/
/* 20079*/   OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 20081*/   OPC_RecordChild1, // #1 = $y
/* 20082*/   OPC_CheckChild1Type, /*MVT::v4f32*/110, 
/* 20084*/   OPC_RecordChild2, // #2 = $m0
/* 20085*/   OPC_MoveChild2,
/* 20086*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20260
/* 20091*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20092*/    OPC_CheckTypeI32,
/* 20093*/    OPC_MoveSibling3,
/* 20094*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20097*/    OPC_RecordNode, // #3 = $m1
/* 20098*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20099*/    OPC_CheckTypeI32,
/* 20100*/    OPC_MoveSibling4,
/* 20101*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20104*/    OPC_RecordNode, // #4 = $m2
/* 20105*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20106*/    OPC_CheckTypeI32,
/* 20107*/    OPC_MoveSibling5,
/* 20108*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20111*/    OPC_RecordNode, // #5 = $m3
/* 20112*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20113*/    OPC_CheckTypeI32,
/* 20114*/    OPC_MoveSibling6,
/* 20115*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20118*/    OPC_RecordNode, // #6 = $m4
/* 20119*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20120*/    OPC_CheckTypeI32,
/* 20121*/    OPC_MoveSibling7,
/* 20122*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20125*/    OPC_RecordNode, // #7 = $m5
/* 20126*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20127*/    OPC_CheckTypeI32,
/* 20128*/    OPC_MoveSibling, 8,
/* 20130*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20133*/    OPC_RecordNode, // #8 = $m6
/* 20134*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20135*/    OPC_CheckTypeI32,
/* 20136*/    OPC_MoveSibling, 9,
/* 20138*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20141*/    OPC_RecordNode, // #9 = $m7
/* 20142*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20143*/    OPC_CheckTypeI32,
/* 20144*/    OPC_MoveSibling, 10,
/* 20146*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20149*/    OPC_RecordNode, // #10 = $m8
/* 20150*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20151*/    OPC_CheckTypeI32,
/* 20152*/    OPC_MoveSibling, 11,
/* 20154*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20157*/    OPC_RecordNode, // #11 = $m9
/* 20158*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20159*/    OPC_CheckTypeI32,
/* 20160*/    OPC_MoveSibling, 12,
/* 20162*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20165*/    OPC_RecordNode, // #12 = $mA
/* 20166*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20167*/    OPC_CheckTypeI32,
/* 20168*/    OPC_MoveSibling, 13,
/* 20170*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20173*/    OPC_RecordNode, // #13 = $mB
/* 20174*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20175*/    OPC_CheckTypeI32,
/* 20176*/    OPC_MoveSibling, 14,
/* 20178*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20181*/    OPC_RecordNode, // #14 = $mC
/* 20182*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20183*/    OPC_CheckTypeI32,
/* 20184*/    OPC_MoveSibling, 15,
/* 20186*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20189*/    OPC_RecordNode, // #15 = $mD
/* 20190*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20191*/    OPC_CheckTypeI32,
/* 20192*/    OPC_MoveSibling, 16,
/* 20194*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20197*/    OPC_RecordNode, // #16 = $mE
/* 20198*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20199*/    OPC_CheckTypeI32,
/* 20200*/    OPC_MoveSibling, 17,
/* 20202*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20205*/    OPC_RecordNode, // #17 = $mF
/* 20206*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20207*/    OPC_CheckTypeI32,
/* 20208*/    OPC_MoveParent,
/* 20209*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 20211*/    OPC_EmitConvertToTarget2,
/* 20212*/    OPC_EmitConvertToTarget3,
/* 20213*/    OPC_EmitConvertToTarget4,
/* 20214*/    OPC_EmitConvertToTarget5,
/* 20215*/    OPC_EmitConvertToTarget6,
/* 20216*/    OPC_EmitConvertToTarget7,
/* 20217*/    OPC_EmitConvertToTarget, 8,
/* 20219*/    OPC_EmitConvertToTarget, 9,
/* 20221*/    OPC_EmitConvertToTarget, 10,
/* 20223*/    OPC_EmitConvertToTarget, 11,
/* 20225*/    OPC_EmitConvertToTarget, 12,
/* 20227*/    OPC_EmitConvertToTarget, 13,
/* 20229*/    OPC_EmitConvertToTarget, 14,
/* 20231*/    OPC_EmitConvertToTarget, 15,
/* 20233*/    OPC_EmitConvertToTarget, 16,
/* 20235*/    OPC_EmitConvertToTarget, 17,
/* 20237*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/110, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20260*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20417
/* 20264*/    OPC_CheckTypeI32,
/* 20265*/    OPC_MoveSibling3,
/* 20266*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20269*/    OPC_RecordNode, // #3 = $m1
/* 20270*/    OPC_CheckTypeI32,
/* 20271*/    OPC_MoveSibling4,
/* 20272*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20275*/    OPC_RecordNode, // #4 = $m2
/* 20276*/    OPC_CheckTypeI32,
/* 20277*/    OPC_MoveSibling5,
/* 20278*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20281*/    OPC_RecordNode, // #5 = $m3
/* 20282*/    OPC_CheckTypeI32,
/* 20283*/    OPC_MoveSibling6,
/* 20284*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20287*/    OPC_RecordNode, // #6 = $m4
/* 20288*/    OPC_CheckTypeI32,
/* 20289*/    OPC_MoveSibling7,
/* 20290*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20293*/    OPC_RecordNode, // #7 = $m5
/* 20294*/    OPC_CheckTypeI32,
/* 20295*/    OPC_MoveSibling, 8,
/* 20297*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20300*/    OPC_RecordNode, // #8 = $m6
/* 20301*/    OPC_CheckTypeI32,
/* 20302*/    OPC_MoveSibling, 9,
/* 20304*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20307*/    OPC_RecordNode, // #9 = $m7
/* 20308*/    OPC_CheckTypeI32,
/* 20309*/    OPC_MoveSibling, 10,
/* 20311*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20314*/    OPC_RecordNode, // #10 = $m8
/* 20315*/    OPC_CheckTypeI32,
/* 20316*/    OPC_MoveSibling, 11,
/* 20318*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20321*/    OPC_RecordNode, // #11 = $m9
/* 20322*/    OPC_CheckTypeI32,
/* 20323*/    OPC_MoveSibling, 12,
/* 20325*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20328*/    OPC_RecordNode, // #12 = $mA
/* 20329*/    OPC_CheckTypeI32,
/* 20330*/    OPC_MoveSibling, 13,
/* 20332*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20335*/    OPC_RecordNode, // #13 = $mB
/* 20336*/    OPC_CheckTypeI32,
/* 20337*/    OPC_MoveSibling, 14,
/* 20339*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20342*/    OPC_RecordNode, // #14 = $mC
/* 20343*/    OPC_CheckTypeI32,
/* 20344*/    OPC_MoveSibling, 15,
/* 20346*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20349*/    OPC_RecordNode, // #15 = $mD
/* 20350*/    OPC_CheckTypeI32,
/* 20351*/    OPC_MoveSibling, 16,
/* 20353*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20356*/    OPC_RecordNode, // #16 = $mE
/* 20357*/    OPC_CheckTypeI32,
/* 20358*/    OPC_MoveSibling, 17,
/* 20360*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20363*/    OPC_RecordNode, // #17 = $mF
/* 20364*/    OPC_CheckTypeI32,
/* 20365*/    OPC_MoveParent,
/* 20366*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 20368*/    OPC_EmitConvertToTarget2,
/* 20369*/    OPC_EmitConvertToTarget3,
/* 20370*/    OPC_EmitConvertToTarget4,
/* 20371*/    OPC_EmitConvertToTarget5,
/* 20372*/    OPC_EmitConvertToTarget6,
/* 20373*/    OPC_EmitConvertToTarget7,
/* 20374*/    OPC_EmitConvertToTarget, 8,
/* 20376*/    OPC_EmitConvertToTarget, 9,
/* 20378*/    OPC_EmitConvertToTarget, 10,
/* 20380*/    OPC_EmitConvertToTarget, 11,
/* 20382*/    OPC_EmitConvertToTarget, 12,
/* 20384*/    OPC_EmitConvertToTarget, 13,
/* 20386*/    OPC_EmitConvertToTarget, 14,
/* 20388*/    OPC_EmitConvertToTarget, 15,
/* 20390*/    OPC_EmitConvertToTarget, 16,
/* 20392*/    OPC_EmitConvertToTarget, 17,
/* 20394*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/110, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20417*/   0, // EndSwitchOpcode
/* 20418*/  /*Scope*/ 89|128,2/*345*/, /*->20765*/
/* 20420*/   OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20423*/   OPC_RecordChild1, // #1 = $y
/* 20424*/   OPC_CheckChild1Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20427*/   OPC_RecordChild2, // #2 = $m0
/* 20428*/   OPC_MoveChild2,
/* 20429*/   OPC_SwitchOpcode /*2 cases */, 43|128,1/*171*/, TARGET_VAL(ISD::Constant),// ->20605
/* 20434*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20435*/    OPC_CheckTypeI32,
/* 20436*/    OPC_MoveSibling3,
/* 20437*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20440*/    OPC_RecordNode, // #3 = $m1
/* 20441*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20442*/    OPC_CheckTypeI32,
/* 20443*/    OPC_MoveSibling4,
/* 20444*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20447*/    OPC_RecordNode, // #4 = $m2
/* 20448*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20449*/    OPC_CheckTypeI32,
/* 20450*/    OPC_MoveSibling5,
/* 20451*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20454*/    OPC_RecordNode, // #5 = $m3
/* 20455*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20456*/    OPC_CheckTypeI32,
/* 20457*/    OPC_MoveSibling6,
/* 20458*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20461*/    OPC_RecordNode, // #6 = $m4
/* 20462*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20463*/    OPC_CheckTypeI32,
/* 20464*/    OPC_MoveSibling7,
/* 20465*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20468*/    OPC_RecordNode, // #7 = $m5
/* 20469*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20470*/    OPC_CheckTypeI32,
/* 20471*/    OPC_MoveSibling, 8,
/* 20473*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20476*/    OPC_RecordNode, // #8 = $m6
/* 20477*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20478*/    OPC_CheckTypeI32,
/* 20479*/    OPC_MoveSibling, 9,
/* 20481*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20484*/    OPC_RecordNode, // #9 = $m7
/* 20485*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20486*/    OPC_CheckTypeI32,
/* 20487*/    OPC_MoveSibling, 10,
/* 20489*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20492*/    OPC_RecordNode, // #10 = $m8
/* 20493*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20494*/    OPC_CheckTypeI32,
/* 20495*/    OPC_MoveSibling, 11,
/* 20497*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20500*/    OPC_RecordNode, // #11 = $m9
/* 20501*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20502*/    OPC_CheckTypeI32,
/* 20503*/    OPC_MoveSibling, 12,
/* 20505*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20508*/    OPC_RecordNode, // #12 = $mA
/* 20509*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20510*/    OPC_CheckTypeI32,
/* 20511*/    OPC_MoveSibling, 13,
/* 20513*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20516*/    OPC_RecordNode, // #13 = $mB
/* 20517*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20518*/    OPC_CheckTypeI32,
/* 20519*/    OPC_MoveSibling, 14,
/* 20521*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20524*/    OPC_RecordNode, // #14 = $mC
/* 20525*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20526*/    OPC_CheckTypeI32,
/* 20527*/    OPC_MoveSibling, 15,
/* 20529*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20532*/    OPC_RecordNode, // #15 = $mD
/* 20533*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20534*/    OPC_CheckTypeI32,
/* 20535*/    OPC_MoveSibling, 16,
/* 20537*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20540*/    OPC_RecordNode, // #16 = $mE
/* 20541*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20542*/    OPC_CheckTypeI32,
/* 20543*/    OPC_MoveSibling, 17,
/* 20545*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20548*/    OPC_RecordNode, // #17 = $mF
/* 20549*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20550*/    OPC_CheckTypeI32,
/* 20551*/    OPC_MoveParent,
/* 20552*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20555*/    OPC_EmitConvertToTarget2,
/* 20556*/    OPC_EmitConvertToTarget3,
/* 20557*/    OPC_EmitConvertToTarget4,
/* 20558*/    OPC_EmitConvertToTarget5,
/* 20559*/    OPC_EmitConvertToTarget6,
/* 20560*/    OPC_EmitConvertToTarget7,
/* 20561*/    OPC_EmitConvertToTarget, 8,
/* 20563*/    OPC_EmitConvertToTarget, 9,
/* 20565*/    OPC_EmitConvertToTarget, 10,
/* 20567*/    OPC_EmitConvertToTarget, 11,
/* 20569*/    OPC_EmitConvertToTarget, 12,
/* 20571*/    OPC_EmitConvertToTarget, 13,
/* 20573*/    OPC_EmitConvertToTarget, 14,
/* 20575*/    OPC_EmitConvertToTarget, 15,
/* 20577*/    OPC_EmitConvertToTarget, 16,
/* 20579*/    OPC_EmitConvertToTarget, 17,
/* 20581*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/0|128,1/*128*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20605*/   /*SwitchOpcode*/ 27|128,1/*155*/, TARGET_VAL(ISD::TargetConstant),// ->20764
/* 20609*/    OPC_CheckTypeI32,
/* 20610*/    OPC_MoveSibling3,
/* 20611*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20614*/    OPC_RecordNode, // #3 = $m1
/* 20615*/    OPC_CheckTypeI32,
/* 20616*/    OPC_MoveSibling4,
/* 20617*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20620*/    OPC_RecordNode, // #4 = $m2
/* 20621*/    OPC_CheckTypeI32,
/* 20622*/    OPC_MoveSibling5,
/* 20623*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20626*/    OPC_RecordNode, // #5 = $m3
/* 20627*/    OPC_CheckTypeI32,
/* 20628*/    OPC_MoveSibling6,
/* 20629*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20632*/    OPC_RecordNode, // #6 = $m4
/* 20633*/    OPC_CheckTypeI32,
/* 20634*/    OPC_MoveSibling7,
/* 20635*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20638*/    OPC_RecordNode, // #7 = $m5
/* 20639*/    OPC_CheckTypeI32,
/* 20640*/    OPC_MoveSibling, 8,
/* 20642*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20645*/    OPC_RecordNode, // #8 = $m6
/* 20646*/    OPC_CheckTypeI32,
/* 20647*/    OPC_MoveSibling, 9,
/* 20649*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20652*/    OPC_RecordNode, // #9 = $m7
/* 20653*/    OPC_CheckTypeI32,
/* 20654*/    OPC_MoveSibling, 10,
/* 20656*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20659*/    OPC_RecordNode, // #10 = $m8
/* 20660*/    OPC_CheckTypeI32,
/* 20661*/    OPC_MoveSibling, 11,
/* 20663*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20666*/    OPC_RecordNode, // #11 = $m9
/* 20667*/    OPC_CheckTypeI32,
/* 20668*/    OPC_MoveSibling, 12,
/* 20670*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20673*/    OPC_RecordNode, // #12 = $mA
/* 20674*/    OPC_CheckTypeI32,
/* 20675*/    OPC_MoveSibling, 13,
/* 20677*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20680*/    OPC_RecordNode, // #13 = $mB
/* 20681*/    OPC_CheckTypeI32,
/* 20682*/    OPC_MoveSibling, 14,
/* 20684*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20687*/    OPC_RecordNode, // #14 = $mC
/* 20688*/    OPC_CheckTypeI32,
/* 20689*/    OPC_MoveSibling, 15,
/* 20691*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20694*/    OPC_RecordNode, // #15 = $mD
/* 20695*/    OPC_CheckTypeI32,
/* 20696*/    OPC_MoveSibling, 16,
/* 20698*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20701*/    OPC_RecordNode, // #16 = $mE
/* 20702*/    OPC_CheckTypeI32,
/* 20703*/    OPC_MoveSibling, 17,
/* 20705*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20708*/    OPC_RecordNode, // #17 = $mF
/* 20709*/    OPC_CheckTypeI32,
/* 20710*/    OPC_MoveParent,
/* 20711*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 20714*/    OPC_EmitConvertToTarget2,
/* 20715*/    OPC_EmitConvertToTarget3,
/* 20716*/    OPC_EmitConvertToTarget4,
/* 20717*/    OPC_EmitConvertToTarget5,
/* 20718*/    OPC_EmitConvertToTarget6,
/* 20719*/    OPC_EmitConvertToTarget7,
/* 20720*/    OPC_EmitConvertToTarget, 8,
/* 20722*/    OPC_EmitConvertToTarget, 9,
/* 20724*/    OPC_EmitConvertToTarget, 10,
/* 20726*/    OPC_EmitConvertToTarget, 11,
/* 20728*/    OPC_EmitConvertToTarget, 12,
/* 20730*/    OPC_EmitConvertToTarget, 13,
/* 20732*/    OPC_EmitConvertToTarget, 14,
/* 20734*/    OPC_EmitConvertToTarget, 15,
/* 20736*/    OPC_EmitConvertToTarget, 16,
/* 20738*/    OPC_EmitConvertToTarget, 17,
/* 20740*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/0|128,1/*128*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20764*/   0, // EndSwitchOpcode
/* 20765*/  0, /*End of Scope*/
/* 20766*/ /*SwitchOpcode*/ 73|128,8/*1097*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21867
/* 20770*/  OPC_Scope, 6|128,1/*134*/, /*->20907*/ // 2 children in Scope
/* 20773*/   OPC_MoveChild0,
/* 20774*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20777*/   OPC_CheckChild0Integer, 0, 
/* 20779*/   OPC_Scope, 62, /*->20843*/ // 2 children in Scope
/* 20781*/    OPC_CheckChild0TypeI32,
/* 20782*/    OPC_MoveSibling1,
/* 20783*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20786*/    OPC_RecordMemRef,
/* 20787*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20788*/    OPC_CheckFoldableChainNode,
/* 20789*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20790*/    OPC_CheckTypeI32,
/* 20791*/    OPC_Scope, 24, /*->20817*/ // 2 children in Scope
/* 20793*/     OPC_CheckChild1TypeI32,
/* 20794*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20796*/     OPC_CheckPredicate6,  // Predicate_load
/* 20797*/     OPC_MoveParent,
/* 20798*/     OPC_CheckChild2Integer, 0, 
/* 20800*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 20802*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20803*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20805*/     OPC_EmitMergeInputChains1_0,
/* 20806*/     OPC_EmitInteger32, 0, 
/* 20808*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20817*/    /*Scope*/ 24, /*->20842*/
/* 20818*/     OPC_CheckChild1TypeI64,
/* 20819*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20821*/     OPC_CheckPredicate6,  // Predicate_load
/* 20822*/     OPC_MoveParent,
/* 20823*/     OPC_CheckChild2Integer, 0, 
/* 20825*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 20827*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 20828*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20830*/     OPC_EmitMergeInputChains1_0,
/* 20831*/     OPC_EmitInteger32, 0, 
/* 20833*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20842*/    0, /*End of Scope*/
/* 20843*/   /*Scope*/ 62, /*->20906*/
/* 20844*/    OPC_CheckChild0TypeI64,
/* 20845*/    OPC_MoveSibling1,
/* 20846*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20849*/    OPC_RecordMemRef,
/* 20850*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20851*/    OPC_CheckFoldableChainNode,
/* 20852*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20853*/    OPC_CheckTypeI64,
/* 20854*/    OPC_Scope, 24, /*->20880*/ // 2 children in Scope
/* 20856*/     OPC_CheckChild1TypeI32,
/* 20857*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20859*/     OPC_CheckPredicate6,  // Predicate_load
/* 20860*/     OPC_MoveParent,
/* 20861*/     OPC_CheckChild2Integer, 0, 
/* 20863*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 20865*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20866*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20868*/     OPC_EmitMergeInputChains1_0,
/* 20869*/     OPC_EmitInteger32, 0, 
/* 20871*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20880*/    /*Scope*/ 24, /*->20905*/
/* 20881*/     OPC_CheckChild1TypeI64,
/* 20882*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20884*/     OPC_CheckPredicate6,  // Predicate_load
/* 20885*/     OPC_MoveParent,
/* 20886*/     OPC_CheckChild2Integer, 0, 
/* 20888*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 20890*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 20891*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20893*/     OPC_EmitMergeInputChains1_0,
/* 20894*/     OPC_EmitInteger32, 0, 
/* 20896*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20905*/    0, /*End of Scope*/
/* 20906*/   0, /*End of Scope*/
/* 20907*/  /*Scope*/ 61|128,7/*957*/, /*->21866*/
/* 20909*/   OPC_RecordChild0, // #0 = $vec
/* 20910*/   OPC_Scope, 32|128,3/*416*/, /*->21329*/ // 4 children in Scope
/* 20913*/    OPC_MoveChild1,
/* 20914*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20917*/    OPC_RecordMemRef,
/* 20918*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 20919*/    OPC_CheckFoldableChainNode,
/* 20920*/    OPC_RecordChild1, // #2 = $addr
/* 20921*/    OPC_Scope, 73|128,1/*201*/, /*->21125*/ // 2 children in Scope
/* 20924*/     OPC_CheckChild1TypeI32,
/* 20925*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20927*/     OPC_Scope, 67, /*->20996*/ // 2 children in Scope
/* 20929*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 20931*/      OPC_CheckTypeI32,
/* 20932*/      OPC_Scope, 30, /*->20964*/ // 2 children in Scope
/* 20934*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 20935*/       OPC_MoveSibling2,
/* 20936*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20939*/       OPC_RecordNode, // #3 = $idx
/* 20940*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/* 20942*/       OPC_CheckTypeI32,
/* 20943*/       OPC_MoveParent,
/* 20944*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 20946*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20947*/       OPC_EmitMergeInputChains1_1,
/* 20948*/       OPC_EmitInteger32, 0, 
/* 20950*/       OPC_EmitInteger32, 0, 
/* 20952*/       OPC_EmitConvertToTarget3,
/* 20953*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 20964*/      /*Scope*/ 30, /*->20995*/
/* 20965*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 20966*/       OPC_MoveSibling2,
/* 20967*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20970*/       OPC_RecordNode, // #3 = $idx
/* 20971*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/* 20973*/       OPC_CheckTypeI32,
/* 20974*/       OPC_MoveParent,
/* 20975*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 20977*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20978*/       OPC_EmitMergeInputChains1_1,
/* 20979*/       OPC_EmitInteger32, 0, 
/* 20981*/       OPC_EmitInteger32, 0, 
/* 20983*/       OPC_EmitConvertToTarget3,
/* 20984*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 20995*/      0, /*End of Scope*/
/* 20996*/     /*Scope*/ 127, /*->21124*/
/* 20997*/      OPC_CheckPredicate6,  // Predicate_load
/* 20998*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21030
/* 21001*/       OPC_MoveSibling2,
/* 21002*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21005*/       OPC_RecordNode, // #3 = $idx
/* 21006*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21008*/       OPC_CheckTypeI32,
/* 21009*/       OPC_MoveParent,
/* 21010*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21012*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21013*/       OPC_EmitMergeInputChains1_1,
/* 21014*/       OPC_EmitInteger32, 0, 
/* 21016*/       OPC_EmitInteger32, 0, 
/* 21018*/       OPC_EmitConvertToTarget3,
/* 21019*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21030*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21061
/* 21032*/       OPC_MoveSibling2,
/* 21033*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21036*/       OPC_RecordNode, // #3 = $idx
/* 21037*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21039*/       OPC_CheckTypeI32,
/* 21040*/       OPC_MoveParent,
/* 21041*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21043*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21044*/       OPC_EmitMergeInputChains1_1,
/* 21045*/       OPC_EmitInteger32, 0, 
/* 21047*/       OPC_EmitInteger32, 0, 
/* 21049*/       OPC_EmitConvertToTarget3,
/* 21050*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21061*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21092
/* 21063*/       OPC_MoveSibling2,
/* 21064*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21067*/       OPC_RecordNode, // #3 = $idx
/* 21068*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21070*/       OPC_CheckTypeI32,
/* 21071*/       OPC_MoveParent,
/* 21072*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21074*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21075*/       OPC_EmitMergeInputChains1_1,
/* 21076*/       OPC_EmitInteger32, 0, 
/* 21078*/       OPC_EmitInteger32, 0, 
/* 21080*/       OPC_EmitConvertToTarget3,
/* 21081*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21092*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21123
/* 21094*/       OPC_MoveSibling2,
/* 21095*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21098*/       OPC_RecordNode, // #3 = $idx
/* 21099*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21101*/       OPC_CheckTypeI32,
/* 21102*/       OPC_MoveParent,
/* 21103*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21105*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21106*/       OPC_EmitMergeInputChains1_1,
/* 21107*/       OPC_EmitInteger32, 0, 
/* 21109*/       OPC_EmitInteger32, 0, 
/* 21111*/       OPC_EmitConvertToTarget3,
/* 21112*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21123*/      0, // EndSwitchType
/* 21124*/     0, /*End of Scope*/
/* 21125*/    /*Scope*/ 73|128,1/*201*/, /*->21328*/
/* 21127*/     OPC_CheckChild1TypeI64,
/* 21128*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21130*/     OPC_Scope, 67, /*->21199*/ // 2 children in Scope
/* 21132*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21134*/      OPC_CheckTypeI32,
/* 21135*/      OPC_Scope, 30, /*->21167*/ // 2 children in Scope
/* 21137*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21138*/       OPC_MoveSibling2,
/* 21139*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21142*/       OPC_RecordNode, // #3 = $idx
/* 21143*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/* 21145*/       OPC_CheckTypeI32,
/* 21146*/       OPC_MoveParent,
/* 21147*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21149*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21150*/       OPC_EmitMergeInputChains1_1,
/* 21151*/       OPC_EmitInteger32, 0, 
/* 21153*/       OPC_EmitInteger64, 0, 
/* 21155*/       OPC_EmitConvertToTarget3,
/* 21156*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21167*/      /*Scope*/ 30, /*->21198*/
/* 21168*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21169*/       OPC_MoveSibling2,
/* 21170*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21173*/       OPC_RecordNode, // #3 = $idx
/* 21174*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/* 21176*/       OPC_CheckTypeI32,
/* 21177*/       OPC_MoveParent,
/* 21178*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21180*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21181*/       OPC_EmitMergeInputChains1_1,
/* 21182*/       OPC_EmitInteger32, 0, 
/* 21184*/       OPC_EmitInteger64, 0, 
/* 21186*/       OPC_EmitConvertToTarget3,
/* 21187*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21198*/      0, /*End of Scope*/
/* 21199*/     /*Scope*/ 127, /*->21327*/
/* 21200*/      OPC_CheckPredicate6,  // Predicate_load
/* 21201*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21233
/* 21204*/       OPC_MoveSibling2,
/* 21205*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21208*/       OPC_RecordNode, // #3 = $idx
/* 21209*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21211*/       OPC_CheckTypeI32,
/* 21212*/       OPC_MoveParent,
/* 21213*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21215*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21216*/       OPC_EmitMergeInputChains1_1,
/* 21217*/       OPC_EmitInteger32, 0, 
/* 21219*/       OPC_EmitInteger64, 0, 
/* 21221*/       OPC_EmitConvertToTarget3,
/* 21222*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21233*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21264
/* 21235*/       OPC_MoveSibling2,
/* 21236*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21239*/       OPC_RecordNode, // #3 = $idx
/* 21240*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21242*/       OPC_CheckTypeI32,
/* 21243*/       OPC_MoveParent,
/* 21244*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21246*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21247*/       OPC_EmitMergeInputChains1_1,
/* 21248*/       OPC_EmitInteger32, 0, 
/* 21250*/       OPC_EmitInteger64, 0, 
/* 21252*/       OPC_EmitConvertToTarget3,
/* 21253*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21264*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21295
/* 21266*/       OPC_MoveSibling2,
/* 21267*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21270*/       OPC_RecordNode, // #3 = $idx
/* 21271*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21273*/       OPC_CheckTypeI32,
/* 21274*/       OPC_MoveParent,
/* 21275*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21277*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21278*/       OPC_EmitMergeInputChains1_1,
/* 21279*/       OPC_EmitInteger32, 0, 
/* 21281*/       OPC_EmitInteger64, 0, 
/* 21283*/       OPC_EmitConvertToTarget3,
/* 21284*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21295*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21326
/* 21297*/       OPC_MoveSibling2,
/* 21298*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21301*/       OPC_RecordNode, // #3 = $idx
/* 21302*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21304*/       OPC_CheckTypeI32,
/* 21305*/       OPC_MoveParent,
/* 21306*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21308*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21309*/       OPC_EmitMergeInputChains1_1,
/* 21310*/       OPC_EmitInteger32, 0, 
/* 21312*/       OPC_EmitInteger64, 0, 
/* 21314*/       OPC_EmitConvertToTarget3,
/* 21315*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21326*/      0, // EndSwitchType
/* 21327*/     0, /*End of Scope*/
/* 21328*/    0, /*End of Scope*/
/* 21329*/   /*Scope*/ 24|128,1/*152*/, /*->21483*/
/* 21331*/    OPC_RecordChild1, // #1 = $x
/* 21332*/    OPC_Scope, 104, /*->21438*/ // 2 children in Scope
/* 21334*/     OPC_CheckChild1TypeI32,
/* 21335*/     OPC_Scope, 56, /*->21393*/ // 2 children in Scope
/* 21337*/      OPC_RecordChild2, // #2 = $idx
/* 21338*/      OPC_MoveChild2,
/* 21339*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21342*/      OPC_CheckTypeI32,
/* 21343*/      OPC_Scope, 15, /*->21360*/ // 3 children in Scope
/* 21345*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx16
/* 21347*/       OPC_MoveParent,
/* 21348*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21350*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21351*/       OPC_EmitConvertToTarget2,
/* 21352*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21360*/      /*Scope*/ 15, /*->21376*/
/* 21361*/       OPC_CheckPredicate, 15, // Predicate_LaneIdx8
/* 21363*/       OPC_MoveParent,
/* 21364*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21366*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21367*/       OPC_EmitConvertToTarget2,
/* 21368*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21376*/      /*Scope*/ 15, /*->21392*/
/* 21377*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21379*/       OPC_MoveParent,
/* 21380*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21382*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21383*/       OPC_EmitConvertToTarget2,
/* 21384*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21392*/      0, /*End of Scope*/
/* 21393*/     /*Scope*/ 43, /*->21437*/
/* 21394*/      OPC_MoveChild2,
/* 21395*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21398*/      OPC_MoveParent,
/* 21399*/      OPC_SwitchType /*3 cases */, 10, /*MVT::v16i8*/39, // ->21412
/* 21402*/       OPC_EmitInteger32, 0, 
/* 21404*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21412*/      /*SwitchType*/ 10, /*MVT::v8i16*/50, // ->21424
/* 21414*/       OPC_EmitInteger32, 0, 
/* 21416*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21424*/      /*SwitchType*/ 10, /*MVT::v4i32*/60, // ->21436
/* 21426*/       OPC_EmitInteger32, 0, 
/* 21428*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21436*/      0, // EndSwitchType
/* 21437*/     0, /*End of Scope*/
/* 21438*/    /*Scope*/ 43, /*->21482*/
/* 21439*/     OPC_CheckChild1TypeI64,
/* 21440*/     OPC_Scope, 21, /*->21463*/ // 2 children in Scope
/* 21442*/      OPC_RecordChild2, // #2 = $idx
/* 21443*/      OPC_MoveChild2,
/* 21444*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21447*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21449*/      OPC_CheckTypeI32,
/* 21450*/      OPC_MoveParent,
/* 21451*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21453*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21454*/      OPC_EmitConvertToTarget2,
/* 21455*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21463*/     /*Scope*/ 17, /*->21481*/
/* 21464*/      OPC_MoveChild2,
/* 21465*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21468*/      OPC_MoveParent,
/* 21469*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21471*/      OPC_EmitInteger32, 0, 
/* 21473*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21481*/     0, /*End of Scope*/
/* 21482*/    0, /*End of Scope*/
/* 21483*/   /*Scope*/ 26|128,2/*282*/, /*->21767*/
/* 21485*/    OPC_MoveChild1,
/* 21486*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21489*/    OPC_RecordMemRef,
/* 21490*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21491*/    OPC_CheckFoldableChainNode,
/* 21492*/    OPC_RecordChild1, // #2 = $addr
/* 21493*/    OPC_Scope, 6|128,1/*134*/, /*->21630*/ // 2 children in Scope
/* 21496*/     OPC_CheckChild1TypeI32,
/* 21497*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21499*/     OPC_CheckPredicate6,  // Predicate_load
/* 21500*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21532
/* 21503*/      OPC_MoveSibling2,
/* 21504*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21507*/      OPC_RecordNode, // #3 = $idx
/* 21508*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21510*/      OPC_CheckTypeI32,
/* 21511*/      OPC_MoveParent,
/* 21512*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21514*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21515*/      OPC_EmitMergeInputChains1_1,
/* 21516*/      OPC_EmitInteger32, 0, 
/* 21518*/      OPC_EmitInteger32, 0, 
/* 21520*/      OPC_EmitConvertToTarget3,
/* 21521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21532*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21563
/* 21534*/      OPC_MoveSibling2,
/* 21535*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21538*/      OPC_RecordNode, // #3 = $idx
/* 21539*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21541*/      OPC_CheckTypeI32,
/* 21542*/      OPC_MoveParent,
/* 21543*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21545*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21546*/      OPC_EmitMergeInputChains1_1,
/* 21547*/      OPC_EmitInteger32, 0, 
/* 21549*/      OPC_EmitInteger32, 0, 
/* 21551*/      OPC_EmitConvertToTarget3,
/* 21552*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21563*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->21596
/* 21565*/      OPC_MoveSibling2,
/* 21566*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21569*/      OPC_RecordNode, // #3 = $idx
/* 21570*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21572*/      OPC_CheckTypeI32,
/* 21573*/      OPC_MoveParent,
/* 21574*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21577*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21578*/      OPC_EmitMergeInputChains1_1,
/* 21579*/      OPC_EmitInteger32, 0, 
/* 21581*/      OPC_EmitInteger32, 0, 
/* 21583*/      OPC_EmitConvertToTarget3,
/* 21584*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21596*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->21629
/* 21598*/      OPC_MoveSibling2,
/* 21599*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21602*/      OPC_RecordNode, // #3 = $idx
/* 21603*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21605*/      OPC_CheckTypeI32,
/* 21606*/      OPC_MoveParent,
/* 21607*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21610*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21611*/      OPC_EmitMergeInputChains1_1,
/* 21612*/      OPC_EmitInteger32, 0, 
/* 21614*/      OPC_EmitInteger32, 0, 
/* 21616*/      OPC_EmitConvertToTarget3,
/* 21617*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21629*/     0, // EndSwitchType
/* 21630*/    /*Scope*/ 6|128,1/*134*/, /*->21766*/
/* 21632*/     OPC_CheckChild1TypeI64,
/* 21633*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21635*/     OPC_CheckPredicate6,  // Predicate_load
/* 21636*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21668
/* 21639*/      OPC_MoveSibling2,
/* 21640*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21643*/      OPC_RecordNode, // #3 = $idx
/* 21644*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21646*/      OPC_CheckTypeI32,
/* 21647*/      OPC_MoveParent,
/* 21648*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21650*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21651*/      OPC_EmitMergeInputChains1_1,
/* 21652*/      OPC_EmitInteger32, 0, 
/* 21654*/      OPC_EmitInteger64, 0, 
/* 21656*/      OPC_EmitConvertToTarget3,
/* 21657*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21668*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21699
/* 21670*/      OPC_MoveSibling2,
/* 21671*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21674*/      OPC_RecordNode, // #3 = $idx
/* 21675*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21677*/      OPC_CheckTypeI32,
/* 21678*/      OPC_MoveParent,
/* 21679*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21681*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21682*/      OPC_EmitMergeInputChains1_1,
/* 21683*/      OPC_EmitInteger32, 0, 
/* 21685*/      OPC_EmitInteger64, 0, 
/* 21687*/      OPC_EmitConvertToTarget3,
/* 21688*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/110, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21699*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->21732
/* 21701*/      OPC_MoveSibling2,
/* 21702*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21705*/      OPC_RecordNode, // #3 = $idx
/* 21706*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21708*/      OPC_CheckTypeI32,
/* 21709*/      OPC_MoveParent,
/* 21710*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21713*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21714*/      OPC_EmitMergeInputChains1_1,
/* 21715*/      OPC_EmitInteger32, 0, 
/* 21717*/      OPC_EmitInteger64, 0, 
/* 21719*/      OPC_EmitConvertToTarget3,
/* 21720*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21732*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->21765
/* 21734*/      OPC_MoveSibling2,
/* 21735*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21738*/      OPC_RecordNode, // #3 = $idx
/* 21739*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21741*/      OPC_CheckTypeI32,
/* 21742*/      OPC_MoveParent,
/* 21743*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21746*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21747*/      OPC_EmitMergeInputChains1_1,
/* 21748*/      OPC_EmitInteger32, 0, 
/* 21750*/      OPC_EmitInteger64, 0, 
/* 21752*/      OPC_EmitConvertToTarget3,
/* 21753*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/0|128,1/*128*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21765*/     0, // EndSwitchType
/* 21766*/    0, /*End of Scope*/
/* 21767*/   /*Scope*/ 97, /*->21865*/
/* 21768*/    OPC_RecordChild1, // #1 = $x
/* 21769*/    OPC_Scope, 44, /*->21815*/ // 2 children in Scope
/* 21771*/     OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 21773*/     OPC_Scope, 21, /*->21796*/ // 2 children in Scope
/* 21775*/      OPC_RecordChild2, // #2 = $idx
/* 21776*/      OPC_MoveChild2,
/* 21777*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21780*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21782*/      OPC_CheckTypeI32,
/* 21783*/      OPC_MoveParent,
/* 21784*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21786*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21787*/      OPC_EmitConvertToTarget2,
/* 21788*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/110, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21796*/     /*Scope*/ 17, /*->21814*/
/* 21797*/      OPC_MoveChild2,
/* 21798*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21801*/      OPC_MoveParent,
/* 21802*/      OPC_CheckType, /*MVT::v4f32*/110, 
/* 21804*/      OPC_EmitInteger32, 0, 
/* 21806*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/110, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21814*/     0, /*End of Scope*/
/* 21815*/    /*Scope*/ 48, /*->21864*/
/* 21816*/     OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 21818*/     OPC_Scope, 23, /*->21843*/ // 2 children in Scope
/* 21820*/      OPC_RecordChild2, // #2 = $idx
/* 21821*/      OPC_MoveChild2,
/* 21822*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21825*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21827*/      OPC_CheckTypeI32,
/* 21828*/      OPC_MoveParent,
/* 21829*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21832*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21833*/      OPC_EmitConvertToTarget2,
/* 21834*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21843*/     /*Scope*/ 19, /*->21863*/
/* 21844*/      OPC_MoveChild2,
/* 21845*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21848*/      OPC_MoveParent,
/* 21849*/      OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 21852*/      OPC_EmitInteger32, 0, 
/* 21854*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21863*/     0, /*End of Scope*/
/* 21864*/    0, /*End of Scope*/
/* 21865*/   0, /*End of Scope*/
/* 21866*/  0, /*End of Scope*/
/* 21867*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->22095
/* 21871*/  OPC_Scope, 87, /*->21960*/ // 2 children in Scope
/* 21873*/   OPC_MoveChild0,
/* 21874*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21877*/   OPC_MoveChild0,
/* 21878*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->21919
/* 21882*/    OPC_RecordChild0, // #0 = $lhs
/* 21883*/    OPC_RecordChild1, // #1 = $rhs
/* 21884*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21886*/    OPC_MoveSibling1,
/* 21887*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21890*/    OPC_CheckChild0Integer, 2, 
/* 21892*/    OPC_CheckChild0TypeI32,
/* 21893*/    OPC_MoveParent,
/* 21894*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21896*/    OPC_MoveParent,
/* 21897*/    OPC_CheckChild1Integer, 2, 
/* 21899*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->21909
/* 21902*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21909*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->21918
/* 21911*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21918*/    0, // EndSwitchType
/* 21919*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->21959
/* 21922*/    OPC_CheckChild0Integer, 2, 
/* 21924*/    OPC_CheckChild0TypeI32,
/* 21925*/    OPC_MoveSibling1,
/* 21926*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21929*/    OPC_RecordChild0, // #0 = $lhs
/* 21930*/    OPC_RecordChild1, // #1 = $rhs
/* 21931*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21933*/    OPC_MoveParent,
/* 21934*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21936*/    OPC_MoveParent,
/* 21937*/    OPC_CheckChild1Integer, 2, 
/* 21939*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->21949
/* 21942*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21949*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->21958
/* 21951*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 21958*/    0, // EndSwitchType
/* 21959*/   0, // EndSwitchOpcode
/* 21960*/  /*Scope*/ 4|128,1/*132*/, /*->22094*/
/* 21962*/   OPC_RecordChild0, // #0 = $lhs
/* 21963*/   OPC_Scope, 84, /*->22049*/ // 2 children in Scope
/* 21965*/    OPC_MoveChild1,
/* 21966*/    OPC_Scope, 24, /*->21992*/ // 5 children in Scope
/* 21968*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 21971*/     OPC_MoveChild0,
/* 21972*/     OPC_CheckAndImm, 63, 
/* 21974*/     OPC_RecordChild0, // #1 = $rhs
/* 21975*/     OPC_MoveParent,
/* 21976*/     OPC_MoveParent,
/* 21977*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 21979*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 21985*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 21992*/    /*Scope*/ 13, /*->22006*/
/* 21993*/     OPC_CheckAndImm, 7, 
/* 21995*/     OPC_RecordChild0, // #1 = $rhs
/* 21996*/     OPC_MoveParent,
/* 21997*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 21999*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22006*/    /*Scope*/ 13, /*->22020*/
/* 22007*/     OPC_CheckAndImm, 15, 
/* 22009*/     OPC_RecordChild0, // #1 = $rhs
/* 22010*/     OPC_MoveParent,
/* 22011*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 22013*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22020*/    /*Scope*/ 13, /*->22034*/
/* 22021*/     OPC_CheckAndImm, 31, 
/* 22023*/     OPC_RecordChild0, // #1 = $rhs
/* 22024*/     OPC_MoveParent,
/* 22025*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22027*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22034*/    /*Scope*/ 13, /*->22048*/
/* 22035*/     OPC_CheckAndImm, 63, 
/* 22037*/     OPC_RecordChild0, // #1 = $rhs
/* 22038*/     OPC_MoveParent,
/* 22039*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22041*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22048*/    0, /*End of Scope*/
/* 22049*/   /*Scope*/ 43, /*->22093*/
/* 22050*/    OPC_RecordChild1, // #1 = $x
/* 22051*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->22062
/* 22054*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22055*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22062*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->22072
/* 22064*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22072*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->22082
/* 22074*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22075*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22082*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->22092
/* 22084*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22085*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22092*/    0, // EndSwitchType
/* 22093*/   0, /*End of Scope*/
/* 22094*/  0, /*End of Scope*/
/* 22095*/ /*SwitchOpcode*/ 22|128,4/*534*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22633
/* 22099*/  OPC_Scope, 73|128,1/*201*/, /*->22303*/ // 4 children in Scope
/* 22102*/   OPC_MoveChild0,
/* 22103*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22106*/   OPC_RecordMemRef,
/* 22107*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22108*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22109*/   OPC_Scope, 95, /*->22206*/ // 2 children in Scope
/* 22111*/    OPC_CheckChild1TypeI32,
/* 22112*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22114*/    OPC_Scope, 45, /*->22161*/ // 2 children in Scope
/* 22116*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22118*/     OPC_CheckTypeI32,
/* 22119*/     OPC_Scope, 19, /*->22140*/ // 2 children in Scope
/* 22121*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22122*/      OPC_MoveParent,
/* 22123*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22125*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22126*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22128*/      OPC_EmitMergeInputChains1_0,
/* 22129*/      OPC_EmitInteger32, 0, 
/* 22131*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22140*/     /*Scope*/ 19, /*->22160*/
/* 22141*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22142*/      OPC_MoveParent,
/* 22143*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22145*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22146*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22148*/      OPC_EmitMergeInputChains1_0,
/* 22149*/      OPC_EmitInteger32, 0, 
/* 22151*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22160*/     0, /*End of Scope*/
/* 22161*/    /*Scope*/ 43, /*->22205*/
/* 22162*/     OPC_CheckPredicate6,  // Predicate_load
/* 22163*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22184
/* 22166*/      OPC_MoveParent,
/* 22167*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22169*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22170*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22172*/      OPC_EmitMergeInputChains1_0,
/* 22173*/      OPC_EmitInteger32, 0, 
/* 22175*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22184*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22204
/* 22186*/      OPC_MoveParent,
/* 22187*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22189*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22190*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22192*/      OPC_EmitMergeInputChains1_0,
/* 22193*/      OPC_EmitInteger32, 0, 
/* 22195*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22204*/     0, // EndSwitchType
/* 22205*/    0, /*End of Scope*/
/* 22206*/   /*Scope*/ 95, /*->22302*/
/* 22207*/    OPC_CheckChild1TypeI64,
/* 22208*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22210*/    OPC_Scope, 45, /*->22257*/ // 2 children in Scope
/* 22212*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22214*/     OPC_CheckTypeI32,
/* 22215*/     OPC_Scope, 19, /*->22236*/ // 2 children in Scope
/* 22217*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22218*/      OPC_MoveParent,
/* 22219*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22221*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22222*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22224*/      OPC_EmitMergeInputChains1_0,
/* 22225*/      OPC_EmitInteger32, 0, 
/* 22227*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22236*/     /*Scope*/ 19, /*->22256*/
/* 22237*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22238*/      OPC_MoveParent,
/* 22239*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22241*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22242*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22244*/      OPC_EmitMergeInputChains1_0,
/* 22245*/      OPC_EmitInteger32, 0, 
/* 22247*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22256*/     0, /*End of Scope*/
/* 22257*/    /*Scope*/ 43, /*->22301*/
/* 22258*/     OPC_CheckPredicate6,  // Predicate_load
/* 22259*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22280
/* 22262*/      OPC_MoveParent,
/* 22263*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22265*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22266*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22268*/      OPC_EmitMergeInputChains1_0,
/* 22269*/      OPC_EmitInteger32, 0, 
/* 22271*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22280*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22300
/* 22282*/      OPC_MoveParent,
/* 22283*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22285*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22286*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22288*/      OPC_EmitMergeInputChains1_0,
/* 22289*/      OPC_EmitInteger32, 0, 
/* 22291*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22300*/     0, // EndSwitchType
/* 22301*/    0, /*End of Scope*/
/* 22302*/   0, /*End of Scope*/
/* 22303*/  /*Scope*/ 20|128,1/*148*/, /*->22453*/
/* 22305*/   OPC_RecordChild0, // #0 = $x
/* 22306*/   OPC_Scope, 102, /*->22410*/ // 3 children in Scope
/* 22308*/    OPC_MoveChild0,
/* 22309*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22312*/    OPC_SwitchType /*2 cases */, 80, /*MVT::i32*/7, // ->22395
/* 22315*/     OPC_MoveParent,
/* 22316*/     OPC_SwitchType /*3 cases */, 37, /*MVT::v16i8*/39, // ->22356
/* 22319*/      OPC_EmitConvertToTarget0,
/* 22320*/      OPC_EmitConvertToTarget0,
/* 22321*/      OPC_EmitConvertToTarget0,
/* 22322*/      OPC_EmitConvertToTarget0,
/* 22323*/      OPC_EmitConvertToTarget0,
/* 22324*/      OPC_EmitConvertToTarget0,
/* 22325*/      OPC_EmitConvertToTarget0,
/* 22326*/      OPC_EmitConvertToTarget0,
/* 22327*/      OPC_EmitConvertToTarget0,
/* 22328*/      OPC_EmitConvertToTarget0,
/* 22329*/      OPC_EmitConvertToTarget0,
/* 22330*/      OPC_EmitConvertToTarget0,
/* 22331*/      OPC_EmitConvertToTarget0,
/* 22332*/      OPC_EmitConvertToTarget0,
/* 22333*/      OPC_EmitConvertToTarget0,
/* 22334*/      OPC_EmitConvertToTarget0,
/* 22335*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    /*MVT::v16i8*/39, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22356*/     /*SwitchType*/ 21, /*MVT::v8i16*/50, // ->22379
/* 22358*/      OPC_EmitConvertToTarget0,
/* 22359*/      OPC_EmitConvertToTarget0,
/* 22360*/      OPC_EmitConvertToTarget0,
/* 22361*/      OPC_EmitConvertToTarget0,
/* 22362*/      OPC_EmitConvertToTarget0,
/* 22363*/      OPC_EmitConvertToTarget0,
/* 22364*/      OPC_EmitConvertToTarget0,
/* 22365*/      OPC_EmitConvertToTarget0,
/* 22366*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    /*MVT::v8i16*/50, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22379*/     /*SwitchType*/ 13, /*MVT::v4i32*/60, // ->22394
/* 22381*/      OPC_EmitConvertToTarget0,
/* 22382*/      OPC_EmitConvertToTarget0,
/* 22383*/      OPC_EmitConvertToTarget0,
/* 22384*/      OPC_EmitConvertToTarget0,
/* 22385*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    /*MVT::v4i32*/60, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22394*/     0, // EndSwitchType
/* 22395*/    /*SwitchType*/ 12, /*MVT::i64*/8, // ->22409
/* 22397*/     OPC_MoveParent,
/* 22398*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22400*/     OPC_EmitConvertToTarget0,
/* 22401*/     OPC_EmitConvertToTarget0,
/* 22402*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 22409*/    0, // EndSwitchType
/* 22410*/   /*Scope*/ 30, /*->22441*/
/* 22411*/    OPC_CheckChild0TypeI32,
/* 22412*/    OPC_SwitchType /*3 cases */, 7, /*MVT::v16i8*/39, // ->22422
/* 22415*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 22422*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22431
/* 22424*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22425*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 22431*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->22440
/* 22433*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22434*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 22440*/    0, // EndSwitchType
/* 22441*/   /*Scope*/ 10, /*->22452*/
/* 22442*/    OPC_CheckChild0TypeI64,
/* 22443*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22445*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22446*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 22452*/   0, /*End of Scope*/
/* 22453*/  /*Scope*/ 107, /*->22561*/
/* 22454*/   OPC_MoveChild0,
/* 22455*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22458*/   OPC_RecordMemRef,
/* 22459*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22460*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22461*/   OPC_Scope, 48, /*->22511*/ // 2 children in Scope
/* 22463*/    OPC_CheckChild1TypeI32,
/* 22464*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22466*/    OPC_CheckPredicate6,  // Predicate_load
/* 22467*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22488
/* 22470*/     OPC_MoveParent,
/* 22471*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22473*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22474*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22476*/     OPC_EmitMergeInputChains1_0,
/* 22477*/     OPC_EmitInteger32, 0, 
/* 22479*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22488*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22510
/* 22490*/     OPC_MoveParent,
/* 22491*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22494*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22495*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22497*/     OPC_EmitMergeInputChains1_0,
/* 22498*/     OPC_EmitInteger32, 0, 
/* 22500*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22510*/    0, // EndSwitchType
/* 22511*/   /*Scope*/ 48, /*->22560*/
/* 22512*/    OPC_CheckChild1TypeI64,
/* 22513*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22515*/    OPC_CheckPredicate6,  // Predicate_load
/* 22516*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22537
/* 22519*/     OPC_MoveParent,
/* 22520*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22522*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22523*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22525*/     OPC_EmitMergeInputChains1_0,
/* 22526*/     OPC_EmitInteger32, 0, 
/* 22528*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22537*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22559
/* 22539*/     OPC_MoveParent,
/* 22540*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22543*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22544*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22546*/     OPC_EmitMergeInputChains1_0,
/* 22547*/     OPC_EmitInteger32, 0, 
/* 22549*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22559*/    0, // EndSwitchType
/* 22560*/   0, /*End of Scope*/
/* 22561*/  /*Scope*/ 70, /*->22632*/
/* 22562*/   OPC_RecordChild0, // #0 = $x
/* 22563*/   OPC_Scope, 40, /*->22605*/ // 3 children in Scope
/* 22565*/    OPC_MoveChild0,
/* 22566*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 22569*/    OPC_SwitchType /*2 cases */, 16, /*MVT::f32*/12, // ->22588
/* 22572*/     OPC_MoveParent,
/* 22573*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22575*/     OPC_EmitConvertToTarget0,
/* 22576*/     OPC_EmitConvertToTarget0,
/* 22577*/     OPC_EmitConvertToTarget0,
/* 22578*/     OPC_EmitConvertToTarget0,
/* 22579*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   /*MVT::v4f32*/110, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 22588*/    /*SwitchType*/ 14, /*MVT::f64*/13, // ->22604
/* 22590*/     OPC_MoveParent,
/* 22591*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22594*/     OPC_EmitConvertToTarget0,
/* 22595*/     OPC_EmitConvertToTarget0,
/* 22596*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 22604*/    0, // EndSwitchType
/* 22605*/   /*Scope*/ 11, /*->22617*/
/* 22606*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 22608*/    OPC_CheckType, /*MVT::v4f32*/110, 
/* 22610*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22611*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 22617*/   /*Scope*/ 13, /*->22631*/
/* 22618*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 22620*/    OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22623*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22624*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 22631*/   0, /*End of Scope*/
/* 22632*/  0, /*End of Scope*/
/* 22633*/ /*SwitchOpcode*/ 26|128,2/*282*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->22919
/* 22637*/  OPC_Scope, 103, /*->22742*/ // 4 children in Scope
/* 22639*/   OPC_MoveChild0,
/* 22640*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22643*/   OPC_RecordMemRef,
/* 22644*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22645*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22646*/   OPC_Scope, 46, /*->22694*/ // 2 children in Scope
/* 22648*/    OPC_CheckChild1TypeI32,
/* 22649*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22651*/    OPC_CheckPredicate6,  // Predicate_load
/* 22652*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22673
/* 22655*/     OPC_MoveParent,
/* 22656*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22658*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22659*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22661*/     OPC_EmitMergeInputChains1_0,
/* 22662*/     OPC_EmitInteger32, 0, 
/* 22664*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22673*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->22693
/* 22675*/     OPC_MoveParent,
/* 22676*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22678*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22679*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22681*/     OPC_EmitMergeInputChains1_0,
/* 22682*/     OPC_EmitInteger32, 0, 
/* 22684*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22693*/    0, // EndSwitchType
/* 22694*/   /*Scope*/ 46, /*->22741*/
/* 22695*/    OPC_CheckChild1TypeI64,
/* 22696*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22698*/    OPC_CheckPredicate6,  // Predicate_load
/* 22699*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22720
/* 22702*/     OPC_MoveParent,
/* 22703*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22705*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22706*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22708*/     OPC_EmitMergeInputChains1_0,
/* 22709*/     OPC_EmitInteger32, 0, 
/* 22711*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22720*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->22740
/* 22722*/     OPC_MoveParent,
/* 22723*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22725*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22726*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22728*/     OPC_EmitMergeInputChains1_0,
/* 22729*/     OPC_EmitInteger32, 0, 
/* 22731*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22740*/    0, // EndSwitchType
/* 22741*/   0, /*End of Scope*/
/* 22742*/  /*Scope*/ 41, /*->22784*/
/* 22743*/   OPC_RecordChild0, // #0 = $x
/* 22744*/   OPC_Scope, 27, /*->22773*/ // 2 children in Scope
/* 22746*/    OPC_CheckChild0TypeI32,
/* 22747*/    OPC_SwitchType /*3 cases */, 6, /*MVT::v16i8*/39, // ->22756
/* 22750*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 22756*/    /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->22764
/* 22758*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 22764*/    /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->22772
/* 22766*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 22772*/    0, // EndSwitchType
/* 22773*/   /*Scope*/ 9, /*->22783*/
/* 22774*/    OPC_CheckChild0TypeI64,
/* 22775*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22777*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 22783*/   0, /*End of Scope*/
/* 22784*/  /*Scope*/ 107, /*->22892*/
/* 22785*/   OPC_MoveChild0,
/* 22786*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22789*/   OPC_RecordMemRef,
/* 22790*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22791*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22792*/   OPC_Scope, 48, /*->22842*/ // 2 children in Scope
/* 22794*/    OPC_CheckChild1TypeI32,
/* 22795*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22797*/    OPC_CheckPredicate6,  // Predicate_load
/* 22798*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22819
/* 22801*/     OPC_MoveParent,
/* 22802*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22804*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22805*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22807*/     OPC_EmitMergeInputChains1_0,
/* 22808*/     OPC_EmitInteger32, 0, 
/* 22810*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22819*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22841
/* 22821*/     OPC_MoveParent,
/* 22822*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22825*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22826*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22828*/     OPC_EmitMergeInputChains1_0,
/* 22829*/     OPC_EmitInteger32, 0, 
/* 22831*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22841*/    0, // EndSwitchType
/* 22842*/   /*Scope*/ 48, /*->22891*/
/* 22843*/    OPC_CheckChild1TypeI64,
/* 22844*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22846*/    OPC_CheckPredicate6,  // Predicate_load
/* 22847*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22868
/* 22850*/     OPC_MoveParent,
/* 22851*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 22853*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22854*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22856*/     OPC_EmitMergeInputChains1_0,
/* 22857*/     OPC_EmitInteger32, 0, 
/* 22859*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/110, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22868*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22890
/* 22870*/     OPC_MoveParent,
/* 22871*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 22874*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22875*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22877*/     OPC_EmitMergeInputChains1_0,
/* 22878*/     OPC_EmitInteger32, 0, 
/* 22880*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22890*/    0, // EndSwitchType
/* 22891*/   0, /*End of Scope*/
/* 22892*/  /*Scope*/ 25, /*->22918*/
/* 22893*/   OPC_RecordChild0, // #0 = $x
/* 22894*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->22905
/* 22897*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 22899*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22905*/   /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->22917
/* 22908*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 22910*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 22917*/   0, // EndSwitchType
/* 22918*/  0, /*End of Scope*/
/* 22919*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->23055
/* 22923*/  OPC_RecordChild0, // #0 = $lhs
/* 22924*/  OPC_Scope, 84, /*->23010*/ // 2 children in Scope
/* 22926*/   OPC_MoveChild1,
/* 22927*/   OPC_Scope, 24, /*->22953*/ // 5 children in Scope
/* 22929*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22932*/    OPC_MoveChild0,
/* 22933*/    OPC_CheckAndImm, 63, 
/* 22935*/    OPC_RecordChild0, // #1 = $rhs
/* 22936*/    OPC_MoveParent,
/* 22937*/    OPC_MoveParent,
/* 22938*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22940*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 22946*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22953*/   /*Scope*/ 13, /*->22967*/
/* 22954*/    OPC_CheckAndImm, 7, 
/* 22956*/    OPC_RecordChild0, // #1 = $rhs
/* 22957*/    OPC_MoveParent,
/* 22958*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 22960*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22967*/   /*Scope*/ 13, /*->22981*/
/* 22968*/    OPC_CheckAndImm, 15, 
/* 22970*/    OPC_RecordChild0, // #1 = $rhs
/* 22971*/    OPC_MoveParent,
/* 22972*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 22974*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22981*/   /*Scope*/ 13, /*->22995*/
/* 22982*/    OPC_CheckAndImm, 31, 
/* 22984*/    OPC_RecordChild0, // #1 = $rhs
/* 22985*/    OPC_MoveParent,
/* 22986*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 22988*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22995*/   /*Scope*/ 13, /*->23009*/
/* 22996*/    OPC_CheckAndImm, 63, 
/* 22998*/    OPC_RecordChild0, // #1 = $rhs
/* 22999*/    OPC_MoveParent,
/* 23000*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23002*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23009*/   0, /*End of Scope*/
/* 23010*/  /*Scope*/ 43, /*->23054*/
/* 23011*/   OPC_RecordChild1, // #1 = $x
/* 23012*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23023
/* 23015*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23016*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23023*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23033
/* 23025*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23026*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23033*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23043
/* 23035*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23036*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23043*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23053
/* 23045*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23046*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23053*/   0, // EndSwitchType
/* 23054*/  0, /*End of Scope*/
/* 23055*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->23191
/* 23059*/  OPC_RecordChild0, // #0 = $lhs
/* 23060*/  OPC_Scope, 84, /*->23146*/ // 2 children in Scope
/* 23062*/   OPC_MoveChild1,
/* 23063*/   OPC_Scope, 24, /*->23089*/ // 5 children in Scope
/* 23065*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23068*/    OPC_MoveChild0,
/* 23069*/    OPC_CheckAndImm, 63, 
/* 23071*/    OPC_RecordChild0, // #1 = $rhs
/* 23072*/    OPC_MoveParent,
/* 23073*/    OPC_MoveParent,
/* 23074*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23076*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23082*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23089*/   /*Scope*/ 13, /*->23103*/
/* 23090*/    OPC_CheckAndImm, 7, 
/* 23092*/    OPC_RecordChild0, // #1 = $rhs
/* 23093*/    OPC_MoveParent,
/* 23094*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23096*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23103*/   /*Scope*/ 13, /*->23117*/
/* 23104*/    OPC_CheckAndImm, 15, 
/* 23106*/    OPC_RecordChild0, // #1 = $rhs
/* 23107*/    OPC_MoveParent,
/* 23108*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23110*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23117*/   /*Scope*/ 13, /*->23131*/
/* 23118*/    OPC_CheckAndImm, 31, 
/* 23120*/    OPC_RecordChild0, // #1 = $rhs
/* 23121*/    OPC_MoveParent,
/* 23122*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23124*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23131*/   /*Scope*/ 13, /*->23145*/
/* 23132*/    OPC_CheckAndImm, 63, 
/* 23134*/    OPC_RecordChild0, // #1 = $rhs
/* 23135*/    OPC_MoveParent,
/* 23136*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23138*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23145*/   0, /*End of Scope*/
/* 23146*/  /*Scope*/ 43, /*->23190*/
/* 23147*/   OPC_RecordChild1, // #1 = $x
/* 23148*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23159
/* 23151*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23152*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23159*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23169
/* 23161*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23162*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23169*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23179
/* 23171*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23172*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23179*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23189
/* 23181*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23182*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23189*/   0, // EndSwitchType
/* 23190*/  0, /*End of Scope*/
/* 23191*/ /*SwitchOpcode*/ 66|128,8/*1090*/, TARGET_VAL(ISD::VSELECT),// ->24285
/* 23195*/  OPC_Scope, 13|128,1/*141*/, /*->23339*/ // 4 children in Scope
/* 23198*/   OPC_MoveChild0,
/* 23199*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23202*/   OPC_MoveChild0,
/* 23203*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23206*/   OPC_RecordChild0, // #0 = $rhs
/* 23207*/   OPC_SwitchType /*3 cases */, 41, /*MVT::v4f32*/110, // ->23251
/* 23210*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23212*/    OPC_MoveSibling1,
/* 23213*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23216*/    OPC_RecordChild0, // #1 = $lhs
/* 23217*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23219*/    OPC_MoveParent,
/* 23220*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23222*/    OPC_MoveParent,
/* 23223*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23225*/    OPC_Scope, 11, /*->23238*/ // 2 children in Scope
/* 23227*/     OPC_CheckChild1Same, 0,
/* 23229*/     OPC_CheckChild2Same, 1,
/* 23231*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23238*/    /*Scope*/ 11, /*->23250*/
/* 23239*/     OPC_CheckChild1Same, 1,
/* 23241*/     OPC_CheckChild2Same, 0,
/* 23243*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23250*/    0, /*End of Scope*/
/* 23251*/   /*SwitchType*/ 41, /*MVT::v2f64*/0|128,1/*128*/, // ->23295
/* 23254*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23256*/    OPC_MoveSibling1,
/* 23257*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23260*/    OPC_RecordChild0, // #1 = $lhs
/* 23261*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23263*/    OPC_MoveParent,
/* 23264*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23266*/    OPC_MoveParent,
/* 23267*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23269*/    OPC_Scope, 11, /*->23282*/ // 2 children in Scope
/* 23271*/     OPC_CheckChild1Same, 0,
/* 23273*/     OPC_CheckChild2Same, 1,
/* 23275*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23282*/    /*Scope*/ 11, /*->23294*/
/* 23283*/     OPC_CheckChild1Same, 1,
/* 23285*/     OPC_CheckChild2Same, 0,
/* 23287*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23294*/    0, /*End of Scope*/
/* 23295*/   /*SwitchType*/ 41, /*MVT::v8f16*/92, // ->23338
/* 23297*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23299*/    OPC_MoveSibling1,
/* 23300*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23303*/    OPC_RecordChild0, // #1 = $lhs
/* 23304*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23306*/    OPC_MoveParent,
/* 23307*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23309*/    OPC_MoveParent,
/* 23310*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23312*/    OPC_Scope, 11, /*->23325*/ // 2 children in Scope
/* 23314*/     OPC_CheckChild1Same, 0,
/* 23316*/     OPC_CheckChild2Same, 1,
/* 23318*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23325*/    /*Scope*/ 11, /*->23337*/
/* 23326*/     OPC_CheckChild1Same, 1,
/* 23328*/     OPC_CheckChild2Same, 0,
/* 23330*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23337*/    0, /*End of Scope*/
/* 23338*/   0, // EndSwitchType
/* 23339*/  /*Scope*/ 45, /*->23385*/
/* 23340*/   OPC_RecordChild0, // #0 = $c
/* 23341*/   OPC_RecordChild1, // #1 = $v1
/* 23342*/   OPC_RecordChild2, // #2 = $v2
/* 23343*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23354
/* 23346*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23354*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23364
/* 23356*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23364*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23374
/* 23366*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23374*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23384
/* 23376*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23384*/   0, // EndSwitchType
/* 23385*/  /*Scope*/ 101|128,6/*869*/, /*->24256*/
/* 23387*/   OPC_MoveChild0,
/* 23388*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23391*/   OPC_RecordChild0, // #0 = $rhs
/* 23392*/   OPC_Scope, 21|128,2/*277*/, /*->23672*/ // 3 children in Scope
/* 23395*/    OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 23397*/    OPC_RecordChild1, // #1 = $lhs
/* 23398*/    OPC_Scope, 33, /*->23433*/ // 8 children in Scope
/* 23400*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23402*/     OPC_MoveParent,
/* 23403*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23405*/     OPC_Scope, 12, /*->23419*/ // 2 children in Scope
/* 23407*/      OPC_CheckChild1Same, 0,
/* 23409*/      OPC_CheckChild2Same, 1,
/* 23411*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23412*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23419*/     /*Scope*/ 12, /*->23432*/
/* 23420*/      OPC_CheckChild1Same, 1,
/* 23422*/      OPC_CheckChild2Same, 0,
/* 23424*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23425*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23432*/     0, /*End of Scope*/
/* 23433*/    /*Scope*/ 33, /*->23467*/
/* 23434*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23436*/     OPC_MoveParent,
/* 23437*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23439*/     OPC_Scope, 12, /*->23453*/ // 2 children in Scope
/* 23441*/      OPC_CheckChild1Same, 0,
/* 23443*/      OPC_CheckChild2Same, 1,
/* 23445*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23446*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23453*/     /*Scope*/ 12, /*->23466*/
/* 23454*/      OPC_CheckChild1Same, 1,
/* 23456*/      OPC_CheckChild2Same, 0,
/* 23458*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23459*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23466*/     0, /*End of Scope*/
/* 23467*/    /*Scope*/ 33, /*->23501*/
/* 23468*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23470*/     OPC_MoveParent,
/* 23471*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23473*/     OPC_Scope, 12, /*->23487*/ // 2 children in Scope
/* 23475*/      OPC_CheckChild1Same, 1,
/* 23477*/      OPC_CheckChild2Same, 0,
/* 23479*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23480*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23487*/     /*Scope*/ 12, /*->23500*/
/* 23488*/      OPC_CheckChild1Same, 0,
/* 23490*/      OPC_CheckChild2Same, 1,
/* 23492*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23493*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23500*/     0, /*End of Scope*/
/* 23501*/    /*Scope*/ 33, /*->23535*/
/* 23502*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23504*/     OPC_MoveParent,
/* 23505*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23507*/     OPC_Scope, 12, /*->23521*/ // 2 children in Scope
/* 23509*/      OPC_CheckChild1Same, 1,
/* 23511*/      OPC_CheckChild2Same, 0,
/* 23513*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23514*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23521*/     /*Scope*/ 12, /*->23534*/
/* 23522*/      OPC_CheckChild1Same, 0,
/* 23524*/      OPC_CheckChild2Same, 1,
/* 23526*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23527*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23534*/     0, /*End of Scope*/
/* 23535*/    /*Scope*/ 33, /*->23569*/
/* 23536*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23538*/     OPC_MoveParent,
/* 23539*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23541*/     OPC_Scope, 12, /*->23555*/ // 2 children in Scope
/* 23543*/      OPC_CheckChild1Same, 0,
/* 23545*/      OPC_CheckChild2Same, 1,
/* 23547*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23548*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23555*/     /*Scope*/ 12, /*->23568*/
/* 23556*/      OPC_CheckChild1Same, 1,
/* 23558*/      OPC_CheckChild2Same, 0,
/* 23560*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23561*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23568*/     0, /*End of Scope*/
/* 23569*/    /*Scope*/ 33, /*->23603*/
/* 23570*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23572*/     OPC_MoveParent,
/* 23573*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23575*/     OPC_Scope, 12, /*->23589*/ // 2 children in Scope
/* 23577*/      OPC_CheckChild1Same, 0,
/* 23579*/      OPC_CheckChild2Same, 1,
/* 23581*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23582*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23589*/     /*Scope*/ 12, /*->23602*/
/* 23590*/      OPC_CheckChild1Same, 1,
/* 23592*/      OPC_CheckChild2Same, 0,
/* 23594*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23595*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23602*/     0, /*End of Scope*/
/* 23603*/    /*Scope*/ 33, /*->23637*/
/* 23604*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 23606*/     OPC_MoveParent,
/* 23607*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23609*/     OPC_Scope, 12, /*->23623*/ // 2 children in Scope
/* 23611*/      OPC_CheckChild1Same, 1,
/* 23613*/      OPC_CheckChild2Same, 0,
/* 23615*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23616*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23623*/     /*Scope*/ 12, /*->23636*/
/* 23624*/      OPC_CheckChild1Same, 0,
/* 23626*/      OPC_CheckChild2Same, 1,
/* 23628*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23629*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23636*/     0, /*End of Scope*/
/* 23637*/    /*Scope*/ 33, /*->23671*/
/* 23638*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 23640*/     OPC_MoveParent,
/* 23641*/     OPC_CheckType, /*MVT::v4f32*/110, 
/* 23643*/     OPC_Scope, 12, /*->23657*/ // 2 children in Scope
/* 23645*/      OPC_CheckChild1Same, 1,
/* 23647*/      OPC_CheckChild2Same, 0,
/* 23649*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23650*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23657*/     /*Scope*/ 12, /*->23670*/
/* 23658*/      OPC_CheckChild1Same, 0,
/* 23660*/      OPC_CheckChild2Same, 1,
/* 23662*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23663*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/110, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23670*/     0, /*End of Scope*/
/* 23671*/    0, /*End of Scope*/
/* 23672*/   /*Scope*/ 46|128,2/*302*/, /*->23976*/
/* 23674*/    OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23677*/    OPC_RecordChild1, // #1 = $lhs
/* 23678*/    OPC_Scope, 36, /*->23716*/ // 8 children in Scope
/* 23680*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23682*/     OPC_MoveParent,
/* 23683*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23686*/     OPC_Scope, 13, /*->23701*/ // 2 children in Scope
/* 23688*/      OPC_CheckChild1Same, 0,
/* 23690*/      OPC_CheckChild2Same, 1,
/* 23692*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23693*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23701*/     /*Scope*/ 13, /*->23715*/
/* 23702*/      OPC_CheckChild1Same, 1,
/* 23704*/      OPC_CheckChild2Same, 0,
/* 23706*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23707*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23715*/     0, /*End of Scope*/
/* 23716*/    /*Scope*/ 36, /*->23753*/
/* 23717*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23719*/     OPC_MoveParent,
/* 23720*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23723*/     OPC_Scope, 13, /*->23738*/ // 2 children in Scope
/* 23725*/      OPC_CheckChild1Same, 0,
/* 23727*/      OPC_CheckChild2Same, 1,
/* 23729*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23730*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23738*/     /*Scope*/ 13, /*->23752*/
/* 23739*/      OPC_CheckChild1Same, 1,
/* 23741*/      OPC_CheckChild2Same, 0,
/* 23743*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23744*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23752*/     0, /*End of Scope*/
/* 23753*/    /*Scope*/ 36, /*->23790*/
/* 23754*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23756*/     OPC_MoveParent,
/* 23757*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23760*/     OPC_Scope, 13, /*->23775*/ // 2 children in Scope
/* 23762*/      OPC_CheckChild1Same, 1,
/* 23764*/      OPC_CheckChild2Same, 0,
/* 23766*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23767*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23775*/     /*Scope*/ 13, /*->23789*/
/* 23776*/      OPC_CheckChild1Same, 0,
/* 23778*/      OPC_CheckChild2Same, 1,
/* 23780*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23781*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23789*/     0, /*End of Scope*/
/* 23790*/    /*Scope*/ 36, /*->23827*/
/* 23791*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23793*/     OPC_MoveParent,
/* 23794*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23797*/     OPC_Scope, 13, /*->23812*/ // 2 children in Scope
/* 23799*/      OPC_CheckChild1Same, 1,
/* 23801*/      OPC_CheckChild2Same, 0,
/* 23803*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23804*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23812*/     /*Scope*/ 13, /*->23826*/
/* 23813*/      OPC_CheckChild1Same, 0,
/* 23815*/      OPC_CheckChild2Same, 1,
/* 23817*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23818*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23826*/     0, /*End of Scope*/
/* 23827*/    /*Scope*/ 36, /*->23864*/
/* 23828*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23830*/     OPC_MoveParent,
/* 23831*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23834*/     OPC_Scope, 13, /*->23849*/ // 2 children in Scope
/* 23836*/      OPC_CheckChild1Same, 0,
/* 23838*/      OPC_CheckChild2Same, 1,
/* 23840*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23841*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23849*/     /*Scope*/ 13, /*->23863*/
/* 23850*/      OPC_CheckChild1Same, 1,
/* 23852*/      OPC_CheckChild2Same, 0,
/* 23854*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23855*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23863*/     0, /*End of Scope*/
/* 23864*/    /*Scope*/ 36, /*->23901*/
/* 23865*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23867*/     OPC_MoveParent,
/* 23868*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23871*/     OPC_Scope, 13, /*->23886*/ // 2 children in Scope
/* 23873*/      OPC_CheckChild1Same, 0,
/* 23875*/      OPC_CheckChild2Same, 1,
/* 23877*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23886*/     /*Scope*/ 13, /*->23900*/
/* 23887*/      OPC_CheckChild1Same, 1,
/* 23889*/      OPC_CheckChild2Same, 0,
/* 23891*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23892*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23900*/     0, /*End of Scope*/
/* 23901*/    /*Scope*/ 36, /*->23938*/
/* 23902*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 23904*/     OPC_MoveParent,
/* 23905*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23908*/     OPC_Scope, 13, /*->23923*/ // 2 children in Scope
/* 23910*/      OPC_CheckChild1Same, 1,
/* 23912*/      OPC_CheckChild2Same, 0,
/* 23914*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23915*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23923*/     /*Scope*/ 13, /*->23937*/
/* 23924*/      OPC_CheckChild1Same, 0,
/* 23926*/      OPC_CheckChild2Same, 1,
/* 23928*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23929*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23937*/     0, /*End of Scope*/
/* 23938*/    /*Scope*/ 36, /*->23975*/
/* 23939*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 23941*/     OPC_MoveParent,
/* 23942*/     OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 23945*/     OPC_Scope, 13, /*->23960*/ // 2 children in Scope
/* 23947*/      OPC_CheckChild1Same, 1,
/* 23949*/      OPC_CheckChild2Same, 0,
/* 23951*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23952*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23960*/     /*Scope*/ 13, /*->23974*/
/* 23961*/      OPC_CheckChild1Same, 0,
/* 23963*/      OPC_CheckChild2Same, 1,
/* 23965*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23966*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/0|128,1/*128*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23974*/     0, /*End of Scope*/
/* 23975*/    0, /*End of Scope*/
/* 23976*/   /*Scope*/ 21|128,2/*277*/, /*->24255*/
/* 23978*/    OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 23980*/    OPC_RecordChild1, // #1 = $lhs
/* 23981*/    OPC_Scope, 33, /*->24016*/ // 8 children in Scope
/* 23983*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23985*/     OPC_MoveParent,
/* 23986*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 23988*/     OPC_Scope, 12, /*->24002*/ // 2 children in Scope
/* 23990*/      OPC_CheckChild1Same, 0,
/* 23992*/      OPC_CheckChild2Same, 1,
/* 23994*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 23995*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24002*/     /*Scope*/ 12, /*->24015*/
/* 24003*/      OPC_CheckChild1Same, 1,
/* 24005*/      OPC_CheckChild2Same, 0,
/* 24007*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24008*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24015*/     0, /*End of Scope*/
/* 24016*/    /*Scope*/ 33, /*->24050*/
/* 24017*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24019*/     OPC_MoveParent,
/* 24020*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24022*/     OPC_Scope, 12, /*->24036*/ // 2 children in Scope
/* 24024*/      OPC_CheckChild1Same, 0,
/* 24026*/      OPC_CheckChild2Same, 1,
/* 24028*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24029*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24036*/     /*Scope*/ 12, /*->24049*/
/* 24037*/      OPC_CheckChild1Same, 1,
/* 24039*/      OPC_CheckChild2Same, 0,
/* 24041*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24042*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24049*/     0, /*End of Scope*/
/* 24050*/    /*Scope*/ 33, /*->24084*/
/* 24051*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24053*/     OPC_MoveParent,
/* 24054*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24056*/     OPC_Scope, 12, /*->24070*/ // 2 children in Scope
/* 24058*/      OPC_CheckChild1Same, 1,
/* 24060*/      OPC_CheckChild2Same, 0,
/* 24062*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24063*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24070*/     /*Scope*/ 12, /*->24083*/
/* 24071*/      OPC_CheckChild1Same, 0,
/* 24073*/      OPC_CheckChild2Same, 1,
/* 24075*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24076*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24083*/     0, /*End of Scope*/
/* 24084*/    /*Scope*/ 33, /*->24118*/
/* 24085*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24087*/     OPC_MoveParent,
/* 24088*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24090*/     OPC_Scope, 12, /*->24104*/ // 2 children in Scope
/* 24092*/      OPC_CheckChild1Same, 1,
/* 24094*/      OPC_CheckChild2Same, 0,
/* 24096*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24097*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24104*/     /*Scope*/ 12, /*->24117*/
/* 24105*/      OPC_CheckChild1Same, 0,
/* 24107*/      OPC_CheckChild2Same, 1,
/* 24109*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24110*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24117*/     0, /*End of Scope*/
/* 24118*/    /*Scope*/ 33, /*->24152*/
/* 24119*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24121*/     OPC_MoveParent,
/* 24122*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24124*/     OPC_Scope, 12, /*->24138*/ // 2 children in Scope
/* 24126*/      OPC_CheckChild1Same, 0,
/* 24128*/      OPC_CheckChild2Same, 1,
/* 24130*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24131*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24138*/     /*Scope*/ 12, /*->24151*/
/* 24139*/      OPC_CheckChild1Same, 1,
/* 24141*/      OPC_CheckChild2Same, 0,
/* 24143*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24144*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24151*/     0, /*End of Scope*/
/* 24152*/    /*Scope*/ 33, /*->24186*/
/* 24153*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24155*/     OPC_MoveParent,
/* 24156*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24158*/     OPC_Scope, 12, /*->24172*/ // 2 children in Scope
/* 24160*/      OPC_CheckChild1Same, 0,
/* 24162*/      OPC_CheckChild2Same, 1,
/* 24164*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24165*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24172*/     /*Scope*/ 12, /*->24185*/
/* 24173*/      OPC_CheckChild1Same, 1,
/* 24175*/      OPC_CheckChild2Same, 0,
/* 24177*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24178*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24185*/     0, /*End of Scope*/
/* 24186*/    /*Scope*/ 33, /*->24220*/
/* 24187*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24189*/     OPC_MoveParent,
/* 24190*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24192*/     OPC_Scope, 12, /*->24206*/ // 2 children in Scope
/* 24194*/      OPC_CheckChild1Same, 1,
/* 24196*/      OPC_CheckChild2Same, 0,
/* 24198*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24199*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24206*/     /*Scope*/ 12, /*->24219*/
/* 24207*/      OPC_CheckChild1Same, 0,
/* 24209*/      OPC_CheckChild2Same, 1,
/* 24211*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24212*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24219*/     0, /*End of Scope*/
/* 24220*/    /*Scope*/ 33, /*->24254*/
/* 24221*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24223*/     OPC_MoveParent,
/* 24224*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24226*/     OPC_Scope, 12, /*->24240*/ // 2 children in Scope
/* 24228*/      OPC_CheckChild1Same, 1,
/* 24230*/      OPC_CheckChild2Same, 0,
/* 24232*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24233*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24240*/     /*Scope*/ 12, /*->24253*/
/* 24241*/      OPC_CheckChild1Same, 0,
/* 24243*/      OPC_CheckChild2Same, 1,
/* 24245*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24246*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24253*/     0, /*End of Scope*/
/* 24254*/    0, /*End of Scope*/
/* 24255*/   0, /*End of Scope*/
/* 24256*/  /*Scope*/ 27, /*->24284*/
/* 24257*/   OPC_RecordChild0, // #0 = $c
/* 24258*/   OPC_RecordChild1, // #1 = $v1
/* 24259*/   OPC_RecordChild2, // #2 = $v2
/* 24260*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/110, // ->24271
/* 24263*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/110, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 24271*/   /*SwitchType*/ 9, /*MVT::v2f64*/0|128,1/*128*/, // ->24283
/* 24274*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/0|128,1/*128*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 24283*/   0, // EndSwitchType
/* 24284*/  0, /*End of Scope*/
/* 24285*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->24304
/* 24288*/  OPC_RecordChild0, // #0 = $src
/* 24289*/  OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24291*/  OPC_RecordChild1, // #1 = $mask
/* 24292*/  OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 24294*/  OPC_CheckType, /*MVT::v16i8*/39, 
/* 24296*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24297*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 24304*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->24346
/* 24307*/  OPC_RecordChild0, // #0 = $v
/* 24308*/  OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->24318
/* 24311*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24312*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 24318*/  /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->24327
/* 24320*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24321*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 24327*/  /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->24336
/* 24329*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24330*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 24336*/  /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->24345
/* 24338*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24339*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 24345*/  0, // EndSwitchType
/* 24346*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->24373
/* 24349*/  OPC_RecordChild0, // #0 = $lhs
/* 24350*/  OPC_RecordChild1, // #1 = $rhs
/* 24351*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24362
/* 24354*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24355*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24362*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24372
/* 24364*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24365*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24372*/  0, // EndSwitchType
/* 24373*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->24400
/* 24376*/  OPC_RecordChild0, // #0 = $lhs
/* 24377*/  OPC_RecordChild1, // #1 = $rhs
/* 24378*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24389
/* 24381*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24382*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24389*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24399
/* 24391*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24392*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24399*/  0, // EndSwitchType
/* 24400*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->24437
/* 24403*/  OPC_RecordChild0, // #0 = $lhs
/* 24404*/  OPC_RecordChild1, // #1 = $rhs
/* 24405*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24416
/* 24408*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24409*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24416*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24426
/* 24418*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24419*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24426*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24436
/* 24428*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24429*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24436*/  0, // EndSwitchType
/* 24437*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->24474
/* 24440*/  OPC_RecordChild0, // #0 = $lhs
/* 24441*/  OPC_RecordChild1, // #1 = $rhs
/* 24442*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24453
/* 24445*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24446*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24453*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24463
/* 24455*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24456*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24463*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24473
/* 24465*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24466*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24473*/  0, // EndSwitchType
/* 24474*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->24511
/* 24477*/  OPC_RecordChild0, // #0 = $lhs
/* 24478*/  OPC_RecordChild1, // #1 = $rhs
/* 24479*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24490
/* 24482*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24483*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24490*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24500
/* 24492*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24493*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24500*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24510
/* 24502*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24503*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24510*/  0, // EndSwitchType
/* 24511*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->24548
/* 24514*/  OPC_RecordChild0, // #0 = $lhs
/* 24515*/  OPC_RecordChild1, // #1 = $rhs
/* 24516*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24527
/* 24519*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24520*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24527*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24537
/* 24529*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24530*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24537*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24547
/* 24539*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24540*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24547*/  0, // EndSwitchType
/* 24548*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->24564
/* 24551*/  OPC_RecordChild0, // #0 = $vec
/* 24552*/  OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24555*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 24557*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24558*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24564*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->24580
/* 24567*/  OPC_RecordChild0, // #0 = $vec
/* 24568*/  OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24571*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 24573*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24574*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24580*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->24619
/* 24583*/  OPC_RecordChild0, // #0 = $vec
/* 24584*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24596
/* 24587*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24589*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24590*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24596*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24607
/* 24598*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24600*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24601*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24607*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24618
/* 24609*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24611*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24612*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24618*/  0, // EndSwitchType
/* 24619*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->24658
/* 24622*/  OPC_RecordChild0, // #0 = $vec
/* 24623*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24635
/* 24626*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24628*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24629*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24635*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24646
/* 24637*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24639*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24640*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24646*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24657
/* 24648*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24650*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24651*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24657*/  0, // EndSwitchType
/* 24658*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->24697
/* 24661*/  OPC_RecordChild0, // #0 = $vec
/* 24662*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24674
/* 24665*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24667*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24668*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24674*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24685
/* 24676*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24678*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24679*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24685*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24696
/* 24687*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24689*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24690*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24696*/  0, // EndSwitchType
/* 24697*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->24736
/* 24700*/  OPC_RecordChild0, // #0 = $vec
/* 24701*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24713
/* 24704*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24706*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24707*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24713*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24724
/* 24715*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24717*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24718*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24724*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24735
/* 24726*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24728*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24729*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24735*/  0, // EndSwitchType
/* 24736*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->24770
/* 24739*/  OPC_RecordChild0, // #0 = $left
/* 24740*/  OPC_SwitchType /*2 cases */, 12, /*MVT::v16i8*/39, // ->24755
/* 24743*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24745*/   OPC_RecordChild1, // #1 = $right
/* 24746*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 24748*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 24755*/  /*SwitchType*/ 12, /*MVT::v8i16*/50, // ->24769
/* 24757*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24759*/   OPC_RecordChild1, // #1 = $right
/* 24760*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 24762*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 24769*/  0, // EndSwitchType
/* 24770*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->24787
/* 24773*/  OPC_RecordChild0, // #0 = $vec
/* 24774*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24776*/  OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24779*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24780*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24787*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->24804
/* 24790*/  OPC_RecordChild0, // #0 = $vec
/* 24791*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24793*/  OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24796*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24797*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24804*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->24820
/* 24807*/  OPC_RecordChild0, // #0 = $vec
/* 24808*/  OPC_CheckChild0Type, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24811*/  OPC_CheckType, /*MVT::v4f32*/110, 
/* 24813*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24814*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                /*MVT::v4f32*/110, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 24820*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->24837
/* 24823*/  OPC_RecordChild0, // #0 = $vec
/* 24824*/  OPC_CheckChild0Type, /*MVT::v4f32*/110, 
/* 24826*/  OPC_CheckType, /*MVT::v2f64*/0|128,1/*128*/, 
/* 24829*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24830*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                /*MVT::v2f64*/0|128,1/*128*/, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 24837*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 24839 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 359
  // #OPC_RecordNode                           = 299
  // #OPC_RecordChild                          = 747
  // #OPC_RecordMemRef                         = 43
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 297
  // #OPC_MoveSibling                          = 297
  // #OPC_MoveParent                           = 611
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 195
  // #OPC_CheckPatternPredicate                = 758
  // #OPC_CheckPredicate                       = 553
  // #OPC_CheckOpcode                          = 518
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 566
  // #OPC_SwitchType                           = 184
  // #OPC_CheckChildType                       = 461
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 108
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 165
  // #OPC_CheckValueType                       = 17
  // #OPC_CheckComplexPat                      = 326
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 6
  // #OPC_EmitInteger                          = 377
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 324
  // #OPC_EmitMergeInputChains                 = 448
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 44
  // #OPC_MorphNodeTo                          = 1258

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64());
  case 2: return (Subtarget->hasAddr64());
  case 3: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 4: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 5: return (Subtarget->hasFP16()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasExceptionHandling());
  case 17: return (Subtarget->hasFP16());
  case 18: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 7: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 9: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 12: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 13: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 14: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 15: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 16: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 18: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
